****************************************
***      TuComposer Library v1.0     ***
***   1996-98 by The united Coders  ***
***               (TuC)              ***
***        Main code: Basty/TuC      ***
***   This is the support library    ***
***    of TuComposer, giving you     ***
***  all important functions which   ***
***  should be needed in compose.    ***
***    Yes ! Coders only need to     ***
***    code an interface. The lib    ***
***    does the rest for you !!!     ***
****************************************

	IFND	_G2
	MACHINE	MC68020
	ENDC

	include	"exec/types.i"
	include	"exec/libraries.i"
	include	"exec/exec_lib.i"
	include	"intuition/intuition_lib.i"
	include	"intuition/intuition.i"
	include	"graphics/graphics_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/player.i"

	moveq	#31,d0
	lea	TuCName(pc),a1
	move.l	4.w,a6
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,d1
	beq	TuCLibError
	move.l	d1,a3
	lea	IntName(pc),a1
	jsr	_LVOOldOpenLibrary(a6)
	move.l	d0,a4
	lea	GfxName(pc),a1
	jsr	_LVOOldOpenLibrary(a6)
	move.l	d0,a5
	sub.l	a1,a1
	jsr	_LVOFindTask(a6)
	move.l	d0,CurrentTask
	moveq	#-1,d0
	jsr	_LVOAllocSignal(a6)
	move.b	d0,SigBit
	lea	NewWin(pc),a0
	move.l	a4,a6
	jsr	_LVOOpenWindow(a6)
	move.l	d0,d1
	beq	OpenWinError
	move.l	d1,a2
	lea	AddPlayHandler(pc),a0
	move.l	a3,a6
	jsr	_LVOAddPlayExecHandler(a6)
	moveq	#1,d0
	move.l	wd_RPort(a2),a1
	move.l	a5,a6
	jsr	_LVOSetAPen(a6)
	moveq	#6,d0
	moveq	#18,d1
	move.l	wd_RPort(a2),a1
	jsr	_LVOMove(a6)
	moveq	#76,d0
	lea	HeaderInfo(pc),a0
	move.l	wd_RPort(a2),a1
	jsr	_LVOText(a6)
Loop:	moveq	#24-1,d2
	moveq	#26,d3
	moveq	#0,d0
	move.b	SigBit(pc),d1
	bset	d1,d0
	move.l	wd_UserPort(a2),a0
	move.b	MP_SIGBIT(a0),d4
	bset	d4,d0
	move.l	4.w,a6
	jsr	_LVOWait(a6)
	moveq	#0,d1
	bset	d4,d1
	and.l	d0,d1
	beq	NotIDCMPEvent
GetMsgLoop:	move.l	wd_UserPort(a2),a0
	jsr	_LVOGetMsg(a6)
	move.l	d0,d1
	beq	NotIDCMPEvent
	move.l	d1,a1
	move.l	im_Class(a1),d5
	movem.w	im_Code(a1),d6-d7
	jsr	_LVOReplyMsg(a6)
	cmp.l	#IDCMP_REFRESHWINDOW,d5
	bne.s	NotRefreshWindow
	moveq	#6,d0
	moveq	#18,d1
	move.l	wd_RPort(a2),a1
	move.l	a5,a6
	jsr	_LVOMove(a6)
	moveq	#76,d0
	lea	HeaderInfo(pc),a0
	move.l	wd_RPort(a2),a1
	jsr	_LVOText(a6)
	move.l	4.w,a6
	bra.s	GetMsgLoop
NotRefreshWindow:	cmp.l	#IDCMP_VANILLAKEY,d5
	bne.s	NotVanillaEvent
	cmp.w	#27,d6
	beq	LoopDone
	cmp.w	#3,d6
	beq	LoopDone
	cmp.w	#" ",d6
	beq	LoopDone
	bra.s	GetMsgLoop
NotVanillaEvent:	cmp.l	#IDCMP_RAWKEY,d5
	bne.s	GetMsgLoop
	cmp.w	#$4c,d6
	beq.s	MoveUp
	cmp.w	#$4d,d6
	beq.s	MoveDown
	bra.s	GetMsgLoop
MoveUp:	and.w	#3,d7
	beq.s	MoveUpNormal
	move.w	StartCount(pc),d0
	sub.w	#24,d0
	bcc.s	MoveUpFastOk
	moveq	#0,d0
MoveUpFastOk:	move.w	d0,StartCount
	bra	GetMsgLoop
MoveUpNormal:	tst.w	StartCount
	beq	GetMsgLoop
	subq.w	#1,StartCount
	bra	GetMsgLoop
MoveDown:	move.w	StartCount(pc),d0
	addq.w	#1,d0
	and.w	#3,d7
	beq.s	MoveDownNormal
	add.w	#24-1,d0
MoveDownNormal:	move.l	tcb_PlaySong(a3),a0
	move.w	tcso_Channels(a0),d1
	sub.w	#24,d1
	bcc.s	MoveDownOk
	moveq	#0,d1
MoveDownOk:	cmp.w	d1,d0
	blo.s	MoveDownOk2
	move.w	d1,d0
MoveDownOk2:	move.w	d0,StartCount
	bra	GetMsgLoop
NotIDCMPEvent:	moveq	#0,d4
	tst.b	NewModule
	beq	LoopText
	lea	WinTitle(pc),a1
	tst.l	tcb_PlayModule(a3)
	beq	NotPlayingNewModule
	move.l	tcb_PlayModule(a3),Module
	move.l	tcb_PlaySong(a3),Song
LoopText:	moveq	#6,d0
	move.l	d3,d1
	move.l	wd_RPort(a2),a1
	move.l	a5,a6
	jsr	_LVOMove(a6)
	moveq	#76,d0
	lea	Display00(pc),a0
	add.l	d4,a0
	add.l	d0,d4
	move.l	wd_RPort(a2),a1
	jsr	_LVOText(a6)
	addq.l	#8,d3
	dbra	d2,LoopText
	move.l	a2,d7
	lea	WinTitle(pc),a1
	tst.l	tcb_PlayModule(a3)
	beq	NotPlayingNewModule
	lea	WinTitleBuf(pc),a1
	move.l	#"Play",(a1)+
	move.l	#"ing ",(a1)+
	move.l	#"now ",(a1)+
	move.l	#"TuCo",(a1)+
	move.l	#"mpos",(a1)+
	move.l	#"er M",(a1)+
	move.l	#"odul",(a1)+
	move.w	#"e ",(a1)+
	move.l	tcb_PlaySong(a3),a2
	move.l	tcso_Name(a2),a2
CopyNameLoop:	move.b	(a2)+,(a1)+
	bne.s	CopyNameLoop
	subq.l	#1,a1
	move.w	#" (",(a1)+
	move.l	tcb_PlaySong(a3),a2
	move.l	tcso_GlobalData(a2),a2
	move.l	pg_PlayTime(a2),d2
	move.l	d2,d0
	divu.l	#100*60*60,d0
	divu.w	#10,d0
	tst.b	d0
	beq.s	Not2DigitHoursPlay
	add.b	#"0",d0
	move.b	d0,(a1)+
Not2DigitHoursPlay:	swap	d0
	add.b	#"0",d0
	move.b	d0,(a1)+
	move.b	#":",(a1)+
	move.l	#$00300030,d1
	move.l	d2,d0
	divu.l	#100*60,d0
	divu.w	#60,d0
	swap	d0
	ext.l	d0
	divu.w	#10,d0
	add.l	d1,d0
	move.b	d0,(a1)+
	swap	d0
	move.b	d0,(a1)+
	move.b	#":",(a1)+
	move.l	d2,d0
	divu.l	#100,d0
	divu.w	#60,d0
	swap	d0
	ext.l	d0
	divu.w	#10,d0
	add.l	d1,d0
	move.b	d0,(a1)+
	swap	d0
	move.b	d0,(a1)+
	move.b	#".",(a1)+
	moveq	#0,d3
	divu.l	#100,d3:d2
	divu.w	#10,d3
	add.l	d1,d3
	move.b	d3,(a1)+
	swap	d3
	move.b	d3,(a1)+
	move.l	tcb_PlaySong(a3),a2
	tst.l	tcso_PlayTimeHours(a2)
	beq.s	NoPlayingTime
	move.b	#"/",(a1)+
	moveq	#0,d0
	move.b	tcso_PlayTimeHours(a2),d0
	divu.w	#10,d0
	tst.b	d0
	beq.s	Not2DigitHours
	add.b	#"0",d0
	move.b	d0,(a1)+
Not2DigitHours:	swap	d0
	add.b	#"0",d0
	move.b	d0,(a1)+
	move.b	#":",(a1)+
	moveq	#0,d0
	move.b	tcso_PlayTimeMins(a2),d0
	divu.w	#10,d0
	or.l	d1,d0
	move.b	d0,(a1)+
	swap	d0
	move.b	d0,(a1)+
	move.b	#":",(a1)+
	moveq	#0,d0
	move.b	tcso_PlayTimeSecs(a2),d0
	divu.w	#10,d0
	or.l	d1,d0
	move.b	d0,(a1)+
	swap	d0
	move.b	d0,(a1)+
	move.b	#".",(a1)+
	moveq	#0,d0
	move.b	tcso_PlayTimeHundreds(a2),d0
	divu.w	#10,d0
	or.l	d1,d0
	move.b	d0,(a1)+
	swap	d0
	move.b	d0,(a1)+
NoPlayingTime:	move.l	#")...",(a1)+
	clr.b	(a1)
	lea	WinTitleBuf(pc),a1
NotPlayingNewModule:	move.l	d7,a0
	sub.l	a2,a2
	move.l	a4,a6
	jsr	_LVOSetWindowTitles(a6)
	move.l	d7,a2
	clr.b	Displayed
	bra	Loop
LoopDone:	lea	AddPlayHandler(pc),a0
	move.l	a3,a6
	jsr	_LVORemPlayExecHandler(a6)
	move.l	a2,a0
	move.l	a4,a6
	jsr	_LVOCloseWindow(a6)
OpenWinError:	moveq	#0,d0
	move.b	SigBit(pc),d0
	move.l	4.w,a6
	jsr	_LVOFreeSignal(a6)
	move.l	a5,a1
	jsr	_LVOCloseLibrary(a6)
	move.l	a4,a1
	jsr	_LVOCloseLibrary(a6)
	move.l	a3,a1
	jsr	_LVOCloseLibrary(a6)
TuCLibError:	moveq	#0,d0
PlayExecDone:	rts
PlayExecEmpty:	move.b	NewModule(pc),d0
	beq.s	PlayExecDone
	moveq	#24-1,d0
ClrDisplayLoop:	clr.b	(a1)
	lea	Display01-Display00(a1),a1
	dbra	d0,ClrDisplayLoop
	rts
PlayExecCode:	move.b	Displayed(pc),d0
	bne.s	PlayExecDone
	st	Displayed
	move.l	tcb_PlayModule(a6),a0
	cmp.l	Module(pc),a0
	sne	NewModule
	lea	Display00(pc),a1
	move.l	a0,d0
	beq.s	PlayExecEmpty
	move.l	tcb_PlaySong(a6),a0
	cmp.l	Song(pc),a0
	sne	NewModule
	move.l	a0,d0
	beq.s	PlayExecEmpty
	movem.l	d2-d7/a2-a6,-(sp)
	moveq	#0,d2
	move.w	StartCount(pc),d2
	moveq	#24-1,d3
	move.w	tcso_Channels(a0),d4
	moveq	#10,d5
	move.l	#"    ",d6
	move.l	tcso_ChannelData(a0),a0
	move.w	d2,d0
	mulu.w	#phc_SIZEOF,d0
	add.l	d0,a0
	move.l	tcb_PlayModule(a6),a2
	move.l	tcm_ChannelData(a2),a2
	lea	48.w,a3
ChannelLoop:	cmp.w	d4,d2
	bhs	ChannelDone
	move.l	d2,d0
	addq.l	#1,d0
	moveq	#3,d1
	bsr	Dec2Str
	addq.l	#1,a1
	move.w	phc_VirtualChannel(a0),d0
	mulu.w	#pc_SIZEOF,d0
	move.l	a2,a6
	add.l	d0,a6
	btst	#MSB_Play,ms_Flags(a6)
	beq	ChannelDisabled
	cmp.w	pc_HostChannel(a6),d2
	bne	ChannelDisabled
	move.l	pc_Frequency(a6),d0
	moveq	#9,d1
	bsr	Dec2Str
	addq.l	#1,a1
	move.l	(a6),d0
	moveq	#8,d1
	bsr	Dec2Str
	addq.l	#1,a1
	moveq	#0,d0
	move.w	phc_VirtualChannel(a0),d0
	moveq	#3,d1
	bsr	Dec2Str
	addq.l	#2,a1
	move.w	phc_Row(a0),d0
	moveq	#$f,d1
	bsr	Hex4Str
	addq.l	#1,a1
	move.l	phc_TempoCounter(a0),d0
	bsr	Hex4Str
	addq.l	#1,a1
	move.w	phc_Tempo(a0),d0
	bsr	Hex2Str
	addq.l	#1,a1
	moveq	#0,d0
	move.b	pc_FinalVolume(a6),d0
	moveq	#3,d1
	bsr	Dec2Str
	addq.l	#1,a1
	move.b	pc_Volume(a6),d0
	moveq	#$f,d1
	bsr	Hex2Str
	addq.l	#1,a1
	move.b	phc_TrackVolume(a0),d0
	bsr	Hex2Str
	addq.l	#1,a1
	move.w	pc_InstrVolume(a6),d0
	divu.w	#255,d0
	bsr.s	Hex2Str
	addq.l	#1,a1
	move.b	pc_VolEnvelope+pes_EnvelopeValue(a6),d0
	bsr.s	Hex2Str
	addq.l	#1,a1
	move.w	pc_FadeOutCount(a6),d0
	bsr	Hex4Str
	addq.l	#1,a1
	btst	#PCB_Surround,pc_Flags+1(a6)
	beq.s	NoSurround
	move.w	#"Su",(a1)
	addq.l	#2+1,a1
	bra.s	EvalPanEnv
NoSurround:	move.b	pc_FinalPanning(a6),d0
	bsr.s	Hex2Str
	addq.l	#1,a1
EvalPanEnv:	move.b	pc_PanEnvelope+pes_EnvelopeValue(a6),d0
	add.b	#$80,d0
	bsr.s	Hex2Str
	addq.l	#2,a1
	moveq	#0,d0
	move.b	phc_NNA(a0),d0
	move.l	NNA(pc,d0.w*4),(a1)+
	move.w	phc_NumVirtual(a0),d0
	moveq	#3,d1
	bsr.s	Dec2Str
	addq.l	#1,d2
	lea	phc_SIZEOF(a0),a0
	dbra	d3,ChannelLoop
	moveq	#0,d0
	move.b	SigBit(pc),d1
	bset	d1,d0
	move.l	CurrentTask(pc),a1
	move.l	4.w,a6
	jsr	_LVOSignal(a6)
	movem.l	(sp)+,d2-d7/a2-a6
	rts
NNA:	dc.b	'Cut '
	dc.b	'Con '
	dc.b	'Off '
	dc.b	'Fde '
Hex2Str:	addq.l	#2,a1
	move.l	a1,a4
	move.w	d0,d7
	and.w	d1,d7
	move.b	HexTab(pc,d7.w),-(a4)
	lsr.w	#4,d0
	and.w	d1,d0
	move.b	HexTab(pc,d0.w),-(a4)
	rts
Dec2Str:	add.l	d1,a1
	subq.l	#1,d1
	move.l	d1,a5
	move.l	a1,a4
ConvDec2Str:	divul.l	d5,d7:d0
	add.w	a3,d7
	move.b	d7,-(a4)
	dbra	d1,ConvDec2Str
	move.l	a5,d1
	subq.l	#1,d1
	move.l	a3,d7
TrimStr:	cmp.b	(a4),d7
	bne.s	TrimDone
	move.b	d6,(a4)+
	dbra	d1,TrimStr
TrimDone:	rts
Hex4Str:	addq.l	#4,a1
	move.l	a1,a4
	move.w	d0,d7
	and.w	d1,d7
	move.b	HexTab(pc,d7.w),-(a4)
	lsr.w	#4,d0
	move.w	d0,d7
	and.w	d1,d7
	move.b	HexTab(pc,d7.w),-(a4)
	lsr.w	#4,d0
	move.w	d0,d7
	and.w	d1,d7
	move.b	HexTab(pc,d7.w),-(a4)
	lsr.w	#4,d0
	and.w	d1,d0
	move.b	HexTab(pc,d0.w),-(a4)
	rts
HexTab:	dc.b	'0123456789ABCDEF'
ChannelDisabled:	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.w	phc_Row(a0),d0
	moveq	#$f,d1
	bsr.s	Hex4Str
	addq.l	#1,a1
	move.l	phc_TempoCounter(a0),d0
	bsr.s	Hex4Str
	addq.l	#1,a1
	move.w	phc_Tempo(a0),d0
	bsr	Hex2Str
	addq.l	#1,a1
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	#"--- ",(a1)+
	move.w	phc_NumVirtual(a0),d0
	moveq	#3,d1
	bsr	Dec2Str
	addq.l	#1,d2
	lea	phc_SIZEOF(a0),a0
	dbra	d3,ChannelLoop
	moveq	#0,d0
	move.b	SigBit(pc),d1
	bset	d1,d0
	move.l	CurrentTask(pc),a1
	move.l	4.w,a6
	jsr	_LVOSignal(a6)
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ChannelDone:	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	move.l	d6,(a1)+
	addq.l	#1,d2
	lea	phc_SIZEOF(a0),a0
	dbra	d3,ChannelLoop
	moveq	#0,d0
	move.b	SigBit(pc),d1
	bset	d1,d0
	move.l	CurrentTask(pc),a1
	move.l	4.w,a6
	jsr	_LVOSignal(a6)
	movem.l	(sp)+,d2-d7/a2-a6
	rts
Module:	dc.l	0
Song:	dc.l	0
CurrentTask:	dc.l	0
AddPlayHandler:	ds.l	2
	dc.b	0
	dc.b	-128
	dc.l	PlayExecCode
	dc.b	-1
	dc.b	0
	dc.l	0
	ds.b	10
NewWin:	dc.w	0,1,640,255
	dc.b	0,1
	dc.l	IDCMP_REFRESHWINDOW|IDCMP_RAWKEY|IDCMP_VANILLAKEY
	dc.l	WFLG_SIZEGADGET|WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_SIMPLE_REFRESH|WFLG_ACTIVATE
	dc.l	0
	dc.l	0
	dc.l	WinTitle
	dc.l	0
	dc.l	0
	dc.w	128,64,640,256
	dc.w	1
HeaderInfo: dc.b	' Ch Frequency Position VCh  Row  Tick Tm FVl Vl CV SV VE Fade Pn PE  NNA Tot'
Display00:	dc.b	'                                                                            '
Display01:	dc.b	'                                                                            '
Display02:	dc.b	'                                                                            '
Display03:	dc.b	'                                                                            '
Display04:	dc.b	'                                                                            '
Display05:	dc.b	'                                                                            '
Display06:	dc.b	'                                                                            '
Display07:	dc.b	'                                                                            '
Display08:	dc.b	'                                                                            '
Display09:	dc.b	'                                                                            '
Display10:	dc.b	'                                                                            '
Display11:	dc.b	'                                                                            '
Display12:	dc.b	'                                                                            '
Display13:	dc.b	'                                                                            '
Display14:	dc.b	'                                                                            '
Display15:	dc.b	'                                                                            '
Display16:	dc.b	'                                                                            '
Display17:	dc.b	'                                                                            '
Display18:	dc.b	'                                                                            '
Display19:	dc.b	'                                                                            '
Display20:	dc.b	'                                                                            '
Display21:	dc.b	'                                                                            '
Display22:	dc.b	'                                                                            '
Display23:	dc.b	'                                                                            '
StartCount:	dc.w	0
TuCName:	dc.b	'tucomposer.library',0
IntName:	dc.b	'intuition.library',0
GfxName:	dc.b	'graphics.library',0
ActChannels:	dc.b	'Active Channels: 0 (0)          ',0
WinTitle:	dc.b	'No module is currently being playing !',0
WinTitleBuf:	ds.b	256
NewModule:	dc.b	0
SigBit:	dc.b	0
Displayed:	dc.b	0