/* TuComposer OS independent code
**
** $VER: ClearKeyboard.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ClearKeyboard ( struct TuComposerInstrKeyboard *KeybrdStr )
{
  if ( KeybrdStr )
  {
    struct KeyboardEntry *KeybrdEntry;
    ULONG Note = FIRSTNOTE;

    KeybrdEntry = (struct KeyboardEntry *) &(KeybrdStr->tcik_NoteEntry[0]);

    for (;;)
    {
      KeybrdEntry->tcik_Sample_C_0 = 0;
      KeybrdEntry->tcik_Octave_C_0 = Note >> 8;
      KeybrdEntry->tcik_Note_C_0 = Note;

      KeybrdEntry++;

      Note++;

      if ( (Note & 0xFF) > NUMNOTES )
      {
        Note += ( 0x100 - NUMNOTES );

        if ( Note == ((NUMOCTAVES << 8) + FIRSTNOTE ))
          return ( 0L );
      }
    }

    return ( 0L );
  }

  return ( ERROR_MODULE_NOKEYBOARD );
}
