/* TuComposer OS independent code
**
** $VER: DupKeyboard.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstrKeyboard *DupKeyboard ( struct TuComposerInstrKeyboard
    *KeybrdStr )
{
  struct TuComposerInstrKeyboard *CloneKeybrd = NULL;

  if ( KeybrdStr )
  {
    if ( (CloneKeybrd = (struct TuComposerInstrKeyboard *) AllocPMem ( sizeof (struct TuComposerInstrKeyboard ))))
    {
      memcpy ( &(CloneKeybrd->tcik_NoteEntry), &(KeybrdStr->tcik_NoteEntry), sizeof (struct TuComposerInstrKeyboard) - offsetof (struct TuComposerInstrKeyboard, tcik_NoteEntry ));
    } else
    {
      FreePMem ( CloneKeybrd, sizeof (struct TuComposerInstrKeyboard ));

      CloneKeybrd = NULL;
    }
  }

  return ( CloneKeybrd );
}
