/* TuComposer OS independent code
**
** $VER: FreeInstrEnvelopes.c 31.22 (8.2.99)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeInstrEnvelopes ( struct TuComposerInstrEnvelope **InstrEnvStr )
{
  struct TuComposerInstrEnvelope **EnvList = InstrEnvStr;
  ULONG Count = 0L;

  if ( InstrEnvStr )
  {
    for (;;)
    {
      Count++;

      if (!( *EnvList++ ))
        break;
    }

    FreePMem ( InstrEnvStr, Count * sizeof (struct TuComposerInstrEnvelope *));

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
