/* TuComposer OS independent code
**
** $VER: FreeKeyboard.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeKeyboard ( struct TuComposerInstrKeyboard *KeybrdStr )
{
  if ( KeybrdStr )
  {
    struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(KeybrdStr->tcik_Node.mln_Succ);

    if ( KeybrdStr->tcik_Node.mln_Succ )
    {
      struct TuComposerInstr *InstrStr;

      for (;;)
      {
        ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

        if (!( ModuleStr->tcm_Node.mln_Pred ))
          break;
      }

      (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_KeyboardDefs );

      InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

      for (;;)
      {
        InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

        if (!( InstrStr->tci_Node.mln_Succ ))
          break;

        if ( InstrStr->tci_KeyboardDefs == KeybrdStr )
        {
          struct TuComposerInstrKeyboard *KeybrdBuf = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Succ;

          if ( KeybrdBuf->tcik_Node.mln_Succ )
          {
            InstrStr->tci_KeyboardDefs = KeybrdBuf;
          } else
          {
            KeybrdBuf = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Pred;

            if ( KeybrdBuf->tcik_Node.mln_Pred )
            {
              InstrStr->tci_KeyboardDefs = KeybrdBuf;
            } else
            {
              InstrStr->tci_KeyboardDefs = NULL;
            }
          }
        }
      }

      DeleteKeyboard ( KeybrdStr );
    }

    FreePMem ( KeybrdStr, sizeof (struct TuComposerInstrKeyboard ));

    return ( 0L );
  }

  return ( ERROR_MODULE_NOKEYBOARD );
}
