/* TuComposer OS independent code
**
** $VER: GetEnvelopeNum.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetEnvelopeNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrEnvelope *EnvStr )
{
  ULONG EnvNum = 0L;

  if ( ModuleStr && EnvStr )
  {
    struct TuComposerInstrEnvelope *EnvScan = (struct TuComposerInstrEnvelope *) &(ModuleStr->tcm_Envelopes.mlh_Head);

    for (;;)
    {
      EnvScan = (struct TuComposerInstrEnvelope *) EnvScan->tcie_Node.mln_Succ;

      if (!( EnvScan->tcie_Node.mln_Succ))
        return ( 0L );

      EnvNum++;

      if (EnvStr == EnvScan)
        break;
    }
  }

  return ( EnvNum );
}
