/* TuComposer OS independent code
**
** $VER: InsertKeyboard.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertKeyboard ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrKeyboard *KeybrdStr,
    struct TuComposerInstrKeyboard *KeybrdPos )
{
  if ( ModuleStr )
  {
    if ( KeybrdStr )
    {
      InsertNode ( (struct List *) &(ModuleStr->tcm_KeyboardDefs), (struct Node *) KeybrdStr, (struct Node *) KeybrdPos);

      return ( 0L );
    }

    return ( ERROR_MODULE_NOKEYBOARD );
  }

  return( ERROR_MODULE_NOGIVEN );
}
