/* TuComposer OS independent code
**
** $VER: LoadInstr.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_instrbase_protos.h>

struct TuComposerInstr *LoadInstr ( struct CFHandle *CFHandle,
    struct TuComposerInstr *InstrStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr, unsigned long NumInstr )
{
  struct TuComposerInstr *LoadInstrStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifyInstr ( CFHandle );

    if ( ExtLibStr )
    {
      struct InstrLibrary *ExtInstrLibBase;

      if ( (ExtInstrLibBase = (struct InstrLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        LoadInstrStr = ExternalInstrLoadBase ( CFHandle, InstrStr, FlagPassStr, NumInstr, ExtInstrLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( LoadInstrStr );
}
