/* TuComposer OS independent code
**
** $VER: PushInstr.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerInstr *PushInstr ( struct TuComposerInstr *InstrStr )
{
 if ( InstrStr )
  {
    InstrStr = DupInstr ( InstrStr );
  } else
  {
    InstrStr = AllocInstr ( 0L );
  }

  if ( InstrStr )
  {
    ObtainSemaphore ( TuCBase->tcb_InstrSigSem );

    AddNodeHead ( (struct List *) &(TuCBase->tcb_InstrBuf), (struct Node *) &(InstrStr->tci_Node) );

    ReleaseSemaphore ( TuCBase->tcb_InstrSigSem );
  }

  return ( InstrStr );
}
