/* TuComposer OS independent code
**
** $VER: ReSizeArpeggio.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReSizeArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Entries )
{
  if ( ArpStr )
  {
    if ( Entries == NULL )
      Entries = DEFAULT_ARPPOINTS;

    if ( Entries < 0x10000 )
    {
      ULONG Length = ArpStr->tcia_Entries, RC = 0L;

      if ( Entries < Length )
      {
        RC = RemArpeggioTick ( ArpStr, Length - Entries );
      } else if ( Entries > Length )
      {
        RC = AddArpeggioTick ( ArpStr, Entries - Length );
      }

      return ( RC );
    }

    return ( ERROR_INSTR_ENVBIG );
  }

  return ( ERROR_INSTR_NOENVL );
}
