/* TuComposer OS independent code
**
** $VER: SaveInstr.c 31.22 (8.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_instrbase_protos.h>

extern struct TuComposerExtList *InternalTCI;

ULONG SaveInstr ( struct CFHandle *CFHandle,
    struct TuComposerInstr *InstrStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr )
{
  struct InstrLibrary *ExtInstrLibBase;
  ULONG RC = ERROR_EXTLIB_NOOPEN;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalTCI);

  if ( (ExtInstrLibBase = (struct InstrLibrary *) OpenExternalLib ( ExtLibStr )))
  {
    RC = ExternalInstrSaveBase ( CFHandle, InstrStr, FlagPassStr, ExtInstrLibBase );

    CloseExternalLib ( ExtLibStr );
  }

  return ( RC );
}
