/* TuComposer OS independent code
**
** $VER: AllocMixer.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_mixerbase_protos.h>

extern struct TuComposerExtList *InternalMixer;

struct MixerAllocStruct *AllocMixer ( struct TuComposerExtList *ExtLibStr )
{
  struct MixerInfo *ExtMixerLibBase;
  struct MixerAllocStruct *MixAllocStr;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalMixer);

  if ( (ExtMixerLibBase = (struct MixerInfo *) OpenExternalLib ( ExtLibStr )))
  {
    if (!( MixAllocStr = ExternalMixerAllocBase ( ExtMixerLibBase )))
      CloseExternalLib ( ExtLibStr );
  }

  return ( MixAllocStr );
}
