/* TuComposer OS independent code
**
** $VER: AllocSoundDevice.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_devicebase_protos.h>

extern struct TuComposerExtList *InternalSoundDevice;

ULONG AllocSoundDevice ( struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr )
{
  struct SoundDeviceInfo *ExtDeviceLibBase;
  ULONG RC = ERROR_EXTLIB_NOOPEN;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalSoundDevice);

  if ( (ExtDeviceLibBase = (struct SoundDeviceInfo *) OpenExternalLib ( ExtLibStr )))
  {
    if ( (RC = ExternalDeviceAllocBase ( FlagPassStr, ExtDeviceLibBase )))
      CloseExternalLib ( ExtLibStr );
  }

  return ( RC );
}
