/* TuComposer OS independent code
**
** $VER: ChangeMixerRate.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_mixerbase_protos.h>

ULONG ChangeMixerRate ( struct MixerAllocStruct *MixAllocStr,
    unsigned long NewMixRate )
{
  struct MixerInfo *ExtMixerLibBase = MixAllocStr->mas_MixLibBase;
  ULONG RC;

  Disable();

  RC = ExternalMixerChangeRateBase ( MixAllocStr, NewMixRate, ExtMixerLibBase );

  Enable();

  return ( RC );
}
