/* TuComposer OS independent code
**
** $VER: ChangeMixerTempo.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_mixerbase_protos.h>

ULONG ChangeMixerTempo ( struct MixerAllocStruct *MixAllocStr,
    unsigned long NewTempo )
{
  struct MixerInfo *ExtMixerLibBase = MixAllocStr->mas_MixLibBase;
  ULONG RC;

  Disable();

  RC = ExternalMixerChangeTempoBase ( MixAllocStr, NewTempo, ExtMixerLibBase );

  Enable();

  return ( RC );
}
