/* TuComposer OS independent code
**
** $VER: ChangePostProcessor.c 31.22 (1.3.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_postprocbase_protos.h>

ULONG ChangePostProcessor ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr )
{
  struct PostProcInfo *ExtPostProcLibBase = PostAllocStr->pas_PostProcLibBase;
  ULONG RC;

  Disable();

  RC = ExternalPostProcChangeBase ( PostAllocStr, MixAllocStr, ExtPostProcLibBase );

  Enable();

  return ( RC );
}
