/* TuComposer OS independent code
**
** $VER: Cos.c 31.22 (6.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

LONG Cos ( long Degrees, long Amplify )
{
  WORD SineValue;

  Degrees = ( 90 - Degrees ) % 360;

  if ( Degrees < 0 )
    Degrees += 360;

  SineValue = TuCBase->tcb_SineTable[Degrees];

  return ( SineValue * Amplify / 32767 );
}
