/* TuComposer OS independent code
**
** $VER: EnqueueNode.c 31.22 (5.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

void EnqueueNode ( struct List *NodeList, struct Node *Node )
{
  BYTE Pri;
  struct Node *SearchNode;
  struct Node *TmpNode;

  SearchNode = (struct Node *) &(NodeList->lh_Head);
  Pri = Node->ln_Pri;

  for (;;)
  {
    SearchNode = SearchNode->ln_Succ;
    if (!( SearchNode->ln_Succ ))
      break;
    if ( Pri > SearchNode->ln_Pri )
      break;
  }

  TmpNode = SearchNode->ln_Pred;
  SearchNode->ln_Pred = (struct Node *) &(Node->ln_Succ);
  Node->ln_Succ = (struct Node *) &(SearchNode->ln_Succ);
  Node->ln_Pred = (struct Node *) &(TmpNode->ln_Succ);
  TmpNode->ln_Succ = (struct Node *) &(Node->ln_Succ);
}
