/* TuComposer OS independent code
**
** $VER: FreeSoundDevice.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_devicebase_protos.h>

extern struct TuComposerExtList *InternalSoundDevice;

ULONG FreeSoundDevice ( struct TuComposerExtList *ExtLibStr )
{
  struct SoundDeviceInfo *ExtDeviceLibBase;
  ULONG RC;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalSoundDevice);

  ExtDeviceLibBase = (struct SoundDeviceInfo *) ExtLibStr->extl_LibBase;

  if (!( RC = ExternalDeviceFreeBase ( ExtDeviceLibBase )))
    CloseExternalLib ( ExtLibStr );

  return ( RC );
}
