/* TuComposer OS independent code
**
** $VER: FreeUnknownChunk.c 31.22 (25.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef MOTOROLA
  ULONG ReadMLong ( UBYTE *Buffer );
#else
  #define ReadMLong( Buffer ) (*(ULONG *) (Buffer))
#endif

#ifdef __cplusplus
}
#endif

void FreeUnknownChunk ( struct UnknownChunk *UnknownChunkStr )
{
  if ( UnknownChunkStr )
  {
    if ( UnknownChunkStr->uc_Node.mln_Succ )
      DeleteUnknownChunk ( UnknownChunkStr );

    FreePMem ( UnknownChunkStr, (sizeof (struct MinNode ) + offsetof (struct IFFChunk, iff_Data) + ReadMLong ( (UBYTE *) &(UnknownChunkStr->uc_Length[0]) ) + 7 ) & 0xFFFFFFF8 );
  }
}
