/* TuComposer OS independent code
**
** $VER: Randomize.c 31.22 (5.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <time.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG Randomize ( unsigned long Seed )
{
  ULONG OldSeed;

  OldSeed = TuCBase->tcb_RandomSeed;

  if ( Seed )
    TuCBase->tcb_RandomSeed = Seed;
  else
    TuCBase->tcb_RandomSeed = time ( NULL ) * 11543;

  return( OldSeed );
}
