/* TuComposer OS independent code
**
** $VER: SetPlayExecHandlerPri.c 31.22 (1.3.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

void SetPlayExecHandlerPri ( struct PlayExecHandler *PlayExecStr,
    long Pri )
{
  if ( PlayExecStr->peh_Node.mln_Succ )
  {
    struct PlayExecHandler *PlayExecList = PlayExecStr;

    Disable ();

    RemoveNode ( (struct Node *) PlayExecStr );

    for (;;)
    {
      PlayExecList = (struct PlayExecHandler *) PlayExecList->peh_Node.mln_Pred;

      if (!( PlayExecList->peh_Node.mln_Pred ))
        break;
    }

    PlayExecStr->peh_Pri = Pri;

    EnqueueNode ( (struct List *) PlayExecList, (struct Node *) PlayExecStr );

    Enable ();
  }
}
