/* TuComposer OS independent code
**
** $VER: AddTCModule.c 31.22 (4.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG AddTCModule ( struct TuComposerModule *ModuleStr )
{
  if ( ModuleStr )
  {
    ObtainSemaphore ( TuCBase->tcb_ModuleListSigSem );

    AddNodeTail ( (struct List *) &(TuCBase->tcb_ModuleList), (struct Node *) ModuleStr );

    ReleaseSemaphore ( TuCBase->tcb_ModuleListSigSem );

    return ( 0L );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
