/* TuComposer OS independent code
**
** $VER: FreeTCModuleInfo.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeTCModuleInfo ( struct ModuleInfo *ModuleInfoStr )
{
  if ( ModuleInfoStr )
  {
    FreeNameStr ( ModuleInfoStr->tcmi_FileName );
    FreeNameStr ( ModuleInfoStr->tcmi_Name );
    FreeNameStr ( ModuleInfoStr->tcmi_Message );
    FreeNameStr ( ModuleInfoStr->tcmi_Composer );
    FreeNameStr ( ModuleInfoStr->tcmi_Style );
    FreeNameStr ( ModuleInfoStr->tcmi_Comment );

    FreePMem ( ModuleInfoStr, sizeof (struct ModuleInfo ));

    return ( 0L );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
