/* TuComposer OS independent code
**
** $VER: PopTCModule.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG PopTCModule ( struct TuComposerModule *ModuleBuf )
{
  if ( ModuleBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_ModuleSigSem );

    RemoveNode ( (struct Node *) &(ModuleBuf->tcm_Node) );

    ReleaseSemaphore ( TuCBase->tcb_ModuleSigSem );

    ModuleBuf->tcm_Node.mln_Succ = NULL;
    ModuleBuf->tcm_Node.mln_Pred = NULL;

    return ( FreeTCModule ( ModuleBuf ));
  }

  return ( ERROR_MODULE_NOGIVEN );
}
