/* TuComposer OS independent code
**
** $VER: PushTCModule.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerModule *PushTCModule ( struct TuComposerModule *ModuleStr )
{
  if ( ModuleStr )
  {
    ModuleStr = DupTCModule ( ModuleStr );
  } else
  {
    ModuleStr = AllocTCModule ( 0L );
  }

  if ( ModuleStr )
  {
    ObtainSemaphore ( TuCBase->tcb_ModuleSigSem );

    AddNodeHead ( (struct List *) &(TuCBase->tcb_ModuleBuf), (struct Node *) &(ModuleStr->tcm_Node) );

    ReleaseSemaphore ( TuCBase->tcb_ModuleSigSem );
  }

  return ( ModuleStr );
}
