/* TuComposer OS independent code
**
** $VER: StopTCModule.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG StopTCModule ( void )
{
  struct SoundDeviceInfo *ExtDeviceLibBase;
  struct TuComposerSong *SongStr;
  struct PlayerGlobals *PGStr;
  ULONG RC = 0L;

  if ( (SongStr = TuCBase->tcb_PlaySong ))
  {
    PGStr = SongStr->tcso_GlobalData;

    PGStr->pg_Flags &= ~(PGF_NoProcPattern|PGF_PlayPattern);
    PGStr->pg_PlayType = 0;
  }

  if ( (ExtDeviceLibBase = TuCBase->tcb_PlaySoundDeviceBase ))
    RC = StopSoundDevice ( ExtDeviceLibBase->sdi_Library.extb_ExtLibList );

  return ( RC );
}
