	include	"tucomposer/external/device_lib.i"

	XDEF	_ExternalDeviceAllocBase
	XDEF	_ExternalDeviceFreeBase
	XDEF	_ExternalDevicePlayBase
	XDEF	_ExternalDeviceStopBase
	XDEF	_ExternalDeviceCheckRateBase
	XDEF	_ExternalDeviceCheckRateFractionBase
	XDEF	_ExternalDeviceUpdateRateBase

_ExternalDeviceAllocBase:	move.l	a6,-(sp)
	movem.l	8(sp),a0/a6
	jsr	_LVOExternalDeviceAlloc(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalDeviceFreeBase:	move.l	a6,-(sp)
	movea.l	8(sp),a6
	jsr	_LVOExternalDeviceFree(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalDevicePlayBase:	move.l	a6,-(sp)
	movem.l	8(sp),a0-a1/a6
	jsr	_LVOExternalDevicePlay(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalDeviceStopBase:	move.l	a6,-(sp)
	movea.l	8(sp),a6
	jsr	_LVOExternalDeviceStop(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalDeviceCheckRateBase:	move.l	a6,-(sp)
	movem.l	8(sp),d0/a6
	jsr	_LVOExternalDeviceCheckRate(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalDeviceCheckRateFractionBase:	move.l	a6,-(sp)
	movem.l	8(sp),d0/a6
	jsr	_LVOExternalDeviceCheckRateFraction(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalDeviceUpdateRateBase:	move.l	a6,-(sp)
	movem.l	8(sp),d0/a6
	jsr	_LVOExternalDeviceUpdateRate(a6)
	movea.l	(sp)+,a6
	rts
