	include	"tucomposer/external/mixer_lib.i"

	XDEF	_ExternalMixerAllocBase
	XDEF	_ExternalMixerFreeBase
	XDEF	_ExternalMixerInitBase
	XDEF	_ExternalMixerChangeRateBase
	XDEF	_ExternalMixerChangeTempoBase
	XDEF	_ExternalMixerChangeVolTableBase
	XDEF	_ExternalMixerGetChannelBase
	XDEF	_ExternalMixerSetChannelBase
	XDEF	_ExternalMixerSetChannelVolPanPitchBase
	XDEF	_ExternalMixerSetChannelPosRepFlagsBase
	XDEF	_ExternalMixerDoMixBase

_ExternalMixerAllocBase:	move.l	a6,-(sp)
	movea.l	8(sp),a6
	jsr	_LVOExternalMixerAlloc(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalMixerFreeBase:	move.l	a6,-(sp)
	movem.l	8(sp),a0/a6
	jsr	_LVOExternalMixerFree(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalMixerInitBase:	movem.l	a2/a6,-(sp)
	movem.l	12(sp),a0-a2/a6
	jsr	_LVOExternalMixerInit(a6)
	movem.l	(sp)+,a2/a6
	rts

	cnop	0,4

_ExternalMixerChangeRateBase:	move.l	a6,-(sp)
	movea.l	8(sp),a0
	movem.l	12(sp),d0/a6
	jsr	_LVOExternalMixerChangeRate(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalMixerChangeTempoBase:	move.l	a6,-(sp)
	movea.l	8(sp),a0
	movem.l	12(sp),d0/a6
	jsr	_LVOExternalMixerChangeTempo(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalMixerChangeVolTableBase:	movem.l	d2-d3/a6,-(sp)
	movea.l	16(sp),a0
	movem.l	20(sp),d0-d3/a6
	jsr	_LVOExternalMixerChangeVolTable(a6)
	movem.l	(sp)+,d2-d3/a6
	rts

	cnop	0,4

_ExternalMixerGetChannelBase:	move.l	a6,-(sp)
	movem.l	8(sp),a0-a1
	exg	a0,a1
	movem.l	16(sp),d0/a6
	jsr	_LVOExternalMixerGetChannel(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalMixerSetChannelBase:	move.l	a6,-(sp)
	movem.l	8(sp),a0-a1
	exg	a0,a1
	movem.l	16(sp),d0/a6
	jsr	_LVOExternalMixerSetChannel(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalMixerSetChannelVolPanPitchBase:	move.l	a6,-(sp)
	movem.l	8(sp),a0-a1
	exg	a0,a1
	movem.l	16(sp),d0/a6
	jsr	_LVOExternalMixerSetChannelVolPanPitch(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalMixerSetChannelPosRepFlagsBase:	move.l	a6,-(sp)
	movem.l	8(sp),a0-a1
	exg	a0,a1
	movem.l	16(sp),d0/a6
	jsr	_LVOExternalMixerSetChannelPosRepFlags(a6)
	movea.l	(sp)+,a6
	rts

	cnop	0,4

_ExternalMixerDoMixBase:	movem.l	a2/a6,-(sp)
	movem.l	12(sp),a0/a2/a6
	jsr	_LVOExternalMixerDoMix(a6)
	movem.l	(sp)+,a2/a6
	rts
