/* TuComposer OS independent code
**
** $VER: AddPositionList.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddPositionList ( struct TuComposerOrders *PosStr,
    struct TuComposerOrderList *PosListStr, unsigned long Channel )
{
  if ( PosStr )
  {
    if ( PosListStr )
    {
      PosStr += Channel;

      PosStr->tco_Length++;

      AddNodeTail ( (struct List *) &(PosStr->tco_OrderData), (struct Node *) PosListStr );

      return (  0L );
    }

    return ( ERROR_POSLIST_NOGIVEN );
  }

  return ( ERROR_POSITION_NOGIVEN );
}
