/* TuComposer OS independent code
**
** $VER: AllocPosition.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerOrders *AllocPosition ( unsigned long Channels )
{
  struct TuComposerOrders *PosStr;
  struct TuComposerOrders *PosBuf;
  ULONG i;

  if ( (PosStr = (struct TuComposerOrders *) AllocPMem ( Channels * sizeof (struct TuComposerOrders ))))
  {
    PosBuf = PosStr;

    for (i = Channels; i > 0; i--)
    {
      InitNodeList ( (struct List *) &(PosBuf->tco_OrderData));

      PosBuf->tco_Volume = DEFAULTPOSVOLUME;
      PosBuf->tco_Panning = DEFAULTPOSPANNING;

      PosBuf++;
    }
  }

  return ( PosStr );
}
