/* TuComposer OS independent code
**
** $VER: DupPosition.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerOrders *DupPosition ( struct TuComposerOrders *PosStr,
    unsigned long Channels )
{
  if ( PosStr )
  {
    struct TuComposerOrders *ClonePosStr;
    struct TuComposerOrders *PosBuf;

    if ( ClonePosStr = AllocPosition ( Channels ))
    {
      ULONG Channel = 0L, i;

      PosBuf = ClonePosStr;

      for (i = Channels; i > 0; i--)
      {
        if ( DupPositionChannel ( PosStr, PosBuf, Channel, Channel ))
        {
          FreePosition ( ClonePosStr, Channels );

          return ( NULL );
        }

        Channel++;
      }

      return ( ClonePosStr );
    }
  }

  return ( NULL );
}
