/* TuComposer OS independent code
**
** $VER: GetPositionNum.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetPositionNum ( struct TuComposerOrders *PosStr,
   struct TuComposerOrderList *PosListStr, unsigned long Channel )
{
  if ( PosStr && PosListStr )
  {
    ULONG Count = 0L;

    PosStr += Channel;

    for (;;)
    {
      PosStr = (struct TuComposerOrders *) PosStr->tco_OrderData.mlh_Head;

      if (!( PosStr->tco_OrderData.mlh_Head ))
        break;

      Count++;

      if ( (struct TuComposerOrderList *) PosStr == PosListStr )
        return ( Count );
    }
  }

  return ( 0L );
}
