/* TuComposer OS independent code
**
** $VER: RemPositionList.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemPositionList ( struct TuComposerOrders *PosStr,
    unsigned long Channel )
{
  if ( PosStr )
  {
    PosStr += Channel;

    if ( PosStr->tco_Length )
    {
      struct TuComposerOrderList *PosBuf;
      struct TuComposerOrderList *PosListStr;

      PosStr->tco_Length--;

      PosListStr = (struct TuComposerOrderList *) PosStr->tco_OrderData.mlh_TailPred;
      PosBuf = (struct TuComposerOrderList *) PosStr;

      for (;;)
      {
        PosBuf = (struct TuComposerOrderList *) PosBuf->tcol_Node.mln_Succ;

        if (!( PosBuf->tcol_Node.mln_Succ ))
          break;

        if ( PosListStr == PosBuf->tcol_NextPos )
          PosBuf->tcol_NextPos = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Pred;

        if ( PosListStr == PosBuf->tcol_PrevPos )
          PosBuf->tcol_PrevPos = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Pred;
      }

      RemNodeTail ( (struct List *) PosStr );

      PosListStr->tcol_Node.mln_Succ = NULL;
      PosListStr->tcol_Node.mln_Pred = NULL;
    }

    return ( 0L );
  }

  return ( ERROR_POSITION_NOGIVEN );
}
