/* TuComposer OS independent code
**
** $VER: SetPosition.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SetPosition ( struct TuComposerSong *SongStr,
    struct TuComposerOrders *PosStr )
{
  if ( SongStr )
  {
    if ( PosStr )
    {
      struct TuComposerOrders *OldPosStr;

      if ( ( OldPosStr = SongStr->tcso_Position ))
        FreePosition ( OldPosStr, SongStr->tcso_Channels );

      SongStr->tcso_Position = PosStr;

      return ( 0L );
    }

    return ( ERROR_POSITION_NOGIVEN );
  }

  return ( ERROR_SONG_NOGIVEN );
}
