/* TuComposer OS independent code
**
** $VER: SwapPositionList.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SwapPositionList ( struct TuComposerOrderList *PosListStr,
    struct TuComposerOrderList *SwapPosListStr )
{
  if ( PosListStr && SwapPosListStr )
  {
    if ( PosListStr != SwapPosListStr )
    {
      UBYTE *SrcBuf,*DestBuf;
      UBYTE TmpByte;
      ULONG i;

      SrcBuf = (UBYTE *) &(PosListStr->tcol_FirstRow);
      DestBuf = (UBYTE *) &(SwapPosListStr->tcol_FirstRow);

      for (i = (offsetof (struct TuComposerOrderList, tcol_UserData) - offsetof (struct TuComposerOrderList, tcol_FirstRow)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }
    }

    return ( 0L );
  }

  return ( ERROR_POSLIST_NOGIVEN );
}
