/* TuComposer OS independent code
**
** $VER: CalcFineTune.c 31.22 (22.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG CalcFineTune ( unsigned long Note, long FineTune )
{
  if ( FineTune < 0 )
  {
    FineTune += 0x80;
    Note--;
  }

  return ( (ULONG) (TuCBase->tcb_FrequencyTable[Note] - TuCBase->tcb_FrequencyTable[Note-1]) * FineTune >> 7);
}
