/* TuComposer OS independent code
**
** $VER: ConvertWord.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ConvertWord ( struct TuComposerSample *SampleStr )
{
  if ( SampleStr = FindOriginSample ( SampleStr ))
  {
    BYTE *SampleData;

    if ( (SampleData = (BYTE *) SampleStr->tcs_Data ))
    {
      ULONG Length;

      if ( (Length = (SampleStr->tcs_Length + SMP_BLOCKMASK) / SMP_BLOCKSIZE ) && (SampleStr->tcs_BitDepth != 8 ))
      {
        UBYTE SampleHI, SampleLO;
        ULONG i;

        if ( SampleStr->tcs_BitDepth == 16 )
        {
          for (i = Length; i > 0; i--)
          {
            SampleHI = *SampleData++;
            SampleLO = *SampleData;
            *SampleData++ = SampleHI;
            *(SampleData - 2) = SampleLO;

            SampleHI = *SampleData++;
            SampleLO = *SampleData;
            *SampleData++ = SampleHI;
            *(SampleData - 2) = SampleLO;

            SampleHI = *SampleData++;
            SampleLO = *SampleData;
            *SampleData++ = SampleHI;
            *(SampleData - 2) = SampleLO;

            SampleHI = *SampleData++;
            SampleLO = *SampleData;
            *SampleData++ = SampleHI;
            *(SampleData - 2) = SampleLO;
          }
        } else
        {
          UBYTE SampleHILow, SampleLOLow;

          for (i = Length; i > 0; i--)
          {
            SampleHI = *SampleData++;
            SampleLO = *SampleData++;
            SampleHILow = *SampleData++;
            SampleLOLow = *SampleData;

            SampleData += -3;

            *SampleData++ = SampleLOLow;
            *SampleData++ = SampleHILow;
            *SampleData++ = SampleLO;
            *SampleData++ = SampleHI;

            SampleHI = *SampleData++;
            SampleLO = *SampleData++;
            SampleHILow = *SampleData++;
            SampleLOLow = *SampleData;

            SampleData += -3;

            *SampleData++ = SampleLOLow;
            *SampleData++ = SampleHILow;
            *SampleData++ = SampleLO;
            *SampleData++ = SampleHI;
          }
        }
      }

      return ( 0L );
    }

    return ( ERROR_SAMPLE_NODATA );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
