/* TuComposer OS independent code
**
** $VER: CopySample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSample *DoDupSample ( struct TuComposerSample *SampleStr, struct TuComposerSample *CloneSample );

extern struct TuComposerBase *TuCBase;

struct TuComposerSample *CopySample ( struct TuComposerSample *SampleStr,
    struct TuComposerSample *SampleBuf )
{
  if ( SampleBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_SampleSigSem );

    if (!( ReSizeSample ( SampleBuf, SampleStr->tcs_Samples )))
    {
      ClearSample ( SampleBuf );
      SampleBuf = DoDupSample ( SampleStr, SampleBuf );

      ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );

      return ( SampleBuf );
    }

    ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );

    return ( NULL );
  }

  return ( PushSample ( SampleStr ));
}
