/* TuComposer OS independent code
**
** $VER: FindOriginSample.c 31.22 (24.4.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSample *FindOriginSample ( struct TuComposerSample *SampleStr )
{
  struct TuComposerSample *OrigSampleStr = SampleStr;

  if ( SampleStr )
  {
    if ( SampleStr->tcs_Flags & TCSF_Redirect )
    {
      struct TuComposerModule *ModuleStr;

      if ( SampleStr->tcs_Node.mln_Succ )
      {
        struct TuComposerInstr *InstrStr = (struct TuComposerInstr *) &(SampleStr->tcs_Node.mln_Succ);

        for (;;)
        {
          InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Pred;

          if (!( InstrStr->tci_Node.mln_Pred ))
            break;
        }

        (UBYTE *) InstrStr += -offsetof (struct TuComposerInstr, tci_Samples );

        if ( InstrStr->tci_Node.mln_Succ )
        {
          ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);

          for (;;)
          {
            ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

            if (!( ModuleStr->tcm_Node.mln_Pred ))
              break;
          }

          (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList );

          InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

          for (;;)
          {
            InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

            if (!( InstrStr->tci_Node.mln_Succ ))
              break;

            OrigSampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

            for (;;)
            {
              OrigSampleStr = (struct TuComposerSample *) OrigSampleStr->tcs_Node.mln_Succ;

              if (!( OrigSampleStr->tcs_Node.mln_Succ ))
                break;

              if ( OrigSampleStr->tcs_Flags & TCSF_Redirect )
                continue;

              if ( OrigSampleStr->tcs_Data == SampleStr->tcs_Data )
                return ( OrigSampleStr );
            }
          }

          OrigSampleStr = SampleStr;
        }
      }
    }
  }

  return ( OrigSampleStr );
}
