/* TuComposer OS independent code
**
** $VER: GetSamples.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_samplebase_protos.h>

ULONG GetSamples ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr )
{
  ULONG NumSamples = 0L;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifySample ( CFHandle );

    if ( ExtLibStr )
    {
      struct SampleLibrary *ExtSampleLibBase;

      if ( (ExtSampleLibBase = (struct SampleLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        NumSamples = ExternalSampleGetNumsBase ( CFHandle, ExtSampleLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( NumSamples );
}
