/* TuComposer OS independent code
**
** $VER: PushSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSample *PushSample ( struct TuComposerSample *SampleStr )
{
  if ( SampleStr )
  {
    SampleStr = DupSample ( SampleStr );
  } else
  {
    SampleStr = AllocSample ( NULL, 0L );
  }

  if ( SampleStr )
  {
    ObtainSemaphore ( TuCBase->tcb_SampleSigSem );

    AddNodeHead ( (struct List *) &(TuCBase->tcb_SampleBuf), (struct Node *) &(SampleStr->tcs_Node) );

    ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );
  }

  return ( SampleStr );
}
