/* TuComposer OS independent code
**
** $VER: FreeSongArpeggios.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeSongArpeggios ( struct TuComposerInstrArpeggio **ArpList )
{
  struct TuComposerInstrArpeggio **ArpFree = ArpList;
  ULONG Count = 0L;

  if ( ArpList )
  {
    for (;;)
    {
      Count++;

      if (!( *ArpList++ ))
        break;
    }

    FreePMem ( ArpFree, Count * sizeof (struct TuComposerInstrArpeggio *));

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
