/* TuComposer OS independent code
**
** $VER: FreeSongEnvelopes.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeSongEnvelopes ( struct TuComposerInstrEnvelope **EnvList )
{
  struct TuComposerInstrEnvelope **EnvFree = EnvList;
  ULONG Count = 0L;

  if ( EnvList )
  {
    for (;;)
    {
      Count++;

      if (!( *EnvList++ ))
        break;
    }

    FreePMem ( EnvFree, Count * sizeof (struct TuComposerInstrEnvelope *));

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
