/* TuComposer OS independent code
**
** $VER: FreeSongInfo.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeSongInfo ( struct SongInfo *SongInfoStr )
{
  if ( SongInfoStr )
  {
    FreeNameStr ( SongInfoStr->soi_FileName );
    FreeNameStr ( SongInfoStr->soi_Name );
    FreeNameStr ( SongInfoStr->soi_Message );
    FreeNameStr ( SongInfoStr->soi_Composer );
    FreeNameStr ( SongInfoStr->soi_Style );
    FreeNameStr ( SongInfoStr->soi_Comment );

    FreePMem ( SongInfoStr, sizeof (struct SongInfo ));

    return ( 0L );
  }

  return ( ERROR_SONG_NOGIVEN );
}
