/* TuComposer OS independent code
**
** $VER: FreeSongKeyboards.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeSongKeyboards ( struct TuComposerInstrKeyboard **KeybrdList )
{
  struct TuComposerInstrKeyboard **KeybrdFree = KeybrdList;
  ULONG Count = 0L;

  if ( KeybrdList )
  {
    for (;;)
    {
      Count++;

      if (!( *KeybrdList++ ))
        break;
    }

    FreePMem ( KeybrdFree, Count * sizeof (struct TuComposerInstrKeyboard *));

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
