/* TuComposer OS independent code
**
** $VER: GetSongNum.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetSongNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerSong *SongStr )
{
  ULONG SongNum = 0L;

  if ( ModuleStr && SongStr )
  {
    struct TuComposerSong *SongScan = (struct TuComposerSong *) &(ModuleStr->tcm_SongList.mlh_Head);

    for (;;)
    {
      SongScan = (struct TuComposerSong *) SongScan->tcso_Node.mln_Succ;

      if (!( SongScan->tcso_Node.mln_Succ))
        return ( 0L );

      SongNum++;

      if (SongStr == SongScan)
        break;
    }
  }

  return ( SongNum );
}
