/* TuComposer OS independent code
**
** $VER: LoadSong.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_songbase_protos.h>

struct TuComposerSong *LoadSong ( struct CFHandle *CFHandle,
    struct TuComposerSong *SongStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr, unsigned long NumSong )
{
  struct TuComposerSong *LoadSongStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifySong ( CFHandle );

    if ( ExtLibStr )
    {
      struct SongLibrary *ExtSongLibBase;

      if ( (ExtSongLibBase = (struct SongLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        LoadSongStr = ExternalSongLoadBase ( CFHandle, SongStr, FlagPassStr, NumSong, ExtSongLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( LoadSongStr );
}
