/* TuComposer OS independent code
**
** $VER: AddSymbol.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddSymbol ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthSymbolTable *SymbolStr )
{
  if ( SynthStr )
  {
    if ( SymbolStr )
    {
      AddNodeTail ( (struct List *) &(SynthStr->tcy_Symbol), (struct Node *) SymbolStr );

      return ( 0L );
    }

    return ( ERROR_SYNTH_NODATA );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
