/* TuComposer OS independent code
**
** $VER: AllocSymbol.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynthSymbolTable *AllocSymbol ( STRPTR Name )
{
  struct TuComposerSynthSymbolTable *SymbolStr = NULL;

  if ( Name )
  {
    STRPTR CheckName = Name;
    UBYTE TmpChar;

    TmpChar = *CheckName++;

    if ( (TmpChar == 0) || (TmpChar > 'z') || ((TmpChar > 'Z') && (TmpChar != '_') && (TmpChar < 'a')) || ((TmpChar != '.') && (TmpChar < '@')) )
      return ( NULL );

    while ( (TmpChar = *CheckName++ ) != 0 )
    {
      if ( ((TmpChar < '0') && (TmpChar != '.')) || (TmpChar > 'z') || ((TmpChar > 'Z') && (TmpChar != '_') && (TmpChar < 'a')) || ((TmpChar > '9') && (TmpChar < '@')) )
        return ( NULL );
    }

    if ( (SymbolStr = AllocPMem ( sizeof (struct TuComposerSynthSymbolTable ))))
    {
      SymbolStr->tsst_LastLine = 0xFFFF;

      if (!( SetString ( (STRPTR *) &(SymbolStr->tsst_SymbolName), Name )))
      {
        FreePMem ( SymbolStr, sizeof (struct TuComposerSynthSymbolTable ));

        SymbolStr = NULL;
      }
    }
  }

  return ( SymbolStr );
}
