/* TuComposer OS independent code
**
** $VER: AllocWaveform.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynthWave *AllocWaveform ( unsigned long WaveLength )
{
  struct TuComposerSynthWave *WaveformStr;

  if (!( WaveLength ))
    WaveLength = DEFAULTSYNTHWAVELENGTH;

  if ( (WaveformStr = (struct TuComposerSynthWave *) AllocPMem ( sizeof (struct TuComposerSynthWave ))))
  {
    WaveformStr->tcyw_Samples = WaveLength;
    WaveformStr->tcyw_RepLen = WaveLength;

    WaveLength += WaveLength;

    WaveformStr->tcyw_Length = WaveLength;

    if (!( WaveformStr->tcyw_WaveData = AllocPMem ( WaveLength )))
    {
      FreePMem ( WaveformStr, sizeof (struct TuComposerSynthWave ));

      WaveformStr = NULL;
    }
  }

  return ( WaveformStr );
}
