/* TuComposer OS independent code
**
** $VER: AssignSynth.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AssignSynth ( struct TuComposerSample *SampleStr,
    struct TuComposerSynth *SynthStr )
{
  if ( SampleStr )
  {
    struct TuComposerSynth *OldSynthStr;

    if ( (OldSynthStr = SampleStr->tcs_Synth ))
    {
      if ( OldSynthStr != SynthStr )
        FreeSynth ( OldSynthStr );
    }

    SampleStr->tcs_Synth = SynthStr;

    return ( 0L );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
