/* TuComposer OS independent code
**
** $VER: ClearWaveform.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ClearWaveform ( struct TuComposerSynthWave *WaveformStr )
{
  if ( WaveformStr )
  {
    FreeNameStr ( WaveformStr->tcyw_FileName );
    WaveformStr->tcyw_FileName = NULL;

    FreeNameStr ( WaveformStr->tcyw_Name );
    WaveformStr->tcyw_Name = NULL;

    memset ( WaveformStr->tcyw_WaveData, 0, WaveformStr->tcyw_Length );

    return ( 0L );
  }

  return ( ERROR_SYNTH_NODATA );
}
