/* TuComposer OS independent code
**
** $VER: CopySynth.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynth *DoDupSynth ( struct TuComposerSynth *SynthStr, struct TuComposerSynth *CloneSynth );

extern struct TuComposerBase *TuCBase;

struct TuComposerSynth *CopySynth ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynth *SynthBuf )
{
  if ( SynthBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_SynthSigSem );

    ClearSynth ( SynthBuf );
    SynthBuf = DoDupSynth ( SynthStr, SynthBuf );

    ReleaseSemaphore ( TuCBase->tcb_SynthSigSem );

    return ( SynthBuf );
  }

  return ( PushSynth ( SynthStr ));
}
