/* TuComposer OS independent code
**
** $VER: CutSynthCode.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSynth *CutSynthCode ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynth *SynthBuf )
{
  ObtainSemaphore ( TuCBase->tcb_SynthSigSem );

  if ( SynthBuf = CopySynthCode ( SynthStr, SynthBuf ))
    ClearSynthCode ( SynthStr );

  ReleaseSemaphore ( TuCBase->tcb_SynthSigSem );

  return ( SynthBuf );
}
