/* TuComposer OS independent code
**
** $VER: FreeSymbol.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeSymbol ( struct TuComposerSynthSymbolTable *SymbolStr )
{
  if ( SymbolStr )
  {
    if ( SymbolStr->tsst_Node.mln_Succ )
      DeleteSymbol ( SymbolStr );

    FreeNameStr ( SymbolStr->tsst_SymbolName );

    FreePMem ( SymbolStr, sizeof (struct TuComposerSynthSymbolTable ));

    return ( 0L );
  }

  return ( ERROR_SYNTH_NODATA );
}
