/* TuComposer OS independent code
**
** $VER: GetNumSymbols.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetNumSymbols ( struct TuComposerSynth *SynthStr )
{
  ULONG Count = 0L;

  if ( SynthStr )
  {
    struct TuComposerSynthSymbolTable *SymbolStr;

    SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

    for (;;)
    {
      SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

      if (!( SymbolStr->tsst_Node.mln_Succ ))
        break;

      Count++;
    }
  }

  return ( Count );
}
