/* TuComposer OS independent code
**
** $VER: GetNumSynths.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetNumSynths ( struct TuComposerModule *ModuleStr )
{
  ULONG Count = 0L;

  if ( ModuleStr )
  {
    struct TuComposerInstr *InstrStr;
    struct TuComposerSample *SampleStr;

    InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

    for (;;)
    {
      InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

      if (!( InstrStr->tci_Node.mln_Succ ))
        break;

      SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

      for (;;)
      {
        SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

        if (!( SampleStr->tcs_Node.mln_Succ ))
          break;

        if ( SampleStr->tcs_Synth )
          Count++;
      }
    }
  }

  return ( Count );
}
