/* TuComposer OS independent code
**
** $VER: GetNumWaveforms.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetNumWaveforms ( struct TuComposerSynth *SynthStr )
{
  ULONG Count = 0L;

  if ( SynthStr )
  {
    struct TuComposerSynthWave *WaveformStr;

    WaveformStr = (struct TuComposerSynthWave *) &(SynthStr->tcy_Waves.mlh_Head);

    for (;;)
    {
      WaveformStr = (struct TuComposerSynthWave *) WaveformStr->tcyw_Node.mln_Succ;

      if (!( WaveformStr->tcyw_Node.mln_Succ ))
        break;

      Count++;
    }
  }

  return ( Count );
}
