/* TuComposer OS independent code
**
** $VER: GetSymbolAddr.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynthSymbolTable *GetSymbolAddr (
    struct TuComposerSynth *SynthStr, unsigned long SymbolNum )
{
  if ( SynthStr && SymbolNum )
  {
    ULONG Cnt;
    struct TuComposerSynthSymbolTable *SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

    for (Cnt = SymbolNum; Cnt > 0; Cnt--)
    {
      SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

      if (!( SymbolStr->tsst_Node.mln_Succ ))
        return ( NULL );
    }

    return ( SymbolStr );
  }

  return ( NULL );
}
