/* TuComposer OS independent code
**
** $VER: GetSymbolNum.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetSymbolNum ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthSymbolTable *SymbolStr )
{
  ULONG SymbolNum = 0L;

  if ( SynthStr && SymbolStr )
  {
    struct TuComposerSynthSymbolTable *SymbolScan = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

    for (;;)
    {
      SymbolScan = (struct TuComposerSynthSymbolTable *) SymbolScan->tsst_Node.mln_Succ;

      if (!( SymbolScan->tsst_Node.mln_Succ))
        return ( 0L );

      SymbolNum++;

      if (SymbolStr == SymbolScan)
        break;
    }
  }

  return ( SymbolNum );
}
