/* TuComposer OS independent code
**
** $VER: GetSynthAddr.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynth *GetSynthAddr ( struct TuComposerModule *ModuleStr,
    unsigned long SynthNum )
{
  if ( ModuleStr && SynthNum )
  {

    struct TuComposerInstr *InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);
    struct TuComposerSample *SampleStr;
    ULONG Cnt = 0L;

    for (;;)
    {
      InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

      if (!( InstrStr->tci_Node.mln_Succ ))
        break;

      SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

      for (;;)
      {
        SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

        if (!( SampleStr->tcs_Node.mln_Succ ))
          break;

        if ( SampleStr->tcs_Synth )
        {
          Cnt++;

          if ( SynthNum == Cnt )
            return ( SampleStr->tcs_Synth );
        }
      }
    }
  }

  return ( NULL );
}
