/* TuComposer OS independent code
**
** $VER: GetSynths.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_synthbase_protos.h>

ULONG GetSynths ( struct CFHandle *CFHandle, struct TuComposerExtList
    *ExtLibStr )
{
  ULONG NumSynths = 0L;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifySynth ( CFHandle );

    if ( ExtLibStr )
    {
      struct SynthLibrary *ExtSynthLibBase;

      if ( (ExtSynthLibBase = (struct SynthLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        NumSynths = ExternalSynthGetNumsBase ( CFHandle, ExtSynthLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( NumSynths );
}
