/* TuComposer OS independent code
**
** $VER: InsertSymbol.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertSymbol ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthSymbolTable *SymbolStr,
    struct TuComposerSynthSymbolTable *SymbolPos )
{
  if ( SynthStr )
  {
    if ( SymbolStr )
    {
      InsertNode ( (struct List *) &(SynthStr->tcy_Symbol), (struct Node *) SymbolStr, (struct Node *) SymbolPos);

      return ( 0L );
    }

    return ( ERROR_SYNTH_NODATA );
  }

  return( ERROR_SYNTH_NOGIVEN );
}
