/* TuComposer OS independent code
**
** $VER: PopWaveform.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG PopWaveform ( struct TuComposerSynthWave *WaveformBuf )
{
  if ( WaveformBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_WavesSigSem );

    RemoveNode ( (struct Node *) &(WaveformBuf->tcyw_Node) );

    ReleaseSemaphore ( TuCBase->tcb_WavesSigSem );

    WaveformBuf->tcyw_Node.mln_Succ = NULL;
    WaveformBuf->tcyw_Node.mln_Pred = NULL;

    return ( FreeWaveform ( WaveformBuf ));
  }

  return ( ERROR_SYNTH_NODATA );
}
