/* TuComposer OS independent code
**
** $VER: PushSynth.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSynth *PushSynth ( struct TuComposerSynth *SynthStr )
{
  if ( SynthStr )
  {
    SynthStr = DupSynth ( SynthStr );
  } else
  {
    SynthStr = AllocSynth ( 1L, 0L, 0L );
  }

  if ( SynthStr )
  {
    ObtainSemaphore ( TuCBase->tcb_SynthSigSem );

    AddNodeHead ( (struct List *) &(TuCBase->tcb_SynthBuf), (struct Node *) &(SynthStr->tcy_Node) );

    ReleaseSemaphore ( TuCBase->tcb_SynthSigSem );
  }

  return ( SynthStr );
}
