/* TuComposer OS independent code
**
** $VER: PushWaveform.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSynthWave *PushWaveform ( struct TuComposerSynthWave
    *WaveformStr )
{
  if ( WaveformStr )
  {
    WaveformStr = DupWaveform ( WaveformStr );
  } else
  {
    WaveformStr = AllocWaveform ( 0L );
  }

  if ( WaveformStr )
  {
    ObtainSemaphore ( TuCBase->tcb_WavesSigSem );

    AddNodeHead ( (struct List *) &(TuCBase->tcb_WavesBuf), (struct Node *) &(WaveformStr->tcyw_Node) );

    ReleaseSemaphore ( TuCBase->tcb_WavesSigSem );
  }

  return ( WaveformStr );
}
