/* TuComposer OS independent code
**
** $VER: RemSymbol.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemSymbol ( struct TuComposerSynth *SynthStr )
{
  if ( SynthStr )
  {
    struct TuComposerSynthSymbolTable *SymbolStr = (struct TuComposerSynthSymbolTable *) SynthStr->tcy_Symbol.mlh_TailPred;

    RemNodeTail ( (struct List *) &(SynthStr->tcy_Symbol));

    SymbolStr->tsst_Node.mln_Succ = NULL;
    SymbolStr->tsst_Node.mln_Pred = NULL;

    return ( 0L );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
