/* TuComposer OS independent code
**
** $VER: RemWaveform.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemWaveform ( struct TuComposerSynth *SynthStr )
{
  if ( SynthStr )
  {
    if ( SynthStr->tcy_NumWaves )
    {
      struct TuComposerSynthWave *WaveformStr = (struct TuComposerSynthWave *) SynthStr->tcy_Waves.mlh_TailPred;

      SynthStr->tcy_NumWaves--;

      RemNodeTail ( (struct List *) &(SynthStr->tcy_Waves));

      WaveformStr->tcyw_Node.mln_Succ = NULL;
      WaveformStr->tcyw_Node.mln_Pred = NULL;
    }

    return ( 0L );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
