/* TuComposer OS independent code
**
** $VER: AddEffect.c 31.22 (10.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddEffect ( struct TuComposerTrack *TrackStr,
    struct TuComposerTrackEffect *EffStr, unsigned long Row )
{
  if ( TrackStr && EffStr )
  {
    struct TuComposerTrackData *TrackData;

    if ( TrackData = TrackStr->tct_Data )
    {
      TrackData += Row;

      AddNodeTail ( (struct List *) &(TrackData->tctd_Effects), (struct Node *) EffStr );

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return( ERROR_TRACK_NOGIVEN );
}
