/* TuComposer OS independent code
**
** $VER: AddTrack.c 31.22 (8.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddTrack ( struct TuComposerSong *SongStr,
    struct TuComposerTrack *TrackStr )
{
  if ( SongStr )
  {
    if ( TrackStr )
    {
      AddNodeTail ( (struct List *) &(SongStr->tcso_TrackList), (struct Node *) TrackStr );

      return ( 0L );
    }

    return ( ERROR_TRACK_NOGIVEN );
  }

  return ( ERROR_SONG_NOGIVEN );
}
