/* TuComposer OS independent code
**
** $VER: AllocTrackData.c 31.22 (8.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerTrackData *AllocTrackData ( unsigned long Length )
{
  struct TuComposerTrackData *TrackData = NULL;
  struct TuComposerTrackData *TrackCnt;
  ULONG i;

  if (!( Length ))
    Length = DEFAULTTRACKROWS;

  if ( Length > MAXTRACKROWS )
    goto Error;

  if ( TrackData = (struct TuComposerTrackData *) AllocPMem ( Length * sizeof (struct TuComposerTrackData )))
  {
    TrackCnt = TrackData;

    for (i = Length; i > 0; i--)
    {
      InitNodeList ( (struct List *) &(TrackCnt->tctd_Effects) );
      TrackCnt++;
    }
  }

Error:
  return ( TrackData );
}
