/* TuComposer OS independent code
**
** $VER: FreeEffect.c 31.22 (8.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG FreeEffect ( struct TuComposerTrackEffect *EffStr )
{
  if ( EffStr )
  {
    struct TuComposerSong *SongStr;

    if ( (SongStr = TuCBase->tcb_PlaySong) )
    {
      struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
      ULONG i;

      Disable ();

      for (i = SongStr->tcso_Channels; i > 0; i--)
      {
        if ( PHCStr->phc_Effect == EffStr )
        {
          struct TuComposerTrackEffect *EffBuf = (struct TuComposerTrackEffect *) EffStr->tcte_Node.mln_Succ;

          PHCStr->phc_Effect = NULL;

          if ( EffBuf->tcte_Node.mln_Succ )
            PHCStr->phc_Effect = EffBuf;
        }

        PHCStr++;
      }

      Enable ();
    }

    FreePMem ( EffStr, sizeof (struct TuComposerTrackEffect ));

    return ( 0L );
  }

  return( ERROR_TRACK_NOGIVEN );
}
