/* TuComposer OS independent code
**
** $VER: GetTrackAddr.c 31.22 (25.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerTrack *GetTrackAddr ( struct TuComposerSong *SongStr,
    unsigned long Num )
{
  if ( SongStr && Num )
  {
    ULONG Cnt;
    struct TuComposerTrack *TrackStr = (struct TuComposerTrack *) &(SongStr->tcso_TrackList.mlh_Head);

    for (Cnt = Num; Cnt > 0; Cnt--)
    {
      TrackStr = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Succ;

      if (!( TrackStr->tct_Node.mln_Succ ))
        return ( NULL );
    }

    return ( TrackStr );
  }

  return ( NULL );
}
