/* TuComposer OS independent code
**
** $VER: InsertEffect.c 31.22 (18.5.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertEffect ( struct TuComposerTrack *TrackStr,
    struct TuComposerTrackEffect *EffStr,
    struct TuComposerTrackEffect *EffPos, unsigned long Row )
{
  if ( TrackStr && EffStr )
  {
    struct TuComposerTrackData *TrackData;

    if ( TrackData = TrackStr->tct_Data )
    {
      TrackData += Row;

      InsertNode ( (struct List *) &(TrackData->tctd_Effects), (struct Node *) EffStr, (struct Node *) EffPos );

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return( ERROR_TRACK_NOGIVEN );
}
