/* TuComposer OS independent code
**
** $VER: LoadTrack.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_trackbase_protos.h>

struct TuComposerTrack *LoadTrack ( struct CFHandle *CFHandle,
    struct TuComposerTrack *TrackStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr, unsigned long NumTrack )
{
  struct TuComposerTrack *LoadTrackStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifyTrack ( CFHandle );

    if ( ExtLibStr )
    {
      struct TrackLibrary *ExtTrackLibBase;

      if ( (ExtTrackLibBase = (struct TrackLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        LoadTrackStr = ExternalTrackLoadBase ( CFHandle, TrackStr, FlagPassStr, NumTrack, ExtTrackLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( LoadTrackStr );
}
