/* TuComposer OS independent code
**
** $VER: PushTrack.c 31.22 (13.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerTrack *PushTrack ( struct TuComposerTrack *TrackStr )
{
  if ( TrackStr )
  {
    TrackStr = DupTrack ( TrackStr );
  } else
  {
    TrackStr = AllocTrack ( 0L );
  }

  if ( TrackStr )
  {
    ObtainSemaphore ( TuCBase->tcb_TrackSigSem );

    AddNodeHead ( (struct List *) &(TuCBase->tcb_TrackBuf), (struct Node *) &(TrackStr->tct_Node) );

    ReleaseSemaphore ( TuCBase->tcb_TrackSigSem );
  }

  return ( TrackStr );
}
