/* TuComposer OS independent code
**
** $VER: RemEffect.c 31.22 (13.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemEffect ( struct TuComposerTrack *TrackStr, unsigned long Row )
{
  if ( TrackStr )
  {
    struct TuComposerTrackData *TrackData;

    if ( (TrackData = TrackStr->tct_Data))
    {
      struct TuComposerTrackEffect *TrackFX;

      TrackData += Row;

      TrackFX = (struct TuComposerTrackEffect *) TrackData->tctd_Effects.mlh_TailPred;

      RemNodeTail ( (struct List *) &(TrackData->tctd_Effects));

      TrackFX->tcte_Node.mln_Succ = NULL;
      TrackFX->tcte_Node.mln_Pred = NULL;

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
