/* TuComposer OS independent code
**
** $VER: RemTrack.c 31.22 (13.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemTrack ( struct TuComposerSong *SongStr )
{
  if ( SongStr )
  {
    struct TuComposerTrack *TrackStr = (struct TuComposerTrack *) SongStr->tcso_TrackList.mlh_TailPred;

    RemNodeTail ( (struct List *) &(SongStr->tcso_TrackList));

    TrackStr->tct_Node.mln_Succ = NULL;
    TrackStr->tct_Node.mln_Pred = NULL;

    return ( 0L );
  }

  return ( ERROR_SONG_NOGIVEN );
}
