/* TuComposer OS independent code
**
** $VER: SaveTrack.c 31.22 (8.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_trackbase_protos.h>

extern struct TuComposerExtList *InternalTCT;

ULONG SaveTrack ( struct CFHandle *CFHandle,
    struct TuComposerTrack *TrackStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr )
{
  struct TrackLibrary *ExtTrackLibBase;
  ULONG RC = ERROR_EXTLIB_NOOPEN;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalTCT);

  if ( (ExtTrackLibBase = (struct TrackLibrary *) OpenExternalLib ( ExtLibStr )))
  {
    RC = ExternalTrackSaveBase ( CFHandle, TrackStr, FlagPassStr, ExtTrackLibBase );

    CloseExternalLib ( ExtLibStr );
  }

  return ( RC );
}
