#ifndef  CLIB_EXT_DEVICE_PROTOS_H
#define  CLIB_EXT_DEVICE_PROTOS_H

/*
**	$VER: ext_device_protos.h 31.00 (1.8.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_DEVICE_H
#include "tucomposer/external/device.h"
#endif /* TUCOMPOSER_EXTERNAL_DEVICE_H */

#ifndef  TUCOMPOSER_EXTERNAL_MIXER_H
#include "tucomposer/external/mixer.h"
#endif /* TUCOMPOSER_EXTERNAL_MIXER_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalDeviceInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalDeviceUpdateFlags ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
void ExternalDeviceReserved0 ( void );
void ExternalDeviceReserved1 ( void );

/* Specific external sound device support functions */

ULONG ExternalDeviceAlloc ( union FlagPass *FlagPassStr );
ULONG ExternalDeviceFree ( void );
ULONG ExternalDevicePlay ( struct MixerAllocStruct *MixAllocStr,
    union FlagPass *FlagPassStr );
ULONG ExternalDeviceStop ( void );
ULONG ExternalDeviceCheckRate ( unsigned long SmpRate );
ULONG ExternalDeviceCheckRateFraction ( unsigned long SmpRate );
ULONG ExternalDeviceUpdateRate ( unsigned long SmpRate );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_DEVICE_PROTOS_H */
