#ifndef  CLIB_EXT_MODULE_PROTOS_H
#define  CLIB_EXT_MODULE_PROTOS_H

/*
**	$VER: ext_modulebase_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_MODULE_H
#include "tucomposer/external/module.h"
#endif /* TUCOMPOSER_EXTERNAL_MODULE_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalModuleInitializeBase ( struct TuComposerExtList *ExtLibStr, struct ModuleLibrary *ModuleBase );
ULONG ExternalModuleUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct ModuleLibrary *ModuleBase );

/* Specific external module loading/saving functions */

ULONG ExternalModuleIdentifyBase ( struct CFHandle *CFHandle, struct ModuleLibrary *ModuleBase );
struct TuComposerModule *ExternalModuleLoadBase ( struct CFHandle *CFHandle,
    struct TuComposerModule *ModuleStr, union FlagPass *FlagPassStr,
    unsigned long NumModule, struct ModuleLibrary *ModuleBase );
ULONG ExternalModuleSaveBase ( struct CFHandle *CFHandle,
    struct TuComposerModule *ModuleStr, union FlagPass *FlagPassStr, struct ModuleLibrary *ModuleBase );
ULONG ExternalModuleGetInfoBase ( struct CFHandle *CFHandle,
    struct ModuleInfo *ModuleInfo, unsigned long NumModule, struct ModuleLibrary *ModuleBase );
ULONG ExternalModuleGetNumsBase ( struct CFHandle *CFHandle, struct ModuleLibrary *ModuleBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_MODULE_PROTOS_H */
