#ifndef  CLIB_EXT_POSTPROC_PROTOS_H
#define  CLIB_EXT_POSTPROC_PROTOS_H

/*
**	$VER: ext_postprocbase_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_POSTPROC_H
#include "tucomposer/external/postproc.h"
#endif /* TUCOMPOSER_EXTERNAL_POSTPROC_H */

#ifndef  TUCOMPOSER_EXTERNAL_MIXER_H
#include "tucomposer/external/mixer.h"
#endif /* TUCOMPOSER_EXTERNAL_MIXER_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalPostProcInitializeBase ( struct TuComposerExtList *ExtLibStr, struct PostProcInfo *PostProcBase );
ULONG ExternalPostProcUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct PostProcInfo *PostProcBase );

/* Specific external post processor support functions */

struct PostProcAllocStruct *ExternalPostProcAllocBase ( struct MixerAllocStruct *MixAllocStr, struct PostProcInfo *PostProcBase );
ULONG ExternalPostProcFreeBase ( struct PostProcAllocStruct *PostAllocStr, struct PostProcInfo *PostProcBase );
ULONG ExternalPostProcInitBase ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr, union FlagPass *FlagPassStr, struct PostProcInfo *PostProcBase );
ULONG ExternalPostProcChangeBase ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr, struct PostProcInfo *PostProcBase );
void ExternalPostProcDoMixBase ( struct PostProcAllocStruct *PostAllocStr,
    long *MixBuffer, struct PostProcInfo *PostProcBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_POSTPROC_PROTOS_H */
