#ifndef  CLIB_EXT_SAMPLE_PROTOS_H
#define  CLIB_EXT_SAMPLE_PROTOS_H

/*
**	$VER: ext_sample_protos.h 31.00 (1.8.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_SAMPLE_H
#include "tucomposer/external/sample.h"
#endif /* TUCOMPOSER_EXTERNAL_SAMPLE_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalSampleInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalSampleUpdateFlags ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
void ExternalSampleReserved0 ( void );
void ExternalSampleReserved1 ( void );

/* Specific external sample loading/saving functions */

ULONG ExternalSampleIdentify ( struct CFHandle *CFHandle );
struct TuComposerSample *ExternalSampleLoad ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, union FlagPass *FlagPassStr,
    unsigned long NumSample );
ULONG ExternalSampleSave ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, union FlagPass *FlagPassStr );
ULONG ExternalSampleGetInfo ( struct CFHandle *CFHandle,
    struct SampleInfo *SampleInfo, unsigned long NumSample );
ULONG ExternalSampleGetNums ( struct CFHandle *CFHandle );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_SAMPLE_PROTOS_H */
