#ifndef  CLIB_EXT_SONG_PROTOS_H
#define  CLIB_EXT_SONG_PROTOS_H

/*
**	$VER: ext_song_protos.h 31.00 (1.8.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_SONG_H
#include "tucomposer/external/song.h"
#endif /* TUCOMPOSER_EXTERNAL_SONG_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalSongInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalSongUpdateFlags ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
void ExternalSongReserved0 ( void );
void ExternalSongReserved1 ( void );

/* Specific external song loading/saving functions */

ULONG ExternalSongIdentify ( struct CFHandle *CFHandle );
struct TuComposerSong *ExternalSongLoad ( struct CFHandle *CFHandle,
    struct TuComposerSong *SongStr, union FlagPass *FlagPassStr,
    unsigned long NumSong );
ULONG ExternalSongSave ( struct CFHandle *CFHandle,
    struct TuComposerSong *SongStr, union FlagPass *FlagPassStr );
ULONG ExternalSongGetInfo ( struct CFHandle *CFHandle,
    struct SongInfo *SongInfo, unsigned long NumSong );
ULONG ExternalSongGetNums ( struct CFHandle *CFHandle );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_SONG_PROTOS_H */
