#ifndef  CLIB_EXT_TRACK_PROTOS_H
#define  CLIB_EXT_TRACK_PROTOS_H

/*
**	$VER: ext_track_protos.h 31.00 (1.8.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_TRACK_H
#include "tucomposer/external/track.h"
#endif /* TUCOMPOSER_EXTERNAL_TRACK_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalTrackInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalTrackUpdateFlags ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
void ExternalTrackReserved0 ( void );
void ExternalTrackReserved1 ( void );

/* Specific external track loading/saving functions */

ULONG ExternalTrackIdentify ( struct CFHandle *CFHandle );
struct TuComposerTrack *ExternalTrackLoad ( struct CFHandle *CFHandle,
    struct TuComposerTrack *TrackStr, union FlagPass *FlagPassStr,
    unsigned long NumTrack );
ULONG ExternalTrackSave ( struct CFHandle *CFHandle,
    struct TuComposerTrack *TrackStr, union FlagPass *FlagPassStr );
ULONG ExternalTrackGetInfo ( struct CFHandle *CFHandle,
    struct TrackInfo *TrackInfo, unsigned long NumTrack );
ULONG ExternalTrackGetNums ( struct CFHandle *CFHandle );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_TRACK_PROTOS_H */
