#ifndef  CLIB_EXT_TRACK_PROTOS_H
#define  CLIB_EXT_TRACK_PROTOS_H

/*
**	$VER: ext_trackbase_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_TRACK_H
#include "tucomposer/external/track.h"
#endif /* TUCOMPOSER_EXTERNAL_TRACK_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalTrackInitializeBase ( struct TuComposerExtList *ExtLibStr, struct TrackLibrary *TrackBase );
ULONG ExternalTrackUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct TrackLibrary *TrackBase );

/* Specific external track loading/saving functions */

ULONG ExternalTrackIdentifyBase ( struct CFHandle *CFHandle, struct TrackLibrary *TrackBase );
struct TuComposerTrack *ExternalTrackLoadBase ( struct CFHandle *CFHandle,
    struct TuComposerTrack *TrackStr, union FlagPass *FlagPassStr,
    unsigned long NumTrack, struct TrackLibrary *TrackBase );
ULONG ExternalTrackSaveBase ( struct CFHandle *CFHandle,
    struct TuComposerTrack *TrackStr, union FlagPass *FlagPassStr, struct TrackLibrary *TrackBase );
ULONG ExternalTrackGetInfoBase ( struct CFHandle *CFHandle,
    struct TrackInfo *TrackInfo, unsigned long NumTrack, struct TrackLibrary *TrackBase );
ULONG ExternalTrackGetNumsBase ( struct CFHandle *CFHandle, struct TrackLibrary *TrackBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_TRACK_PROTOS_H */
