#ifndef _INCLUDE_PRAGMA_EXT_CRUNCHER_LIB_H
#define _INCLUDE_PRAGMA_EXT_CRUNCHER_LIB_H

/*
**  $VER: ext_cruncher_pragmas.h (01-Aug-99)
**
**  TuComposer pragma file for various compilers
*/

#ifndef CLIB_EXT_CRUNCHER_PROTOS_H
#include <clib/ext_cruncher_protos.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined(AZTEC_C) || defined(__MAXON__) || defined(__STORM__)
#pragma amicall(ExtCruncherLibBase, 0x1E, ExternalCruncherInitialize(a0))
#pragma amicall(ExtCruncherLibBase, 0x24, ExternalCruncherUpdateFlags(a0, d0, d1))
#pragma amicall(ExtCruncherLibBase, 0x2A, ExternalCruncherReserved0())
#pragma amicall(ExtCruncherLibBase, 0x30, ExternalCruncherReserved1())
#pragma amicall(ExtCruncherLibBase, 0x36, ExternalCruncherIdentify(a0))
#pragma amicall(ExtCruncherLibBase, 0x3C, ExternalCruncherOpen(a0))
#pragma amicall(ExtCruncherLibBase, 0x42, ExternalCruncherClose(a0))
#pragma amicall(ExtCruncherLibBase, 0x48, ExternalCruncherRead(a0, a1, d0))
#pragma amicall(ExtCruncherLibBase, 0x4E, ExternalCruncherWrite(a0, a1, d0))
#pragma amicall(ExtCruncherLibBase, 0x54, ExternalCruncherSeek(a0, d0, d1))
#pragma amicall(ExtCruncherLibBase, 0x5A, ExternalCruncherGetInfo(a0, a1))
#endif
#if defined(_DCC) || defined(__SASC)
#pragma libcall ExtCruncherLibBase ExternalCruncherInitialize 1e 801
#pragma libcall ExtCruncherLibBase ExternalCruncherUpdateFlags 24 10803
#pragma libcall ExtCruncherLibBase ExternalCruncherReserved0 2a 00
#pragma libcall ExtCruncherLibBase ExternalCruncherReserved1 30 00
#pragma libcall ExtCruncherLibBase ExternalCruncherIdentify 36 801
#pragma libcall ExtCruncherLibBase ExternalCruncherOpen 3c 801
#pragma libcall ExtCruncherLibBase ExternalCruncherClose 42 801
#pragma libcall ExtCruncherLibBase ExternalCruncherRead 48 09803
#pragma libcall ExtCruncherLibBase ExternalCruncherWrite 4e 09803
#pragma libcall ExtCruncherLibBase ExternalCruncherSeek 54 10803
#pragma libcall ExtCruncherLibBase ExternalCruncherGetInfo 5a 9802
#endif

#ifdef __cplusplus
}
#endif

#endif
