#ifndef _INCLUDE_PRAGMA_EXT_MIXER_LIB_H
#define _INCLUDE_PRAGMA_EXT_MIXER_LIB_H

/*
**  $VER: ext_mixer_pragmas.h (01-Aug-99)
**
**  TuComposer pragma file for various compilers
*/

#ifndef CLIB_EXT_MIXER_PROTOS_H
#include <clib/ext_mixer_protos.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined(AZTEC_C) || defined(__MAXON__) || defined(__STORM__)
#pragma amicall(ExtMixerLibBase, 0x1E, ExternalMixerInitialize(a0))
#pragma amicall(ExtMixerLibBase, 0x24, ExternalMixerUpdateFlags(a0, d0, d1))
#pragma amicall(ExtMixerLibBase, 0x2A, ExternalMixerReserved0())
#pragma amicall(ExtMixerLibBase, 0x30, ExternalMixerReserved1())
#pragma amicall(ExtMixerLibBase, 0x36, ExternalMixerAlloc())
#pragma amicall(ExtMixerLibBase, 0x3C, ExternalMixerFree(a0))
#pragma amicall(ExtMixerLibBase, 0x42, ExternalMixerInit(a0, a1, a2))
#pragma amicall(ExtMixerLibBase, 0x48, ExternalMixerChangeRate(a0, d0))
#pragma amicall(ExtMixerLibBase, 0x4E, ExternalMixerChangeTempo(a0, d0))
#pragma amicall(ExtMixerLibBase, 0x54, ExternalMixerChangeVolTable(a0, d0, d1, d2, d3))
#pragma amicall(ExtMixerLibBase, 0x5A, ExternalMixerGetChannel(a1, a0, d0))
#pragma amicall(ExtMixerLibBase, 0x60, ExternalMixerSetChannel(a1, a0, d0))
#pragma amicall(ExtMixerLibBase, 0x66, ExternalMixerSetChannelVolPanPitch(a1, a0, d0))
#pragma amicall(ExtMixerLibBase, 0x6C, ExternalMixerSetChannelPosRepFlags(a1, a0, d0))
#pragma amicall(ExtMixerLibBase, 0x72, ExternalMixerDoMix(a0, a2))
#endif
#if defined(_DCC) || defined(__SASC)
#pragma libcall ExtMixerLibBase ExternalMixerInitialize 1e 801
#pragma libcall ExtMixerLibBase ExternalMixerUpdateFlags 24 10803
#pragma libcall ExtMixerLibBase ExternalMixerReserved0 2a 00
#pragma libcall ExtMixerLibBase ExternalMixerReserved1 30 00
#pragma libcall ExtMixerLibBase ExternalMixerAlloc 36 00
#pragma libcall ExtMixerLibBase ExternalMixerFree 3c 801
#pragma libcall ExtMixerLibBase ExternalMixerInit 42 a9803
#pragma libcall ExtMixerLibBase ExternalMixerChangeRate 48 0802
#pragma libcall ExtMixerLibBase ExternalMixerChangeTempo 4e 0802
#pragma libcall ExtMixerLibBase ExternalMixerChangeVolTable 54 3210805
#pragma libcall ExtMixerLibBase ExternalMixerGetChannel 5a 08903
#pragma libcall ExtMixerLibBase ExternalMixerSetChannel 60 08903
#pragma libcall ExtMixerLibBase ExternalMixerSetChannelVolPanPitch 66 08903
#pragma libcall ExtMixerLibBase ExternalMixerSetChannelPosRepFlags 6c 08903
#pragma libcall ExtMixerLibBase ExternalMixerDoMix 72 a802
#endif

#ifdef __cplusplus
}
#endif

#endif
