#ifndef _INCLUDE_PRAGMA_EXT_POSTPROC_LIB_H
#define _INCLUDE_PRAGMA_EXT_POSTPROC_LIB_H

/*
**  $VER: ext_postproc_pragmas.h (01-Mar-00)
**
**  TuComposer pragma file for various compilers
*/

#ifndef CLIB_EXT_POSTPROC_PROTOS_H
#include <clib/ext_postproc_protos.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined(AZTEC_C) || defined(__MAXON__) || defined(__STORM__)
#pragma amicall(ExtMixerLibBase, 0x1E, ExternalPostProcInitialize(a0))
#pragma amicall(ExtMixerLibBase, 0x24, ExternalPostProcUpdateFlags(a0, d0, d1))
#pragma amicall(ExtMixerLibBase, 0x2A, ExternalPostProcReserved0())
#pragma amicall(ExtMixerLibBase, 0x30, ExternalPostProcReserved1())
#pragma amicall(ExtMixerLibBase, 0x36, ExternalPostProcAlloc(a0))
#pragma amicall(ExtMixerLibBase, 0x3C, ExternalPostProcFree(a0))
#pragma amicall(ExtMixerLibBase, 0x42, ExternalPostProcInit(a0, a1, a2))
#pragma amicall(ExtMixerLibBase, 0x48, ExternalPostProcChange(a0, a1))
#pragma amicall(ExtMixerLibBase, 0x4E, ExternalPostProcDoMix(a0, a2))
#endif
#if defined(_DCC) || defined(__SASC)
#pragma libcall ExtMixerLibBase ExternalPostProcInitialize 1e 801
#pragma libcall ExtMixerLibBase ExternalPostProcUpdateFlags 24 10803
#pragma libcall ExtMixerLibBase ExternalPostProcReserved0 2a 00
#pragma libcall ExtMixerLibBase ExternalPostProcReserved1 30 00
#pragma libcall ExtMixerLibBase ExternalPostProcAlloc 36 801
#pragma libcall ExtMixerLibBase ExternalPostProcFree 3c 801
#pragma libcall ExtMixerLibBase ExternalPostProcInit 42 a9803
#pragma libcall ExtMixerLibBase ExternalPostProcChange 48 9802
#pragma libcall ExtMixerLibBase ExternalPostProcDoMix 4e a802
#endif

#ifdef __cplusplus
}
#endif

#endif
