#ifndef _INCLUDE_PRAGMA_EXT_SONG_LIB_H
#define _INCLUDE_PRAGMA_EXT_SONG_LIB_H

/*
**  $VER: ext_song_pragmas.h (01-Aug-99)
**
**  TuComposer pragma file for various compilers
*/

#ifndef CLIB_EXT_SONG_PROTOS_H
#include <clib/ext_song_protos.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined(AZTEC_C) || defined(__MAXON__) || defined(__STORM__)
#pragma amicall(ExtSongLibBase, 0x1E, ExternalSongInitialize(a0))
#pragma amicall(ExtSongLibBase, 0x24, ExternalSongUpdateFlags(a0, d0, d1))
#pragma amicall(ExtSongLibBase, 0x2A, ExternalSongReserved0())
#pragma amicall(ExtSongLibBase, 0x30, ExternalSongReserved1())
#pragma amicall(ExtSongLibBase, 0x36, ExternalSongIdentify(a0))
#pragma amicall(ExtSongLibBase, 0x3C, ExternalSongLoad(a0, a1, a2, d0))
#pragma amicall(ExtSongLibBase, 0x42, ExternalSongSave(a0, a1, a2))
#pragma amicall(ExtSongLibBase, 0x48, ExternalSongGetInfo(a0, a1, d0))
#pragma amicall(ExtSongLibBase, 0x4E, ExternalSongGetNums(a0))
#endif
#if defined(_DCC) || defined(__SASC)
#pragma libcall ExtSongLibBase ExternalSongInitialize 1e 801
#pragma libcall ExtSongLibBase ExternalSongUpdateFlags 24 10803
#pragma libcall ExtSongLibBase ExternalSongReserved0 2a 00
#pragma libcall ExtSongLibBase ExternalSongReserved1 30 00
#pragma libcall ExtSongLibBase ExternalSongIdentify 36 801
#pragma libcall ExtSongLibBase ExternalSongLoad 3c 0a9804
#pragma libcall ExtSongLibBase ExternalSongSave 42 a9803
#pragma libcall ExtSongLibBase ExternalSongGetInfo 48 09803
#pragma libcall ExtSongLibBase ExternalSongGetNums 4e 801
#endif

#ifdef __cplusplus
}
#endif

#endif
