#ifndef _INCLUDE_PRAGMA_EXT_SYNTH_LIB_H
#define _INCLUDE_PRAGMA_EXT_SYNTH_LIB_H

/*
**  $VER: ext_synth_pragmas.h (01-Aug-99)
**
**  TuComposer pragma file for various compilers
*/

#ifndef CLIB_EXT_SYNTH_PROTOS_H
#include <clib/ext_synth_protos.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined(AZTEC_C) || defined(__MAXON__) || defined(__STORM__)
#pragma amicall(ExtSynthLibBase, 0x1E, ExternalSynthInitialize(a0))
#pragma amicall(ExtSynthLibBase, 0x24, ExternalSynthUpdateFlags(a0, d0, d1))
#pragma amicall(ExtSynthLibBase, 0x2A, ExternalSynthReserved0())
#pragma amicall(ExtSynthLibBase, 0x30, ExternalSynthReserved1())
#pragma amicall(ExtSynthLibBase, 0x36, ExternalSynthIdentify(a0))
#pragma amicall(ExtSynthLibBase, 0x3C, ExternalSynthLoad(a0, a1, a2, d0))
#pragma amicall(ExtSynthLibBase, 0x42, ExternalSynthSave(a0, a1, a2))
#pragma amicall(ExtSynthLibBase, 0x48, ExternalSynthGetInfo(a0, a1, d0))
#pragma amicall(ExtSynthLibBase, 0x4E, ExternalSynthGetNums(a0))
#endif
#if defined(_DCC) || defined(__SASC)
#pragma libcall ExtSynthLibBase ExternalSynthInitialize 1e 801
#pragma libcall ExtSynthLibBase ExternalSynthUpdateFlags 24 10803
#pragma libcall ExtSynthLibBase ExternalSynthReserved0 2a 00
#pragma libcall ExtSynthLibBase ExternalSynthReserved1 30 00
#pragma libcall ExtSynthLibBase ExternalSynthIdentify 36 801
#pragma libcall ExtSynthLibBase ExternalSynthLoad 3c 0a9804
#pragma libcall ExtSynthLibBase ExternalSynthSave 42 a9803
#pragma libcall ExtSynthLibBase ExternalSynthGetInfo 48 09803
#pragma libcall ExtSynthLibBase ExternalSynthGetNums 4e 801
#endif

#ifdef __cplusplus
}
#endif

#endif
