/* TuComposer OS independent code
**
** $VER: AddEnvelope.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddEnvelope ( struct TuComposerModule *ModuleStr,
     struct TuComposerInstrEnvelope *EnvStr )
{
 if ( ModuleStr )
  {
    if ( EnvStr )
    {
      AddNodeTail ( (struct List *) &(ModuleStr->tcm_Envelopes), (struct Node *) EnvStr );

      return ( 0L );
    }

    return ( ERROR_INSTR_NOENVL );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
