/* TuComposer OS independent code
**
** $VER: AddKeyboard.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddKeyboard ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrKeyboard *KeybrdStr )
{
  if ( ModuleStr )
  {
    if ( KeybrdStr )
    {
      AddNodeTail ( (struct List *) &(ModuleStr->tcm_KeyboardDefs), (struct Node *) KeybrdStr );

      return ( 0L );
    }

    return ( ERROR_MODULE_NOKEYBOARD );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
