/* TuComposer OS independent code
**
** $VER: AllocArpeggio.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstrArpeggio *AllocArpeggio ( unsigned long NumEntries )
{
  struct TuComposerInstrArpeggio *ArpStr = NULL;

  if ( NumEntries == 0L )
    NumEntries = DEFAULT_ARPPOINTS;

  if ( NumEntries < 0x10000 )
  {
    if ( (ArpStr = (struct TuComposerInstrArpeggio *) AllocPMem ( sizeof (struct TuComposerInstrArpeggio ))))
    {
      ArpStr->tcia_Entries = NumEntries;

      if (!( ArpStr->tcia_Data = (struct TuComposerInstrArpeggioData *) AllocPMem ( NumEntries * sizeof (struct TuComposerInstrArpeggioData ))))
      {
        FreePMem ( ArpStr, sizeof (struct TuComposerInstrArpeggio ));

        ArpStr = NULL;
      }
    }
  }

  return ( ArpStr );
}
