/* TuComposer OS independent code
**
** $VER: CmpEnvelopes.c 31.22 (10.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

LONG CmpArpeggios ( struct TuComposerInstrArpeggio *SrcArpStr,
    struct TuComposerInstrArpeggio *DestArpStr )
{
  if ( SrcArpStr && DestArpStr )
  {
    if ( SrcArpStr == DestArpStr )
      goto ArpsEqual;

    if ( SrcArpStr->tcia_Flags != DestArpStr->tcia_Flags )
      goto ArpsNotEqual;

    if ( memcmp ( &(SrcArpStr->tcia_Entries), &(DestArpStr->tcia_Entries), offsetof (struct TuComposerInstrArpeggio, tcia_Reserved) - offsetof (struct TuComposerInstrArpeggio, tcia_Entries )))
      goto ArpsNotEqual;

    if ( memcmp ( SrcArpStr->tcia_Data, DestArpStr->tcia_Data, SrcArpStr->tcia_Entries * sizeof (struct TuComposerInstrArpeggioData)))
      goto ArpsNotEqual;

ArpsEqual:
    return ( 0L );

ArpsNotEqual:
    return ( 1L );

  }

  return ( ERROR_INSTR_NOENVL );
}
