/* TuComposer OS independent code
**
** $VER: CmpEnvelopes.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

LONG CmpEnvelopes ( struct TuComposerInstrEnvelope *SrcEnvStr,
    struct TuComposerInstrEnvelope *DestEnvStr )
{
  if ( SrcEnvStr && DestEnvStr )
  {
    if ( SrcEnvStr == DestEnvStr )
      goto EnvsEqual;

    if ( SrcEnvStr->tcie_Flags != DestEnvStr->tcie_Flags )
      goto EnvsNotEqual;

    if ( memcmp ( &(SrcEnvStr->tcie_NumNodes), &(DestEnvStr->tcie_NumNodes), offsetof (struct TuComposerInstrEnvelope, tcie_UnknownChunks) - offsetof (struct TuComposerInstrEnvelope, tcie_NumNodes )))
      goto EnvsNotEqual;

    if ( SrcEnvStr->tcie_NumNodes )
    {
      if ( memcmp ( SrcEnvStr->tcie_NodePoints, DestEnvStr->tcie_NodePoints, SrcEnvStr->tcie_NumNodes * sizeof (WORD)))
        goto EnvsNotEqual;
    }

    if ( memcmp ( SrcEnvStr->tcie_Data, DestEnvStr->tcie_Data, SrcEnvStr->tcie_NumPoints * sizeof (WORD)))
      goto EnvsNotEqual;

EnvsEqual:
    return ( 0L );

EnvsNotEqual:
    return ( 1L );

  }

  return ( ERROR_INSTR_NOENVL );
}
