/* TuComposer OS independent code
**
** $VER: CmpKeyboards.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

LONG CmpKeyboards ( struct TuComposerInstrKeyboard *SrcKeybrdStr,
    struct TuComposerInstrKeyboard *DestKeybrdStr )
{
  if ( SrcKeybrdStr && DestKeybrdStr )
  {
    if ( SrcKeybrdStr == DestKeybrdStr )
      goto KeyboardsEqual;

    if ( memcmp ( &(SrcKeybrdStr->tcik_NoteEntry[0]), &(DestKeybrdStr->tcik_NoteEntry[0]), sizeof (struct TuComposerInstrKeyboard) - offsetof (struct TuComposerInstrKeyboard, tcik_NoteEntry )))
      return ( 1L );

KeyboardsEqual:

    return ( 0L );
  }

  return ( ERROR_MODULE_NOKEYBOARD );
}
