/* TuComposer OS independent code
**
** $VER: CopyInstr.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstr *DoDupInstr ( struct TuComposerInstr *InstrStr, struct TuComposerInstr *CloneInstr );

extern struct TuComposerBase *TuCBase;

struct TuComposerInstr *CopyInstr ( struct TuComposerInstr *InstrStr,
    struct TuComposerInstr *InstrBuf )
{
  if ( InstrBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_InstrSigSem );

    ClearInstr ( InstrBuf );
    InstrBuf = DoDupInstr ( InstrStr, InstrBuf );

    ReleaseSemaphore ( TuCBase->tcb_InstrSigSem );

    return ( InstrBuf );
  }

  return ( PushInstr ( InstrStr ));
}