/* TuComposer OS independent code
**
** $VER: CutInstr.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerInstr *CutInstr ( struct TuComposerInstr *InstrStr,
    struct TuComposerInstr *InstrBuf )
{
  ObtainSemaphore ( TuCBase->tcb_InstrSigSem );

  if ( InstrBuf = CopyInstr ( InstrStr, InstrBuf ))
    ClearInstr ( InstrStr );

  ReleaseSemaphore ( TuCBase->tcb_InstrSigSem );

  return ( InstrBuf );
}
