/* TuComposer OS independent code
**
** $VER: DupArpeggio.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstrArpeggio *DupArpeggio ( struct TuComposerInstrArpeggio
    *ArpStr )
{
  struct TuComposerInstrArpeggio *CloneArp = NULL;

  if ( ArpStr )
  {
    if ( (CloneArp = (struct TuComposerInstrArpeggio *) AllocPMem ( sizeof (struct TuComposerInstrArpeggio ))))
    {
      struct TuComposerInstrArpeggioData *CloneArpData;
      ULONG ArpLen = ArpStr->tcia_Entries;

      if ( (CloneArpData = (struct TuComposerInstrArpeggioData *) AllocPMem ( ArpLen * sizeof (struct TuComposerInstrArpeggioData ))))
      {
        CloneArp->tcia_Data = CloneArpData;

        CloneArp->tcia_Flags = ArpStr->tcia_Flags;
        memcpy ( &(CloneArp->tcia_Entries), &(ArpStr->tcia_Entries), offsetof (struct TuComposerInstrArpeggio, tcia_Reserved) - offsetof (struct TuComposerInstrArpeggio, tcia_Entries ));

        memcpy ( CloneArpData, ArpStr->tcia_Data, ArpLen * sizeof (struct TuComposerInstrArpeggioData ));
      } else
      {
        FreePMem ( CloneArp, sizeof (struct TuComposerInstrArpeggio ));

        CloneArp = NULL;
      }
    }
  }

  return ( CloneArp );
}
