/* TuComposer OS independent code
**
** $VER: FreeInstrInfo.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeInstrInfo ( struct InstrInfo *InstrInfoStr )
{
  if ( InstrInfoStr )
  {
    FreeNameStr ( InstrInfoStr->ii_FileName );
    FreeNameStr ( InstrInfoStr->ii_Name );

    FreePMem ( InstrInfoStr, sizeof (struct InstrInfo ));

    return ( 0L );
  }

  return ( ERROR_INSTR_NOGIVEN );
}
