/* TuComposer OS independent code
**
** $VER: FreeInstrSamples.c 31.22 (8.2.99)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeInstrSamples ( struct TuComposerSample **InstrSmpStr )
{
  struct TuComposerSample **SampleList = InstrSmpStr;
  ULONG Count = 0L;

  if ( InstrSmpStr )
  {
    for (;;)
    {
      Count++;

      if (!( *SampleList++ ))
        break;
    }

    FreePMem ( InstrSmpStr, Count * sizeof (struct TuComposerSample *));

    return ( 0L );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
