/* TuComposer OS independent code
**
** $VER: GetArpeggioAddr.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstrArpeggio *GetArpeggioAddr ( struct TuComposerModule
    *ModuleStr, unsigned long Num )
{
  if ( ModuleStr && Num )
  {
    ULONG Cnt;
    struct TuComposerInstrArpeggio *ArpStr = (struct TuComposerInstrArpeggio *) &(ModuleStr->tcm_ArpEnvList.mlh_Head);

    for (Cnt = Num; Cnt > 0; Cnt--)
    {
      ArpStr = (struct TuComposerInstrArpeggio *) ArpStr->tcia_Node.mln_Succ;

      if (!( ArpStr->tcia_Node.mln_Succ ))
        return ( NULL );
    }

    return ( ArpStr );
  }

  return ( NULL );
}
