/* TuComposer OS independent code
**
** $VER: GetArpeggioNum.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetArpeggioNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrArpeggio *ArpStr )
{
  ULONG ArpNum = 0L;

  if ( ModuleStr && ArpStr )
  {
    struct TuComposerInstrArpeggio *ArpScan = (struct TuComposerInstrArpeggio *) &(ModuleStr->tcm_ArpEnvList.mlh_Head);

    for (;;)
    {
      ArpScan = (struct TuComposerInstrArpeggio *) ArpScan->tcia_Node.mln_Succ;

      if (!( ArpScan->tcia_Node.mln_Succ))
        return ( 0L );

      ArpNum++;

      if (ArpStr == ArpScan)
        break;
    }
  }

  return ( ArpNum );
}
