/* TuComposer OS independent code
**
** $VER: GetEnvelopeAddr.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstrEnvelope *GetEnvelopeAddr ( struct TuComposerModule
    *ModuleStr, unsigned long Num )
{
  if ( ModuleStr && Num )
  {
    ULONG Cnt;
    struct TuComposerInstrEnvelope *EnvStr = (struct TuComposerInstrEnvelope *) &(ModuleStr->tcm_Envelopes.mlh_Head);

    for (Cnt = Num; Cnt > 0; Cnt--)
    {
      EnvStr = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Succ;

      if (!( EnvStr->tcie_Node.mln_Succ ))
        return ( NULL );
    }

    return ( EnvStr );
  }

  return ( NULL );
}

