/* TuComposer OS independent code
**
** $VER: GetInstrAddr.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstr *GetInstrAddr ( struct TuComposerModule *ModuleStr,
    unsigned long Num )
{
  if ( ModuleStr && Num )
  {
    ULONG Cnt;
    struct TuComposerInstr *InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

    for (Cnt = Num; Cnt > 0; Cnt--)
    {
      InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

      if (!( InstrStr->tci_Node.mln_Succ ))
        return ( NULL );
    }

    return ( InstrStr );
  }

  return ( NULL );
}
