/* TuComposer OS independent code
**
** $VER: GetInstrNum.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetInstrNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstr *InstrStr )
{
  ULONG InstrNum = 0L;

  if ( ModuleStr && InstrStr )
  {
    struct TuComposerInstr *InstrScan = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

    for (;;)
    {
      InstrScan = (struct TuComposerInstr *) InstrScan->tci_Node.mln_Succ;

      if (!( InstrScan->tci_Node.mln_Succ))
        return ( 0L );

      InstrNum++;

      if (InstrStr == InstrScan)
        break;
    }
  }

  return ( InstrNum );
}
