/* TuComposer OS independent code
**
** $VER: GetInstrs.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_instrbase_protos.h>

ULONG GetInstrs ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr )
{
  ULONG NumInstrs = 0L;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifyInstr ( CFHandle );

    if ( ExtLibStr )
    {
      struct InstrLibrary *ExtInstrLibBase;

      if ( (ExtInstrLibBase = (struct InstrLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        NumInstrs = ExternalInstrGetNumsBase ( CFHandle, ExtInstrLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( NumInstrs );
}
