/* TuComposer OS independent code
**
** $VER: GetKeyboardAddr.c 31.22 (4.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstrKeyboard *GetKeyboardAddr (
    struct TuComposerModule *ModuleStr, unsigned long Num )
{
  if ( ModuleStr && Num )
  {
    ULONG Cnt;
    struct TuComposerInstrKeyboard *KeybrdStr = (struct TuComposerInstrKeyboard *) &(ModuleStr->tcm_KeyboardDefs.mlh_Head);

    for (Cnt = Num; Cnt > 0; Cnt--)
    {
      KeybrdStr = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Succ;

      if (!( KeybrdStr->tcik_Node.mln_Succ ))
        return ( NULL );
    }

    return ( KeybrdStr );
  }

  return ( NULL );
}
