/* TuComposer OS independent code
**
** $VER: GetKeyboardNum.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetKeyboardNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrKeyboard *KeybrdStr )
{
  ULONG KeybrdNum = 0L;

  if ( ModuleStr && KeybrdStr )
  {
    struct TuComposerInstrKeyboard *KeybrdScan = (struct TuComposerInstrKeyboard *) &(ModuleStr->tcm_KeyboardDefs.mlh_Head);

    for (;;)
    {
      KeybrdScan = (struct TuComposerInstrKeyboard *) KeybrdScan->tcik_Node.mln_Succ;

      if (!( KeybrdScan->tcik_Node.mln_Succ))
        return ( 0L );

      KeybrdNum++;

      if (KeybrdStr == KeybrdScan)
        break;
    }
  }

  return ( KeybrdNum );
}
