/* TuComposer OS independent code
**
** $VER: GetNumArpeggios.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetNumArpeggios ( struct TuComposerModule *ModuleStr )
{
  ULONG Count = 0L;

  if ( ModuleStr )
  {
    struct TuComposerInstrArpeggio *ArpStr;

    ArpStr = (struct TuComposerInstrArpeggio *) &(ModuleStr->tcm_ArpEnvList.mlh_Head);

    for (;;)
    {
      ArpStr = (struct TuComposerInstrArpeggio *) ArpStr->tcia_Node.mln_Succ;

      if (!( ArpStr->tcia_Node.mln_Succ ))
        break;

      Count++;
    }
  }

  return ( Count );
}
