/* TuComposer OS independent code
**
** $VER: GetNumEnvelopes.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetNumEnvelopes ( struct TuComposerModule *ModuleStr )
{
  ULONG Count = 0L;

  if ( ModuleStr )
  {
    struct TuComposerInstrEnvelope *EnvStr;

    EnvStr = (struct TuComposerInstrEnvelope *) &(ModuleStr->tcm_Envelopes.mlh_Head);

    for (;;)
    {
      EnvStr = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Succ;

      if (!( EnvStr->tcie_Node.mln_Succ ))
        break;

      Count++;
    }
  }

  return ( Count );
}
