/* TuComposer OS independent code
**
** $VER: GetNumInstrs.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetNumInstrs ( struct TuComposerModule *ModuleStr )
{
  ULONG Count = 0L;

  if ( ModuleStr )
  {
    struct TuComposerInstr *InstrStr;

    InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

    for (;;)
    {
      InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

      if (!( InstrStr->tci_Node.mln_Succ ))
        break;

      Count++;
    }
  }

  return ( Count );
}
