/* TuComposer OS independent code
**
** $VER: GetNumKeyboards.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetNumKeyboards ( struct TuComposerModule *ModuleStr )
{
  ULONG Count = 0L;

  if ( ModuleStr )
  {
    struct TuComposerInstrKeyboard *KeybrdStr;

    KeybrdStr = (struct TuComposerInstrKeyboard *) &(ModuleStr->tcm_KeyboardDefs.mlh_Head);

    for (;;)
    {
      KeybrdStr = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Succ;

      if (!( KeybrdStr->tcik_Node.mln_Succ ))
        break;

      Count++;
    }
  }

  return ( Count );
}
