/* TuComposer OS independent code
**
** $VER: HalveEnvelope.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG HalveEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Scale )
{
  if ( EnvStr )
  {
    if ( Scale )
    {
      if ( Scale == 1 )
        return ( 0L );

      return ( ReSizeEnvelope ( EnvStr, EnvStr->tcie_NumPoints / Scale ));
    }

    return ( ERROR_INSTR_ENVSCLR );
  }

  return ( ERROR_INSTR_NOENVL );
}
