/* TuComposer OS independent code
**
** $VER: InsertEnvelope.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertEnvelope ( struct TuComposerModule *ModuleStr,
     struct TuComposerInstrEnvelope *EnvStr,
     struct TuComposerInstrEnvelope *EnvPos )
{
  if ( ModuleStr )
  {
    if ( EnvStr )
    {
      InsertNode ( (struct List *) &(ModuleStr->tcm_Envelopes), (struct Node *) EnvStr, (struct Node *) EnvPos);

      return ( 0L );
    }

    return ( ERROR_INSTR_NOENVL );
  }

  return( ERROR_MODULE_NOGIVEN );
}
