/* TuComposer OS independent code
**
** $VER: JoinArpeggio.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG JoinArpeggio ( struct TuComposerInstrArpeggio *SrcArpStr,
    struct TuComposerInstrArpeggio *DestArpStr )
{
  if ( SrcArpStr && DestArpStr )
  {
    ULONG SrcLen, DestLen, NewLen, RC;

    SrcLen = SrcArpStr->tcia_Entries;
    DestLen = DestArpStr->tcia_Entries;

    if ( (NewLen = (SrcLen + DestLen)) < 0x10000 )
    {
      if (!( RC = AddArpeggioTick ( SrcArpStr, DestLen )))
        memcpy ( SrcArpStr->tcia_Data + SrcLen, DestArpStr->tcia_Data, DestLen * sizeof (struct TuComposerInstrArpeggioData ));

      return ( RC );
    }

    return ( ERROR_INSTR_ENVBIG );
  }

  return ( ERROR_INSTR_NOENVL );
}
