/* TuComposer OS independent code
**
** $VER: PasteInstr.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstr *DoDupInstr ( struct TuComposerInstr *InstrStr, struct TuComposerInstr *CloneInstr );

extern struct TuComposerBase *TuCBase;

struct TuComposerInstr *PasteInstr ( struct TuComposerInstr *InstrBuf,
    struct TuComposerInstr *InstrStr )
{
  ObtainSemaphoreShared ( TuCBase->tcb_InstrSigSem );

  if ( InstrStr )
    ClearInstr ( InstrStr );

  InstrStr = DoDupInstr ( InstrBuf, InstrStr );

  ReleaseSemaphore ( TuCBase->tcb_InstrSigSem );

  return ( InstrStr );
}
