/* TuComposer OS independent code
**
** $VER: PopInstr.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG PopInstr ( struct TuComposerInstr *InstrBuf )
{
  if ( InstrBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_InstrSigSem );

    RemoveNode ( (struct Node *) &(InstrBuf->tci_Node) );

    ReleaseSemaphore ( TuCBase->tcb_InstrSigSem );

    InstrBuf->tci_Node.mln_Succ = NULL;
    InstrBuf->tci_Node.mln_Pred = NULL;

    return ( FreeInstr ( InstrBuf ));
  }

  return ( ERROR_INSTR_NOGIVEN );
}
