/* TuComposer OS independent code
**
** $VER: ReSizeEnvelope.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReSizeEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Entries )
{
  if ( EnvStr )
  {
    if ( Entries == NULL )
      Entries = DEFAULT_ENVPOINTS;

    if ( Entries < 0x10000 )
    {
      ULONG Length = EnvStr->tcie_NumPoints, RC = 0L;

      if ( Entries < Length )
      {
        RC = RemEnvPoint ( EnvStr, Length - Entries );
      } else if ( Entries > Length )
      {
        RC = AddEnvPoint ( EnvStr, Entries - Length );
      }

      return ( RC );
    }

    return ( ERROR_INSTR_ENVBIG );
  }

  return ( ERROR_INSTR_NOENVL );
}
