/* TuComposer OS independent code
**
** $VER: AddPostProcessor.c 31.22 (1.3.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct PostProcAllocStruct *AddPostProcessor ( struct MixerAllocStruct
    *MixAllocStr, struct PostProcAllocStruct *PostAllocStr )
{
  if ( MixAllocStr && PostAllocStr )
  {
    Disable ();

    EnqueueNode ( (struct List *) &(MixAllocStr->mas_PostProcs), (struct Node *) PostAllocStr );

    Enable ();
  }

  return ( PostAllocStr );
}
