/* TuComposer OS independent code
**
** $VER: AllocPostProcessor.c 31.22 (1.3.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_postprocbase_protos.h>

extern struct TuComposerExtList *InternalPostProc;

struct PostProcAllocStruct *AllocPostProcessor ( struct TuComposerExtList *ExtLibStr,
    struct MixerAllocStruct *MixAllocStr )
{
  struct PostProcInfo *ExtPostProcLibBase;
  struct PostProcAllocStruct *PostAllocStr;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalPostProc);

  if ( (ExtPostProcLibBase = (struct PostProcInfo *) OpenExternalLib ( ExtLibStr )))
  {
    if (!( PostAllocStr = ExternalPostProcAllocBase ( MixAllocStr, ExtPostProcLibBase )))
      CloseExternalLib ( ExtLibStr );
  }

  return ( PostAllocStr );
}
