/* TuComposer OS independent code
**
** $VER: CheckSoundDeviceRateFraction.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_devicebase_protos.h>

extern struct TuComposerExtList *InternalSoundDevice;

ULONG CheckSoundDeviceRateFraction ( struct TuComposerExtList
    *ExtLibStr, unsigned long SmpRate )
{
  struct SoundDeviceInfo *ExtDeviceLibBase;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalSoundDevice);

  ExtDeviceLibBase = (struct SoundDeviceInfo *) ExtLibStr->extl_LibBase;

  return ( ExternalDeviceCheckRateFractionBase ( SmpRate, ExtDeviceLibBase ));
}
