/* TuComposer OS independent code
**
** $VER: FreeMixer.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_mixerbase_protos.h>

ULONG FreeMixer ( struct MixerAllocStruct *MixAllocStr )
{
  struct MixerInfo *ExtMixerLibBase = MixAllocStr->mas_MixLibBase;
  struct PostProcAllocStruct *PostAllocStr;
  ULONG RC;

  for (;;)
  {
    PostAllocStr = (struct PostProcAllocStruct *) MixAllocStr->mas_PostProcs.mlh_Head;

    if (!( PostAllocStr->pas_Node.mln_Succ ))
      break;

    FreePostProcessor ( PostAllocStr );
  }

  if (!( RC = ExternalMixerFreeBase ( MixAllocStr, ExtMixerLibBase )))
    CloseExternalLib (ExtMixerLibBase->mix_Library.extb_ExtLibList );

  return ( RC );
}
