/* TuComposer OS independent code
**
** $VER: FreePostProcessor.c 31.22 (1.3.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_postprocbase_protos.h>

ULONG FreePostProcessor ( struct PostProcAllocStruct *PostAllocStr )
{
  struct PostProcInfo *ExtPostProcLibBase = PostAllocStr->pas_PostProcLibBase;
  ULONG RC;

  if ( PostAllocStr->pas_Node.mln_Succ )
    RemoveNode ( (struct Node *) PostAllocStr );

  if (!( RC = ExternalPostProcFreeBase ( PostAllocStr, ExtPostProcLibBase )))
    CloseExternalLib (ExtPostProcLibBase->pop_Library.extb_ExtLibList );

  return ( RC );
}
