/* TuComposer OS independent code
**
** $VER: InitMixer.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_mixerbase_protos.h>

extern struct SoundDeviceInfo *InternalSoundDeviceBase;

ULONG InitMixer ( struct MixerAllocStruct *MixAllocStr,
    struct SoundDeviceInfo *ExtSoundDevStr, union FlagPass *FlagPassStr )
{
  struct MixerInfo *ExtMixerLibBase = MixAllocStr->mas_MixLibBase;

  if (!( ExtSoundDevStr ))
    ExtSoundDevStr = (struct SoundDeviceInfo *) &(InternalSoundDeviceBase);

  return ( ExternalMixerInitBase ( MixAllocStr, ExtSoundDevStr, FlagPassStr, ExtMixerLibBase ));
}
