/* TuComposer OS independent code
**
** $VER: InsertNode.c 31.22 (5.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

void InsertNode ( struct List *NodeList, struct Node *Node,
    struct Node *PredNode )
{
  struct Node *TmpNode;

  if ( PredNode == NULL )
  {
    AddNodeHead ( NodeList, Node );

    return;
  }

  if (!( TmpNode = PredNode->ln_Succ ))
  {
    Node->ln_Succ = (struct Node *) &(PredNode->ln_Succ);

    TmpNode = PredNode->ln_Pred;
    Node->ln_Pred = (struct Node *) &(TmpNode->ln_Succ);

    PredNode->ln_Pred = (struct Node *) &(Node->ln_Succ);
    TmpNode->ln_Succ = (struct Node *) &(Node->ln_Succ);

    return;
  }

  Node->ln_Succ = (struct Node *) &(TmpNode->ln_Succ);
  Node->ln_Pred = (struct Node *) &(PredNode->ln_Succ);

  TmpNode->ln_Pred = (struct Node *) &(Node->ln_Succ);
  PredNode->ln_Succ = (struct Node *) &(Node->ln_Succ);
}
