/* TuComposer OS independent code
**
** $VER: PlaySoundDevice.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_devicebase_protos.h>

extern struct TuComposerExtList *InternalSoundDevice;

ULONG PlaySoundDevice ( struct TuComposerExtList *ExtLibStr,
    struct MixerAllocStruct *MixAllocStr, union FlagPass *FlagPassStr )
{
  struct SoundDeviceInfo *ExtDeviceLibBase;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalSoundDevice);

  ExtDeviceLibBase = (struct SoundDeviceInfo *) ExtLibStr->extl_LibBase;
  return ( ExternalDevicePlayBase ( MixAllocStr, FlagPassStr, ExtDeviceLibBase ));
}
