/* TuComposer OS independent code
**
** $VER: ReMapNodeList.c 31.22 (6.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

void ReMapNodeList ( struct List *SrcNodeList, struct List *DestNodeList )
{
  struct Node *TmpSrcNode, *TmpDestNode;

  if (!( SrcNodeList && DestNodeList ))
    return;

  if (!(( TmpDestNode = (struct Node *) SrcNodeList->lh_Head) && TmpDestNode->ln_Succ ))
  {
    InitNodeList ( DestNodeList );
    return;
  }

  TmpDestNode->ln_Pred = (struct Node *) &(DestNodeList->lh_Head);
  DestNodeList->lh_Head = (struct Node *) &(TmpDestNode->ln_Succ);
  TmpSrcNode = (struct Node *) SrcNodeList->lh_TailPred;
  TmpSrcNode->ln_Succ = (struct Node *) &(DestNodeList->lh_Tail);
  DestNodeList->lh_Tail = NULL;
  DestNodeList->lh_TailPred = (struct Node *) &(TmpSrcNode->ln_Succ);

  return;
}
