/* TuComposer OS independent code
**
** $VER: SetPostProcessorPri.c 31.22 (1.3.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

void SetPostProcessorPri ( struct PostProcAllocStruct *PostAllocStr,
    long Pri )
{
 if ( PostAllocStr->pas_Node.mln_Succ )
  {
    struct PostProcAllocStruct *PostProcList = PostAllocStr;

    Disable ();

    RemoveNode ( (struct Node *) PostAllocStr );

    for (;;)
    {
      PostProcList = (struct PostProcAllocStruct *) PostProcList->pas_Node.mln_Pred;

      if (!( PostProcList->pas_Node.mln_Pred ))
        break;
    }

    PostAllocStr->pas_Pri = Pri;

    EnqueueNode ( (struct List *) PostProcList, (struct Node *) PostAllocStr );

    Enable ();
  }
}
