/* TuComposer OS independent code
**
** $VER: UpdateSoundDeviceRate.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_devicebase_protos.h>

extern struct TuComposerExtList *InternalSoundDevice;

void UpdateSoundDeviceRate ( struct TuComposerExtList *ExtLibStr,
    unsigned long SmpRate )
{
  struct SoundDeviceInfo *ExtDeviceLibBase;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalSoundDevice);

  ExtDeviceLibBase = (struct SoundDeviceInfo *) ExtLibStr->extl_LibBase;

  Disable();

  ExternalDeviceUpdateRateBase ( SmpRate, ExtDeviceLibBase );

  Enable();
}
