/* TuComposer OS independent code
**
** $VER: CopyTCModule.c 31.22 (4.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerModule *DoDupTCModule ( struct TuComposerModule *ModuleStr, struct TuComposerModule *CloneModule );

extern struct TuComposerBase *TuCBase;

struct TuComposerModule *CopyTCModule ( struct TuComposerModule *ModuleStr,
    struct TuComposerModule *ModuleBuf )
{
 if ( ModuleBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_ModuleSigSem );

    ClearTCModule ( ModuleBuf );
    ModuleBuf = DoDupTCModule ( ModuleStr, ModuleBuf );

    ReleaseSemaphore ( TuCBase->tcb_ModuleSigSem );

    return ( ModuleBuf );
  }

  return ( PushTCModule ( ModuleStr ));
}
