/* TuComposer OS independent code
**
** $VER: CutTCModule.c 31.22 (4.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerModule *CutTCModule ( struct TuComposerModule *ModuleStr,
    struct TuComposerModule *ModuleBuf )
{
  ObtainSemaphore ( TuCBase->tcb_ModuleSigSem );

  if ( ModuleBuf = CopyTCModule ( ModuleStr, ModuleBuf ))
    ClearTCModule ( ModuleStr );

  ReleaseSemaphore ( TuCBase->tcb_ModuleSigSem );

  return ( ModuleBuf );
}
