/* TuComposer OS independent code
**
** $VER: GetTCModules.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_modulebase_protos.h>

ULONG GetTCModules ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr )
{
  ULONG NumModules = 0L;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifyTCModule ( CFHandle );

    if ( ExtLibStr )
    {
      struct ModuleLibrary *ExtModuleLibBase;

      if ( (ExtModuleLibBase = (struct ModuleLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        NumModules = ExternalModuleGetNumsBase ( CFHandle, ExtModuleLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( NumModules );
}
