/* TuComposer OS independent code
**
** $VER: LoadTCModule.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_modulebase_protos.h>

struct TuComposerModule *LoadTCModule ( struct CFHandle *CFHandle,
    struct TuComposerModule *ModuleStr,
    struct TuComposerExtList *ExtLibStr, union FlagPass *FlagPassStr,
    unsigned long NumModule )
{
  struct TuComposerModule *LoadModuleStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifyTCModule ( CFHandle );

    if ( ExtLibStr )
    {
      struct ModuleLibrary *ExtModuleLibBase;

      if ( (ExtModuleLibBase = (struct ModuleLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        LoadModuleStr = ExternalModuleLoadBase ( CFHandle, ModuleStr, FlagPassStr, NumModule, ExtModuleLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( LoadModuleStr );
}
