/* TuComposer OS independent code
**
** $VER: PasteTCModule.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerModule *DoDupTCModule ( struct TuComposerModule *ModuleStr, struct TuComposerModule *CloneModule );

extern struct TuComposerBase *TuCBase;

struct TuComposerModule *PasteTCModule ( struct TuComposerModule *ModuleBuf,
    struct TuComposerModule *ModuleStr )
{
  ObtainSemaphoreShared ( TuCBase->tcb_ModuleSigSem );

  if ( ModuleStr )
    ClearTCModule ( ModuleStr );

  ModuleStr = DoDupTCModule ( ModuleBuf, ModuleStr );

  ReleaseSemaphore ( TuCBase->tcb_ModuleSigSem );

  return ( ModuleStr );
}
