/* TuComposer OS independent code
**
** $VER: RemTCModule.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG RemTCModule ( struct TuComposerModule *ModuleStr )
{
  if ( ModuleStr )
  {
    ObtainSemaphore ( TuCBase->tcb_ModuleListSigSem );

    RemoveNode ( (struct Node *) ModuleStr );

    ModuleStr->tcm_Node.mln_Succ = NULL;
    ModuleStr->tcm_Node.mln_Pred = NULL;

    ReleaseSemaphore ( TuCBase->tcb_ModuleListSigSem );

    return ( 0L );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
