/* TuComposer OS independent code
**
** $VER: SaveTCModule.c 31.22 (2.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_modulebase_protos.h>

extern struct TuComposerExtList *InternalTCM;

ULONG SaveTCModule ( struct CFHandle *CFHandle,
    struct TuComposerModule *ModuleStr,
    struct TuComposerExtList *ExtLibStr, union FlagPass *FlagPassStr )
{
  struct ModuleLibrary *ExtModuleLibBase;
  ULONG RC = ERROR_EXTLIB_NOOPEN;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalTCM);

  if ( (ExtModuleLibBase = (struct ModuleLibrary *) OpenExternalLib ( ExtLibStr )))
  {
    RC = ExternalModuleSaveBase ( CFHandle, ModuleStr, FlagPassStr, ExtModuleLibBase );

    CloseExternalLib ( ExtLibStr );
  }

  return ( RC );
}
