/* TuComposer Count play time Amiga Shared-Library function prototypes.
**
** $VER: CalcSongPlayTime_library.h 31.00 (27.1.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

ULONG ASM libChangeCountMixTempo ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __d0 unsigned long NewTempo GNUCREG(d0));
void ASM libGetCountChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0));
void ASM libSetCountChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0));
void ASM libSetCountChannelVol ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0));
void ASM libSetCountChannelPos ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0));
void ASM libCountMix ( register __a0 struct CountMixerAllocStruct *CntMixAllocStr GNUCREG(a0));

#ifdef __cplusplus
}
#endif

ULONG ASM libChangeCountMixTempo ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __d0 unsigned long NewTempo GNUCREG(d0))
{
  return ( ChangeCountMixTempo ( MixAllocStr, NewTempo ));
}

void ASM libGetCountChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0))
{
  GetCountChannel ( MixAllocStr, MixStr, Channel );
}

void ASM libSetCountChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0))
{
  SetCountChannel ( MixAllocStr, MixStr, Channel );
}

void ASM libSetCountChannelVol ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0))
{
  SetCountChannelVol ( MixAllocStr, MixStr, Channel );
}

void ASM libSetCountChannelPos ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0))
{
  SetCountChannelPos ( MixAllocStr, MixStr, Channel );
}

void ASM libCountMix ( register __a0 struct CountMixerAllocStruct *CntMixAllocStr GNUCREG(a0))
{
  CountMix ( CntMixAllocStr );
}

static struct JumpTable {
  struct JumpEntry {
    UWORD JumpInst;
    APTR  JumpPtr;
  } Jump[32];
} InternalMixerJumpTable =
{
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, libCountMix,
  0x4EF9, libSetCountChannelPos,
  0x4EF9, libSetCountChannelVol,
  0x4EF9, libSetCountChannel,
  0x4EF9, libGetCountChannel,
  0x4EF9, CountExtLib,
  0x4EF9, libChangeCountMixTempo,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib,
  0x4EF9, CountExtLib
};

struct MixerInfo CountMixLib =
{
  {{{NULL, NULL, NT_LIBRARY, 0, NULL},
      LIBF_SUMUSED, 0,
      0, 0,
      0, 0,
      NULL,
      NULL, 0},
    NULL,
    NULL,
    NULL},
  MIF_StereoSupport|MIF_Surround, 0,
  COUNT_MIXRATE,
  588,
  65536,
  COUNT_MIXRATE, COUNT_MIXRATE,
  588, 588,
  65535
};
