/* TuComposer OS independent code
**
** $VER: ClearPosition.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG ClearPosition ( struct TuComposerOrders *PosStr,
    unsigned long Channels )
{
  if ( PosStr )
  {
    ULONG Channel = 0L, i;

    if ( PosStr == TuCBase->tcb_PlaySong->tcso_Position )
    {
      StopTCModule ();
      FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
    }

    for (i = Channels; i > 0; i--)
    {
      ClearPositionChannel ( PosStr, Channel );

      Channel++;
    }

    return ( 0L );
  }

  return ( ERROR_POSITION_NOGIVEN );
}
