/* TuComposer OS independent code
**
** $VER: ClearPositionList.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ClearPositionList ( struct TuComposerOrderList *PosListStr )
{
  if ( PosListStr )
  {
    memset ( &(PosListStr->tcol_FirstRow), 0, offsetof (struct TuComposerOrderList, tcol_UserData ) - offsetof (struct TuComposerOrderList, tcol_FirstRow ));

    PosListStr->tcol_Volume = DEFAULTPOSVOLUME;
    PosListStr->tcol_LastRow = 0xFFFF;

    return ( 0L );
  }

  return ( ERROR_POSLIST_NOGIVEN );
}
