/* TuComposer OS independent code
**
** $VER: DeletePositionList.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG DeletePositionList ( struct TuComposerOrderList *PosListStr )
{
  if ( PosListStr )
  {
    struct TuComposerOrderList *PosListBuf;
    struct TuComposerOrderList *PosListTmp;

    PosListBuf = PosListStr;

    for (;;)
    {
      PosListBuf = (struct TuComposerOrderList *) PosListBuf->tcol_Node.mln_Pred;

      if (!( PosListBuf->tcol_Node.mln_Pred ))
        break;
    }

    for (;;)
    {
      PosListBuf = (struct TuComposerOrderList *) PosListBuf->tcol_Node.mln_Succ;

      if (!( PosListBuf->tcol_Node.mln_Succ ))
        break;

      if ( PosListBuf->tcol_NextPos == PosListStr )
      {
        PosListTmp = (struct TuComposerOrderList *) PosListBuf->tcol_Node.mln_Succ;

        if ( PosListTmp->tcol_Node.mln_Succ )
        {
          PosListBuf->tcol_NextPos = PosListTmp;
        } else
        {
          PosListBuf->tcol_NextPos = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Pred;
        }
      }

      if ( PosListBuf->tcol_PrevPos == PosListStr )
      {
        PosListTmp = (struct TuComposerOrderList *) PosListBuf->tcol_Node.mln_Succ;

        if ( PosListTmp->tcol_Node.mln_Succ )
        {
          PosListBuf->tcol_PrevPos = PosListTmp;
        } else
        {
          PosListBuf->tcol_PrevPos = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Pred;
        }
      }
    }

    RemoveNode ( (struct Node *) PosListStr );

    PosListStr->tcol_Node.mln_Succ = NULL;
    PosListStr->tcol_Node.mln_Pred = NULL;

    return ( 0L );
  }

  return ( ERROR_POSLIST_NOGIVEN );
}
