/* TuComposer OS independent code
**
** $VER: DupPositionList.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerOrderList *DupPositionList ( struct TuComposerOrderList
    *PosListStr )
{
  if ( PosListStr )
  {
    struct TuComposerOrderList *CloneListStr;

    if ( (CloneListStr = (struct TuComposerOrderList *) AllocPMem ( sizeof (struct TuComposerOrderList ))))
    {
      CloneListStr->tcol_Track = PosListStr->tcol_Track;

      memcpy ( &(CloneListStr->tcol_FirstRow), &(PosListStr->tcol_FirstRow), offsetof (struct TuComposerOrderList, tcol_UserData ) - offsetof (struct TuComposerOrderList, tcol_FirstRow ));

      CloneListStr->tcol_Played = 0;

      return ( CloneListStr );
    }
  }

  return ( NULL );
}
