/* TuComposer OS independent code
**
** $VER: FreePosition.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG FreePosition ( struct TuComposerOrders *PosStr,
    unsigned long Channels )
{
  if ( PosStr )
  {
    struct TuComposerOrders *PosFree;
    struct TuComposerOrderList *FreePosStr;
    ULONG i;

    if ( PosStr == TuCBase->tcb_PlaySong->tcso_Position )
    {
      StopTCModule ();
      FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
    }

    PosFree = PosStr;

    for (i = Channels; i > 0; i--)
    {
      for (;;)
      {
        FreePosStr = (struct TuComposerOrderList *) PosFree->tco_OrderData.mlh_Head;

        if (!( FreePosStr->tcol_Node.mln_Succ ))
          break;

        FreePositionList ( FreePosStr );
      }

      PosFree++;
    }

    FreePMem ( PosStr, Channels * sizeof (struct TuComposerOrders ));

    return ( 0L );
  }

  return ( ERROR_POSITION_NOGIVEN );
}
