/* TuComposer OS independent code
**
** $VER: GetPositionAddr.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerOrderList *GetPositionAddr ( struct TuComposerOrders
    *PosStr, unsigned long Channel, unsigned long Num )
{
  if ( PosStr && Num )
  {
    ULONG Count = 0L;

    PosStr += Channel;

    for (;;)
    {
      PosStr = (struct TuComposerOrders *) PosStr->tco_OrderData.mlh_Head;

      if (!( PosStr->tco_OrderData.mlh_Head ))
        break;

      Count++;

      if ( Count == Num )
        return ( (struct TuComposerOrderList *) PosStr );
    }
  }

  return ( NULL );
}
