/* TuComposer OS independent code
**
** $VER: InsertPositionList.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertPositionList ( struct TuComposerOrders *PosStr,
    struct TuComposerOrderList *PosListStr,
    struct TuComposerOrderList *PosListPos, unsigned long Channel )
{
  if ( PosStr )
  {
    if ( PosListStr )
    {
      PosStr += Channel;

      PosStr->tco_Length++;

      InsertNode ( (struct List *) PosStr, (struct Node *) PosListStr, (struct Node *) PosListPos );

      return ( 0L );
    }

    return ( ERROR_POSLIST_NOGIVEN );
  }

  return ( ERROR_POSITION_NOGIVEN );
}
