/* TuComposer OS independent code
**
** $VER: AddSample.c 31.22 (21.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddSample ( struct TuComposerInstr *InstrStr,
    struct TuComposerSample *SampleStr )
{
  if ( InstrStr )
  {
    if ( SampleStr )
    {
      if ( InstrStr->tci_NumSamples < LASTSAMPLEPERINSTR )
      {
        InstrStr->tci_NumSamples++;

        AddNodeTail ( (struct List *) &(InstrStr->tci_Samples), (struct Node *) SampleStr );

        return ( 0L );
      }

      return ( ERROR_SAMPLE_TOOMANY );
    }

    return ( ERROR_SAMPLE_NOGIVEN );
  }

  return ( ERROR_INSTR_NOGIVEN );
}
