/* TuComposer OS independent code
**
** $VER: AllocSample.c 31.22 (21.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSample *AllocSample ( WORD *SampleData,
    unsigned long Length )
{
  struct TuComposerSample *SampleStr;

  if ( (SampleStr = (struct TuComposerSample *) AllocPMem ( sizeof (struct TuComposerSample ))))
  {
    SampleStr->tcs_BitDepth = DEFAULTSAMPLEBITDEPTH;
    SampleStr->tcs_Rate = DEFAULTSAMPLERATE;
    SampleStr->tcs_GlobalVolume = DEFAULTSAMPLEVOLUME;
    SampleStr->tcs_Volume = DEFAULTSAMPLEVOLUME;
    SampleStr->tcs_Panning = DEFAULTSAMPLEPANNING;

    InitNodeList ( (struct List *) &(SampleStr->tcs_UnknownChunks));

    SampleStr->tcs_UpperRateLimit = 0xFFFFFFFF;

    if ( SampleData )
    {
      SampleStr->tcs_Flags = TCSF_Redirect;
      SampleStr->tcs_Data = SampleData;
    }

    SampleStr->tcs_Length = Length;

    if ( (SampleStr->tcs_Samples = Length ))
    {
      if ( SampleData == NULL )
      {
        if (!( SampleStr->tcs_Data = (WORD *) AllocSampleData ( Length )))
        {
          FreePMem ( SampleStr, sizeof (struct TuComposerSample ));

          SampleStr = NULL;
        }
      }
    }
  }

  return ( SampleStr );
}
