/* TuComposer OS independent code
**
** $VER: CutSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSample *CutSample ( struct TuComposerSample *SampleStr,
    struct TuComposerSample *SampleBuf )
{
  ObtainSemaphore ( TuCBase->tcb_SampleSigSem );

  if ( SampleBuf = CopySample ( SampleStr, SampleBuf ))
    ClearSample ( SampleStr );

  ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );

  return ( SampleBuf );
}
