/* TuComposer OS independent code
**
** $VER: GetNumSamples.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetNumSamples ( struct TuComposerInstr *InstrStr )
{
  ULONG Count = 0L;

  if ( InstrStr )
  {
    struct TuComposerSample *SampleStr;

    SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

    for (;;)
    {
      SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

      if (!( SampleStr->tcs_Node.mln_Succ ))
        break;

      Count++;
    }
  }

  return ( Count );
}
