/* TuComposer OS independent code
**
** $VER: GetSampleAddr.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSample *GetSampleAddr ( struct TuComposerInstr *InstrStr,
    unsigned long Num )
{
  if ( InstrStr && Num )
  {
    ULONG Cnt;
    struct TuComposerSample *SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

    for (Cnt = Num; Cnt > 0; Cnt--)
    {
      SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

      if (!( SampleStr->tcs_Node.mln_Succ ))
        return ( NULL );
    }

    return ( SampleStr );
  }

  return ( NULL );
}
