/* TuComposer OS independent code
**
** $VER: GetSampleNum.c 31.22 (4.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetSampleNum ( struct TuComposerInstr *InstrStr,
    struct TuComposerSample *SampleStr )
{
  ULONG SampleNum = 0L;

  if ( InstrStr && SampleStr )
  {
    struct TuComposerSample *SampleScan = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

    for (;;)
    {
      SampleScan = (struct TuComposerSample *) SampleScan->tcs_Node.mln_Succ;

      if (!( SampleScan->tcs_Node.mln_Succ))
        return ( 0L );

      SampleNum++;

      if (SampleStr == SampleScan)
        break;
    }
  }

  return ( SampleNum );
}
