/* TuComposer OS independent code
**
** $VER: InvertSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InvertSample ( struct TuComposerSample *SampleStr )
{
  if ( SampleStr = FindOriginSample ( SampleStr ))
  {
    LONG *SampleData;

    if ( (SampleData = (LONG *) SampleStr->tcs_Data ))
    {
      ULONG i;

      for ( i = (SampleStr->tcs_Length + SMP_BLOCKMASK) / SMP_BLOCKSIZE; i > 0; i--)
      {
        *SampleData++ = ~(*SampleData);
        *SampleData++ = ~(*SampleData);
      }

      return ( 0L );
    }

    return ( ERROR_SAMPLE_NODATA );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
