/* TuComposer OS independent code
**
** $VER: LoadSample.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_samplebase_protos.h>

struct TuComposerSample *LoadSample ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr, unsigned long NumSample )
{
  struct TuComposerSample *LoadSampleStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifySample ( CFHandle );

    if ( ExtLibStr )
    {
      struct SampleLibrary *ExtSampleLibBase;

      if ( (ExtSampleLibBase = (struct SampleLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        LoadSampleStr = ExternalSampleLoadBase ( CFHandle, SampleStr, FlagPassStr, NumSample, ExtSampleLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( LoadSampleStr );
}
