/* TuComposer OS independent code
**
** $VER: PasteSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSample *DoDupSample ( struct TuComposerSample *SampleStr, struct TuComposerSample *SampleBuf );

extern struct TuComposerBase *TuCBase;

struct TuComposerSample *PasteSample ( struct TuComposerSample *SampleBuf,
    struct TuComposerSample *SampleStr )
{
  ObtainSemaphoreShared ( TuCBase->tcb_SampleSigSem );

  if ( SampleStr )
  {
    if ( ReSizeSample ( SampleBuf, SampleBuf->tcs_Samples ))
    {
      SampleStr = NULL;
      goto PasteSampleDone;
    }

    ClearSample ( SampleStr );
  }

  SampleStr = DoDupSample ( SampleBuf, SampleStr );

PasteSampleDone:

  ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );

  return ( SampleStr );
}
