/* TuComposer OS independent code
**
** $VER: PopSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG PopSample ( struct TuComposerSample *SampleBuf )
{
  if ( SampleBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_SampleSigSem );

    RemoveNode ( (struct Node *) &(SampleBuf->tcs_Node) );

    ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );

    SampleBuf->tcs_Node.mln_Succ = NULL;
    SampleBuf->tcs_Node.mln_Pred = NULL;

    return ( FreeSample ( SampleBuf ));
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}