/* TuComposer OS independent code
**
** $VER: RemSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemSample ( struct TuComposerInstr *InstrStr )
{
  if ( InstrStr )
  {
    if ( InstrStr->tci_NumSamples )
    {
      struct TuComposerSample *SampleStr = (struct TuComposerSample *) InstrStr->tci_Samples.mlh_TailPred;

      InstrStr->tci_NumSamples--;

      RemNodeTail ( (struct List *) &(InstrStr->tci_Samples));

      SampleStr->tcs_Node.mln_Succ = NULL;
      SampleStr->tcs_Node.mln_Pred = NULL;
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOGIVEN );
}