/* TuComposer OS independent code
**
** $VER: SaveSample.c 31.22 (6.11.01)
**
** (C) 2001 by Sebastian Vater (known as Basty/CDGS).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_samplebase_protos.h>

extern struct TuComposerExtList *InternalTCI;

ULONG SaveSample ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr )
{
  struct SampleLibrary *ExtSampleLibBase;
  ULONG RC = ERROR_EXTLIB_NOOPEN;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalTCI);

  if ( (ExtSampleLibBase = (struct SampleLibrary *) OpenExternalLib ( ExtLibStr )))
  {
    RC = ExternalSampleSaveBase ( CFHandle, SampleStr, FlagPassStr, ExtSampleLibBase );

    CloseExternalLib ( ExtLibStr );
  }

  return ( RC );
}
