/* TuComposer OS independent code
**
** $VER: CopySong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSong *DoDupSong ( struct TuComposerSong *SongStr, struct TuComposerSong *CloneSong );

extern struct TuComposerBase *TuCBase;

struct TuComposerSong *CopySong ( struct TuComposerSong *SongStr,
    struct TuComposerSong *SongBuf )
{
  if ( SongBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_SongSigSem );

    ClearSong ( SongBuf );
    SongBuf = DoDupSong ( SongStr, SongBuf );

    ReleaseSemaphore ( TuCBase->tcb_SongSigSem );

    return ( SongBuf );
  }

  return ( PushSong ( SongStr ));
}
