/* TuComposer OS independent code
**
** $VER: CutSong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSong *CutSong ( struct TuComposerSong *SongStr,
    struct TuComposerSong *SongBuf )
{
  ObtainSemaphore ( TuCBase->tcb_SongSigSem );

  if ( SongBuf = CopySong ( SongStr, SongBuf ))
    ClearSong ( SongStr );

  ReleaseSemaphore ( TuCBase->tcb_SongSigSem );

  return ( SongBuf );
}
