/* TuComposer OS independent code
**
** $VER: DeleteSong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG DeleteSong ( struct TuComposerSong *SongStr )
{
  if ( SongStr )
  {
    if ( SongStr == TuCBase->tcb_PlaySong )
    {
      StopTCModule ();
      FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
    }

    RemoveNode ( (struct Node *) SongStr );

    SongStr->tcso_Node.mln_Succ = NULL;
    SongStr->tcso_Node.mln_Pred = NULL;

    return ( 0L );
  }

  return ( ERROR_SONG_NOGIVEN );
}
