/* TuComposer OS independent code
**
** $VER: FreeSongInstrs.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeSongInstrs ( struct TuComposerInstr **InstrList )
{
  struct TuComposerInstr **InstrFree = InstrList;
  ULONG Count = 0L;

  if ( InstrList )
  {
    for (;;)
    {
      Count++;

      if (!( *InstrList++ ))
        break;
    }

    FreePMem ( InstrFree, Count * sizeof (struct TuComposerInstr *));

    return ( 0L );
  }

  return ( ERROR_INSTR_NOGIVEN );
}
