/* TuComposer OS independent code
**
** $VER: GetNumSongs.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetNumSongs ( struct TuComposerModule *ModuleStr )
{
  ULONG Count = 0L;

  if ( ModuleStr )
  {
    struct TuComposerSong *SongStr;

    SongStr = (struct TuComposerSong *) &(ModuleStr->tcm_SongList.mlh_Head);

    for (;;)
    {
      SongStr = (struct TuComposerSong *) SongStr->tcso_Node.mln_Succ;

      if (!( SongStr->tcso_Node.mln_Succ ))
        break;

      Count++;
    }
  }

  return ( Count );
}
