/* TuComposer OS independent code
**
** $VER: GetSongAddr.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSong *GetSongAddr ( struct TuComposerModule *ModuleStr,
    unsigned long Num )
{
  if ( ModuleStr && Num )
  {
    ULONG Cnt;
    struct TuComposerSong *SongStr = (struct TuComposerSong *) &(ModuleStr->tcm_SongList.mlh_Head);

    for (Cnt = Num; Cnt > 0; Cnt--)
    {
      SongStr = (struct TuComposerSong *) SongStr->tcso_Node.mln_Succ;

      if (!( SongStr->tcso_Node.mln_Succ ))
        return ( NULL );
    }

    return ( SongStr );
  }

  return ( NULL );
}
