/* TuComposer OS independent code
**
** $VER: GetSongs.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_songbase_protos.h>

ULONG GetSongs ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr )
{
  ULONG NumSongs = 0L;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifySong ( CFHandle );

    if ( ExtLibStr )
    {
      struct SongLibrary *ExtSongLibBase;

      if ( (ExtSongLibBase = (struct SongLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        NumSongs = ExternalSongGetNumsBase ( CFHandle, ExtSongLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( NumSongs );
}
