/* TuComposer OS independent code
**
** $VER: PasteSong.c 31.22 (4.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSong *DoDupSong ( struct TuComposerSong *SongStr, struct TuComposerSong *CloneSong );

extern struct TuComposerBase *TuCBase;

struct TuComposerSong *PasteSong ( struct TuComposerSong *SongBuf,
    struct TuComposerSong *SongStr )
{
  ObtainSemaphoreShared ( TuCBase->tcb_SongSigSem );

  if ( SongStr )
    ClearSong ( SongStr );

  SongStr = DoDupSong ( SongBuf, SongStr );

  ReleaseSemaphore ( TuCBase->tcb_SongSigSem );

  return ( SongStr );
}
