/* TuComposer OS independent code
**
** $VER: PopSong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG PopSong ( struct TuComposerSong *SongBuf )
{
  if ( SongBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_SongSigSem );

    RemoveNode ( (struct Node *) &(SongBuf->tcso_Node) );

    ReleaseSemaphore ( TuCBase->tcb_SongSigSem );

    SongBuf->tcso_Node.mln_Succ = NULL;
    SongBuf->tcso_Node.mln_Pred = NULL;

    return ( FreeSong ( SongBuf ));
  }

  return ( ERROR_SONG_NOGIVEN );
}
