/* TuComposer OS independent code
**
** $VER: PushSong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSong *PushSong ( struct TuComposerSong *SongStr )
{
  if ( SongStr )
  {
    SongStr = DupSong ( SongStr );
  } else
  {
    SongStr = AllocSong ( 0L, 0L, 0L );
  }

  if ( SongStr )
  {
    ObtainSemaphore ( TuCBase->tcb_SongSigSem );

    AddNodeHead ( (struct List *) &(TuCBase->tcb_SongBuf), (struct Node *) &(SongStr->tcso_Node) );

    ReleaseSemaphore ( TuCBase->tcb_SongSigSem );
  }

  return ( SongStr );
}
