/* TuComposer OS independent code
**
** $VER: RemSong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG RemSong ( struct TuComposerModule *ModuleStr )
{
  if ( ModuleStr )
  {
    struct TuComposerSong *SongStr = (struct TuComposerSong *) ModuleStr->tcm_SongList.mlh_TailPred;

    if ( SongStr == TuCBase->tcb_PlaySong )
    {
      StopTCModule ();
      FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
    }

    RemNodeTail ( (struct List *) &(ModuleStr->tcm_SongList));

    SongStr->tcso_Node.mln_Succ = NULL;
    SongStr->tcso_Node.mln_Pred = NULL;

    return ( 0L );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
