/* TuComposer OS independent code
**
** $VER: SaveSong.c 31.22 (10.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_songbase_protos.h>

extern struct TuComposerExtList *InternalTCS;

ULONG SaveSong ( struct CFHandle *CFHandle, struct TuComposerSong *SongStr,
    struct TuComposerExtList *ExtLibStr, union FlagPass *FlagPassStr )
{
  struct SongLibrary *ExtSongLibBase;
  ULONG RC = ERROR_EXTLIB_NOOPEN;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalTCS);

  if ( (ExtSongLibBase = (struct SongLibrary *) OpenExternalLib ( ExtLibStr )))
  {
    RC = ExternalSongSaveBase ( CFHandle, SongStr, FlagPassStr, ExtSongLibBase );

    CloseExternalLib ( ExtLibStr );
  }

  return ( RC );
}
