/* TuComposer OS independent code
**
** $VER: SetBaseSongInstrs.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SetBaseSongInstrs ( struct TuComposerSong *SongStr,
    struct TuComposerTrack *TrackStr, unsigned long FirstInsNum )
{
  if ( SongStr )
  {
    struct TuComposerTrackData *TrackData;
    ULONG NumRows = 1L, i, j;

    FirstInsNum--;

    if ( TrackStr == NULL )
    {
      NumRows = 0x10000;
      TrackStr = (struct TuComposerTrack *) SongStr->tcso_TrackList.mlh_Head;

      if ( TrackStr->tct_Node.mln_Succ )
        goto NextReMapDone;
    }

    for (i = NumRows; i > 0; i--)
    {
      if ( (TrackData = TrackStr->tct_Data ))
      {
        for (j = (TrackStr->tct_Length) + 1; j > 0; j--)
        {
          if ( TrackData->tctd_Instrument )
          {
            if ( (TrackData->tctd_Instrument + FirstInsNum) < 0x10000 )
              TrackData->tctd_Instrument += FirstInsNum;
          }

          TrackData++;
        }
      }

      TrackStr = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Succ;

      if (!( TrackStr->tct_Node.mln_Succ ))
        break;
    }

NextReMapDone:

    return ( 0L );
  }

  return ( ERROR_SONG_NOGIVEN );
}
