/* TuComposer OS independent code
**
** $VER: AddWaveform.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddWaveform ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthWave *WaveformStr )
{
  if ( SynthStr )
  {
    if ( WaveformStr )
    {
      if ( SynthStr->tcy_NumWaves < MAXWAVEFORMSPERSYNTH )
      {
        SynthStr->tcy_NumWaves++;

        AddNodeTail ( (struct List *) &(SynthStr->tcy_Waves), (struct Node *) WaveformStr );

        return ( 0L );
      }

      return ( ERROR_SYNTH_TOOMANY );
    }

    return ( ERROR_SYNTH_NODATA );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
