/* TuComposer OS independent code
**
** $VER: AssignSymbol.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AssignSymbol ( struct TuComposerSynthSymbolTable *SymbolStr,
    STRPTR Name )
{
  if ( SymbolStr && Name )
  {
      STRPTR CheckName = Name;
      UBYTE TmpChar;

      TmpChar = *CheckName++;

      if ( (TmpChar == 0) || (TmpChar > 'z') || ((TmpChar > 'Z') && (TmpChar != '_') && (TmpChar < 'a')) || ((TmpChar != '.') && (TmpChar < '@')) )
        return ( ERROR_SYNTH_SYMNAME );

      while ( (TmpChar = *CheckName++ ) != 0 )
      {
        if ( ((TmpChar < '0') && (TmpChar != '.')) || (TmpChar > 'z') || ((TmpChar > 'Z') && (TmpChar != '_') && (TmpChar < 'a')) || ((TmpChar > '9') && (TmpChar < '@')) )
          return ( ERROR_SYNTH_SYMNAME );
      }

    if ( SetString ( (STRPTR *) &(SymbolStr->tsst_SymbolName), Name ))
      return ( 0L );

    return ( ERROR_SYNTH_NOMEM );
  }

  return ( ERROR_SYNTH_NODATA );
}
