/* TuComposer OS independent code
**
** $VER: AssignSynthCode.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AssignSynthCode ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthCode *SynthCodeStr, unsigned long Lines )
{
  if ( SynthStr )
  {
    if ( SynthCodeStr )
    {
      struct TuComposerSynthCode *OldSynthCodeStr = SynthStr->tcy_SynthCode;
      ULONG OldLines = SynthStr->tcy_CodeEntries;

      SynthStr->tcy_SynthCode = SynthCodeStr;
      SynthStr->tcy_CodeEntries = Lines;

      FreePMem ( OldSynthCodeStr, OldLines * sizeof (struct TuComposerSynthCode ));

      return ( 0L );
    }

    return ( ERROR_SYNTH_NODATA );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
