/* TuComposer OS independent code
**
** $VER: CopySynthCode.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSynth *CopySynthCode ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynth *SynthBuf )
{
  if ( SynthBuf )
  {
    struct TuComposerSynthCode *SynthCodeStr;

    ObtainSemaphore ( TuCBase->tcb_SynthSigSem );

    if ( (SynthCodeStr = DupSynthCode ( SynthStr )))
    {
      AssignSynthCode ( SynthBuf, SynthCodeStr, SynthStr->tcy_CodeEntries );
    } else
    {
      SynthBuf = NULL;
    }

    ReleaseSemaphore ( TuCBase->tcb_SynthSigSem );

    return ( SynthBuf );
  }

  return ( PushSynthCode ( SynthStr ));
}
