/* TuComposer OS independent code
**
** $VER: CutWaveform.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSynthWave *CutWaveform ( struct TuComposerSynthWave
    *WaveformStr, struct TuComposerSynthWave *WaveformBuf )
{
  ObtainSemaphore ( TuCBase->tcb_WavesSigSem );

  if ( WaveformBuf = CopyWaveform ( WaveformStr, WaveformBuf ))
    ClearWaveform ( WaveformStr );

  ReleaseSemaphore ( TuCBase->tcb_WavesSigSem );

  return ( WaveformBuf );
}
