/* TuComposer OS independent code
**
** $VER: DeleteWaveform.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG DeleteWaveform ( struct TuComposerSynthWave *WaveformStr )
{
  if ( WaveformStr )
  {
    struct TuComposerSynth *SynthStr;

    SynthStr = (struct TuComposerSynth *) &(WaveformStr->tcyw_Node.mln_Succ);

    for (;;)
    {
      SynthStr = (struct TuComposerSynth *) SynthStr->tcy_Node.mln_Pred;

      if (!( SynthStr->tcy_Node.mln_Pred ))
        break;
    }

    (UBYTE *) SynthStr += -offsetof (struct TuComposerSynth, tcy_Waves );

    SynthStr->tcy_NumWaves--;

    RemoveNode ( (struct Node *) WaveformStr );

    WaveformStr->tcyw_Node.mln_Succ = NULL;
    WaveformStr->tcyw_Node.mln_Pred = NULL;

    return ( 0L );
  }

  return ( ERROR_SYNTH_NODATA );
}
