/* TuComposer OS independent code
**
** $VER: DupSymbol.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynthSymbolTable *DupSymbol (
    struct TuComposerSynthSymbolTable *SymbolStr )
{
  struct TuComposerSynthSymbolTable *CloneSymbol = NULL;

  if ( SymbolStr )
  {
    if ( (CloneSymbol = (struct TuComposerSynthSymbolTable *) AllocPMem ( sizeof (struct TuComposerSynthSymbolTable ))))
    {
      memcpy ( &(CloneSymbol->tsst_SymbolValue), &(SymbolStr->tsst_SymbolValue), offsetof (struct TuComposerSynthSymbolTable, tsst_Reserved ) - offsetof (struct TuComposerSynthSymbolTable, tsst_SymbolValue ));

      if ( SymbolStr->tsst_SymbolName )
      {
        if (!(SetString ( (STRPTR *) &(CloneSymbol->tsst_SymbolName), SymbolStr->tsst_SymbolName )))
        {
          FreePMem ( CloneSymbol, sizeof (struct TuComposerSynthSymbolTable ));

          CloneSymbol = NULL;
        }
      }
    }
  }

  return ( CloneSymbol );
}
