/* TuComposer OS independent code
**
** $VER: FreeSynthInfo.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeSynthInfo ( struct SynthInfo *SynthInfoStr )
{
  if ( SynthInfoStr )
  {
    FreeNameStr ( SynthInfoStr->yi_FileName );
    FreeNameStr ( SynthInfoStr->yi_Name );

    FreePMem ( SynthInfoStr, sizeof (struct SynthInfo ));

    return ( 0L );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
