/* TuComposer OS independent code
**
** $VER: FreeWaveform.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeWaveform ( struct TuComposerSynthWave *WaveformStr )
{
  if ( WaveformStr )
  {
    if ( WaveformStr->tcyw_Node.mln_Succ )
      DeleteWaveform ( WaveformStr );

    FreePMem ( WaveformStr->tcyw_WaveData, WaveformStr->tcyw_Length );

    FreePMem ( WaveformStr, sizeof (struct TuComposerSynthWave ));

    return ( 0L );
  }

  return ( ERROR_SYNTH_NODATA );
}
