/* TuComposer OS independent code
**
** $VER: GetWaveformAddr.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynthWave *GetWaveformAddr ( struct TuComposerSynth
    *SynthStr, unsigned long WaveformNum )
{
  if ( SynthStr )
  {
    ULONG Cnt;
    struct TuComposerSynthWave *WaveformStr = (struct TuComposerSynthWave *) &(SynthStr->tcy_Waves.mlh_Head);

    for (Cnt = WaveformNum; Cnt > 0; Cnt--)
    {
      WaveformStr = (struct TuComposerSynthWave *) WaveformStr->tcyw_Node.mln_Succ;

      if (!( WaveformStr->tcyw_Node.mln_Succ ))
        return ( NULL );
    }

    return ( WaveformStr );
  }

  return ( NULL );
}
