/* TuComposer OS independent code
**
** $VER: GetWaveformNum.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetWaveformNum ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthWave *WaveformStr )
{
  ULONG WaveformNum = 0L;

  if ( SynthStr && WaveformStr )
  {
    struct TuComposerSynthWave *WaveformScan = (struct TuComposerSynthWave *) &(SynthStr->tcy_Waves.mlh_Head);

    for (;;)
    {
      WaveformScan = (struct TuComposerSynthWave *) WaveformScan->tcyw_Node.mln_Succ;

      if (!( WaveformScan->tcyw_Node.mln_Succ))
        return ( 0L );

      WaveformNum++;

      if (WaveformStr == WaveformScan)
        break;
    }
  }

  return ( WaveformNum );
}
