/* TuComposer OS independent code
**
** $VER: InsertWaveform.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertWaveform ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthWave *WaveformStr,
    struct TuComposerSynthWave *WaveformPos )
{
  if ( SynthStr )
  {
    if ( WaveformStr )
    {
      if ( SynthStr->tcy_NumWaves < MAXWAVEFORMSPERSYNTH )
      {
        SynthStr->tcy_NumWaves++;

        InsertNode ( (struct List *) &(SynthStr->tcy_Waves), (struct Node *) WaveformStr, (struct Node *) WaveformPos);

        return ( 0L );
      }

      return ( ERROR_SYNTH_TOOMANY );
    }

    return ( ERROR_SYNTH_NODATA );
  }

  return( ERROR_SYNTH_NOGIVEN );
}
