/* TuComposer OS independent code
**
** $VER: LoadSynth.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_synthbase_protos.h>

struct TuComposerSynth *LoadSynth ( struct CFHandle *CFHandle,
    struct TuComposerSynth *SynthStr,  struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr, unsigned long NumSynth )
{
  struct TuComposerSynth *LoadSynthStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifySynth ( CFHandle );

    if ( ExtLibStr )
    {
      struct SynthLibrary *ExtSynthLibBase;

      if ( (ExtSynthLibBase = (struct SynthLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        LoadSynthStr = ExternalSynthLoadBase ( CFHandle, SynthStr, FlagPassStr, NumSynth, ExtSynthLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( LoadSynthStr );
}
