/* TuComposer OS independent code
**
** $VER: PasteSynth.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynth *DoDupSynth ( struct TuComposerSynth *SynthStr, struct TuComposerSynth *CloneSynth );

extern struct TuComposerBase *TuCBase;

struct TuComposerSynth *PasteSynth ( struct TuComposerSynth *SynthBuf,
    struct TuComposerSynth *SynthStr )
{
  ObtainSemaphoreShared ( TuCBase->tcb_SynthSigSem );

  if ( SynthStr )
    ClearSynth ( SynthStr );

  SynthStr = DoDupSynth ( SynthBuf, SynthStr );

  ReleaseSemaphore ( TuCBase->tcb_SynthSigSem );

  return ( SynthStr );
}
