/* TuComposer OS independent code
**
** $VER: PopSynth.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG PopSynth ( struct TuComposerSynth *SynthBuf )
{
  if ( SynthBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_SynthSigSem );

    RemoveNode ( (struct Node *) &(SynthBuf->tcy_Node) );

    ReleaseSemaphore ( TuCBase->tcb_SynthSigSem );

    SynthBuf->tcy_Node.mln_Succ = NULL;
    SynthBuf->tcy_Node.mln_Pred = NULL;

    return ( FreeSynth ( SynthBuf ));
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
