/* TuComposer OS independent code
**
** $VER: SaveSynth.c 31.22 (8.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_synthbase_protos.h>

extern struct TuComposerExtList *InternalTCY;

ULONG SaveSynth ( struct CFHandle *CFHandle,
    struct TuComposerSynth *SynthStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr )
{
  struct SynthLibrary *ExtSynthLibBase;
  ULONG RC = ERROR_EXTLIB_NOOPEN;

  if (!( ExtLibStr ))
    ExtLibStr = (struct TuComposerExtList *) &(InternalTCY);

  if ( (ExtSynthLibBase = (struct SynthLibrary *) OpenExternalLib ( ExtLibStr )))
  {
    RC = ExternalSynthSaveBase ( CFHandle, SynthStr, FlagPassStr, ExtSynthLibBase );

    CloseExternalLib ( ExtLibStr );
  }

  return ( RC );
}
