/* TuComposer OS independent code
**
** $VER: CopyTrack.c 31.22 (11.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerTrack *DoDupTrack ( struct TuComposerTrack *TrackStr, struct TuComposerTrack *CloneTrack );

extern struct TuComposerBase *TuCBase;

struct TuComposerTrack *CopyTrack ( struct TuComposerTrack *TrackStr,
    struct TuComposerTrack *TrackBuf )
{
  if ( TrackBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_TrackSigSem );

    if (!( ReSizeTrack ( TrackBuf, (TrackStr->tct_Length + 1))))
    {
      ClearTrack ( TrackBuf );
      TrackBuf = DoDupTrack ( TrackStr, TrackBuf );

      ReleaseSemaphore ( TuCBase->tcb_TrackSigSem );

      return ( TrackBuf );
    }

    ReleaseSemaphore ( TuCBase->tcb_TrackSigSem );

    return ( NULL );
  }

  return ( PushTrack ( TrackStr ));
}
