/* TuComposer OS independent code
**
** $VER: CutTrack.c 31.22 (11.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerTrack *CutTrack ( struct TuComposerTrack *TrackStr,
    struct TuComposerTrack *TrackBuf )
{
  ObtainSemaphore ( TuCBase->tcb_TrackSigSem );

  if ( TrackBuf = CopyTrack ( TrackStr, TrackBuf ))
    ClearTrack ( TrackStr );

  ReleaseSemaphore ( TuCBase->tcb_TrackSigSem );

  return ( TrackBuf );
}
