/* TuComposer OS independent code
**
** $VER: FreeTrackInfo.c 31.22 (25.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeTrackInfo ( struct TrackInfo *TrackInfoStr )
{
  if ( TrackInfoStr )
  {
    FreeNameStr ( TrackInfoStr->trki_FileName );
    FreeNameStr ( TrackInfoStr->trki_Name );

    FreePMem ( TrackInfoStr, sizeof (struct TrackInfo ));

    return (0);
  }

  return ( ERROR_TRACK_NOGIVEN );
}
