/* TuComposer OS independent code
**
** $VER: GetNumTracks.c 31.22 (25.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetNumTracks ( struct TuComposerSong *SongStr )
{
  ULONG Count = 0L;

  if ( SongStr )
  {
    struct TuComposerTrack *TrackStr;

    TrackStr = (struct TuComposerTrack *) &(SongStr->tcso_TrackList.mlh_Head);

    for (;;)
    {
      TrackStr = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Succ;

      if (!( TrackStr->tct_Node.mln_Succ ))
        break;

      Count++;
    }
  }

  return ( Count );
}
