/* TuComposer OS independent code
**
** $VER: GetTrackNum.c 31.22 (25.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetTrackNum ( struct TuComposerSong *SongStr,
   struct TuComposerTrack *TrackStr )
{
  ULONG TrackNum = 0L;

  if ( SongStr && TrackStr )
  {
    struct TuComposerTrack *TrackScan = (struct TuComposerTrack *) &(SongStr->tcso_TrackList.mlh_Head);

    for (;;)
    {
      TrackScan = (struct TuComposerTrack *) TrackScan->tct_Node.mln_Succ;

      if (!( TrackScan->tct_Node.mln_Succ))
        return ( 0L );

      TrackNum++;

      if (TrackStr == TrackScan)
        break;
    }
  }

  return ( TrackNum );
}
