/* TuComposer OS independent code
**
** $VER: GetTracks.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_trackbase_protos.h>

ULONG GetTracks ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr )
{
  ULONG NumTracks = 0L;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifyTrack ( CFHandle );

    if ( ExtLibStr )
    {
      struct TrackLibrary *ExtTrackLibBase;

      if ( (ExtTrackLibBase = (struct TrackLibrary *) OpenExternalLib ( ExtLibStr )))
      {
        NumTracks = ExternalTrackGetNumsBase ( CFHandle, ExtTrackLibBase );

        CloseExternalLib ( ExtLibStr );
      }
    }
  }

  return ( NumTracks );
}
