/* TuComposer OS independent code
**
** $VER: HalveTrack.c 31.22 (25.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG HalveTrack ( struct TuComposerTrack *TrackStr, unsigned long Scale )
{
  if ( TrackStr )
  {
    if ( Scale )
    {
      if ( Scale == 1 )
        return ( 0L );

      return ( ReSizeTrack ( TrackStr, (TrackStr->tct_Length + 1) / Scale ));
    }

    return ( ERROR_TRACK_NOSCALE );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
