/* TuComposer OS independent code
**
** $VER: IndexToNote.c 31.22 (27.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG IndexToNote ( unsigned long IndexNote )
{
  UWORD Octave;

  if ( (Octave = (IndexNote / NUMNOTES)) > LASTOCTAVE )
    return ( ERROR_TRACK_INVALID_OCTAVE );

  return ( (Octave << 16) | (IndexNote % NUMNOTES) + 1);
}
