/* TuComposer OS independent code
**
** $VER: NoteToIndex.c 31.22 (29.5.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG NoteToIndex ( unsigned long Octave, unsigned long Note )
{
  if ( Note && Note < NUMNOTES )
  {
    if ( Octave < NUMOCTAVES )
      return ( (Octave * LASTNOTE) + Note - 1);

    return ( ERROR_TRACK_INVALID_OCTAVE );
  }

  return ( ERROR_TRACK_INVALID_NOTE );
}
