/* TuComposer OS independent code
**
** $VER: PasteTrack.c 31.22 (13.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerTrack *DoDupTrack ( struct TuComposerTrack *TrackStr, struct TuComposerTrack *CloneTrack );

extern struct TuComposerBase *TuCBase;

struct TuComposerTrack *PasteTrack (  struct TuComposerTrack *TrackBuf,
    struct TuComposerTrack *TrackStr )
{
  ObtainSemaphoreShared ( TuCBase->tcb_TrackSigSem );

  if ( TrackStr )
  {
    if ( ReSizeTrack ( TrackBuf, (TrackBuf->tct_Length) + 1))
    {
      TrackStr = NULL;
      goto PasteTrackDone;
    }

    ClearTrack ( TrackStr );
  }

  TrackStr = DoDupTrack ( TrackBuf, TrackStr );

PasteTrackDone:

  ReleaseSemaphore ( TuCBase->tcb_TrackSigSem );

  return ( TrackStr );
}
