/* TuComposer OS independent code
**
** $VER: PopTrack.c 31.22 (13.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG PopTrack ( struct TuComposerTrack *TrackBuf )
{
  if ( TrackBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_TrackSigSem );

    RemoveNode ( (struct Node *) &(TrackBuf->tct_Node) );

    ReleaseSemaphore ( TuCBase->tcb_TrackSigSem );

    TrackBuf->tct_Node.mln_Succ = NULL;
    TrackBuf->tct_Node.mln_Pred = NULL;

    return ( FreeTrack ( TrackBuf ));
  }

  return ( ERROR_TRACK_NOGIVEN );
}
