/* TuComposer OS independent code
**
** $VER: ReMapTrack.c 31.22 (9.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReMapTrack ( struct TuComposerSong *SongStr,
    struct TuComposerTrack *TrackStr, struct TuComposerTrack *NewTrackStr )
{
  if (!( SongStr ))
    return ( ERROR_SONG_NOGIVEN );

  if ( TrackStr )
  {
    struct TuComposerOrders *PosStr;
    ULONG i;

    PosStr = SongStr->tcso_Position;

    for ( i = SongStr->tcso_Channels; i > 0; i--)
    {
      struct TuComposerOrderList *OrderList;

      OrderList = (struct TuComposerOrderList *) &(PosStr->tco_OrderData.mlh_Head);

      for (;;)
      {
        OrderList = (struct TuComposerOrderList *) OrderList->tcol_Node.mln_Succ;

        if ( (struct TuComposerOrderList *) OrderList->tcol_Node.mln_Succ )
          break;

        if ( OrderList->tcol_Track == TrackStr )
          OrderList->tcol_Track = NewTrackStr;
      }

      PosStr++;
    }

    return ( NULL );

  }

  return ( ERROR_TRACK_NOGIVEN );
}
