/* TuComposer OS independent code
**
** $VER: ReSizeTrack.c 31.22 (13.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReSizeTrack ( struct TuComposerTrack *TrackStr, unsigned long NewLen )
{
  if ( TrackStr )
  {
    if ( NewLen == NULL )
      NewLen = DEFAULTTRACKROWS;

    if ( NewLen <= MAXTRACKROWS )
    {
      ULONG Length = (TrackStr->tct_Length) + 1, RC = 0L;

      if ( NewLen < Length )
      {
        RC = RemRows ( TrackStr, Length - NewLen );
      } else if ( NewLen > Length )
      {
        RC = AddRows ( TrackStr, NewLen - Length );
      }

      return ( RC );
    }

    return ( ERROR_TRACK_TOO_BIG );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
