#ifndef  CLIB_EXT_PROTOS_H
#define  CLIB_EXT_PROTOS_H

/*
**	$VER: ext_base_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

struct TuComposerExtLibBase *ExtLibOpen ( struct TuComposerExtLibBase *libBase );
ULONG ExternalInitializeBase ( struct TuComposerExtList *ExtLibStr, struct TuComposerExtLibBase *ExtLibBase );
ULONG ExternalUpdateFlagsBase ( union FlagPass *FlagPassStr, unsigned long FlagPassType,
    unsigned long FlagNum, struct TuComposerExtLibBase *ExtLibBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_PROTOS_H */
