#ifndef  CLIB_EXT_MODULE_PROTOS_H
#define  CLIB_EXT_MODULE_PROTOS_H

/*
**	$VER: ext_module_protos.h 31.00 (1.8.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_MODULE_H
#include "tucomposer/external/module.h"
#endif /* TUCOMPOSER_EXTERNAL_MODULE_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalModuleInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalModuleUpdateFlags ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
void ExternalModuleReserved0 ( void );
void ExternalModuleReserved1 ( void );

/* Specific external module loading/saving functions */

ULONG ExternalModuleIdentify ( struct CFHandle *CFHandle );
struct TuComposerModule *ExternalModuleLoad ( struct CFHandle *CFHandle,
    struct TuComposerModule *ModuleStr, union FlagPass *FlagPassStr,
    unsigned long NumModule );
ULONG ExternalModuleSave ( struct CFHandle *CFHandle,
    struct TuComposerModule *ModuleStr, union FlagPass *FlagPassStr );
ULONG ExternalModuleGetInfo ( struct CFHandle *CFHandle,
    struct ModuleInfo *ModuleInfo, unsigned long NumModule );
ULONG ExternalModuleGetNums ( struct CFHandle *CFHandle );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_MODULE_PROTOS_H */
