#ifndef  CLIB_EXT_PROTOS_H
#define  CLIB_EXT_PROTOS_H

/*
**	$VER: ext_protos.h 31.00 (1.8.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalUpdateFlags ( union FlagPass *FlagPassStr, unsigned long FlagPassType,
    unsigned long FlagNum );
void ExternalReserved0 ( void );
void ExternalReserved1 ( void );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_PROTOS_H */
