#ifndef  CLIB_EXT_SAMPLE_PROTOS_H
#define  CLIB_EXT_SAMPLE_PROTOS_H

/*
**	$VER: ext_samplebase_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_SAMPLE_H
#include "tucomposer/external/sample.h"
#endif /* TUCOMPOSER_EXTERNAL_SAMPLE_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalSampleInitializeBase ( struct TuComposerExtList *ExtLibStr, struct SampleLibrary *SampleBase );
ULONG ExternalSampleUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct SampleLibrary *SampleBase );

/* Specific external sample loading/saving functions */

ULONG ExternalSampleIdentifyBase ( struct CFHandle *CFHandle, struct SampleLibrary *SampleBase );
struct TuComposerSample *ExternalSampleLoadBase ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, union FlagPass *FlagPassStr,
    unsigned long NumSample, struct SampleLibrary *SampleBase );
ULONG ExternalSampleSaveBase ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, union FlagPass *FlagPassStr, struct SampleLibrary *SampleBase );
ULONG ExternalSampleGetInfoBase ( struct CFHandle *CFHandle,
    struct SampleInfo *SampleInfo, unsigned long NumSample, struct SampleLibrary *SampleBase );
ULONG ExternalSampleGetNumsBase ( struct CFHandle *CFHandle, struct SampleLibrary *SampleBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_SAMPLE_PROTOS_H */
