#ifndef  CLIB_EXT_SONG_PROTOS_H
#define  CLIB_EXT_SONG_PROTOS_H

/*
**	$VER: ext_songbase_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_SONG_H
#include "tucomposer/external/song.h"
#endif /* TUCOMPOSER_EXTERNAL_SONG_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalSongInitializeBase ( struct TuComposerExtList *ExtLibStr, struct SongLibrary *SongBase );
ULONG ExternalSongUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct SongLibrary *SongBase );

/* Specific external song loading/saving functions */

ULONG ExternalSongIdentifyBase ( struct CFHandle *CFHandle, struct SongLibrary *SongBase );
struct TuComposerSong *ExternalSongLoadBase ( struct CFHandle *CFHandle,
    struct TuComposerSong *SongStr, union FlagPass *FlagPassStr,
    unsigned long NumSong, struct SongLibrary *SongBase );
ULONG ExternalSongSaveBase ( struct CFHandle *CFHandle,
    struct TuComposerSong *SongStr, union FlagPass *FlagPassStr, struct SongLibrary *SongBase );
ULONG ExternalSongGetInfoBase ( struct CFHandle *CFHandle,
    struct SongInfo *SongInfo, unsigned long NumSong, struct SongLibrary *SongBase );
ULONG ExternalSongGetNumsBase ( struct CFHandle *CFHandle, struct SongLibrary *SongBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_SONG_PROTOS_H */
