#ifndef _INCLUDE_PRAGMA_EXT_DEVICE_LIB_H
#define _INCLUDE_PRAGMA_EXT_DEVICE_LIB_H

/*
**  $VER: ext_device_pragmas.h (01-Aug-99)
**
**  TuComposer pragma file for various compilers
*/

#ifndef CLIB_EXT_DEVICE_PROTOS_H
#include <clib/ext_device_protos.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined(AZTEC_C) || defined(__MAXON__) || defined(__STORM__)
#pragma amicall(ExtDeviceLibBase, 0x1E, ExternalDeviceInitialize(a0))
#pragma amicall(ExtDeviceLibBase, 0x24, ExternalDeviceUpdateFlags(a0, d0, d1))
#pragma amicall(ExtDeviceLibBase, 0x2A, ExternalDeviceReserved0())
#pragma amicall(ExtDeviceLibBase, 0x30, ExternalDeviceReserved1())
#pragma amicall(ExtDeviceLibBase, 0x36, ExternalDeviceAlloc(a0))
#pragma amicall(ExtDeviceLibBase, 0x3C, ExternalDeviceFree())
#pragma amicall(ExtDeviceLibBase, 0x42, ExternalDevicePlay(a0, a1))
#pragma amicall(ExtDeviceLibBase, 0x48, ExternalDeviceStop())
#pragma amicall(ExtDeviceLibBase, 0x4E, ExternalDeviceCheckRate(d0))
#pragma amicall(ExtDeviceLibBase, 0x54, ExternalDeviceCheckRateFraction(d0))
#pragma amicall(ExtDeviceLibBase, 0x5A, ExternalDeviceUpdateRate(d0))
#endif
#if defined(_DCC) || defined(__SASC)
#pragma libcall ExtDeviceLibBase ExternalDeviceInitialize 1e 801
#pragma libcall ExtDeviceLibBase ExternalDeviceUpdateFlags 24 10803
#pragma libcall ExtDeviceLibBase ExternalDeviceReserved0 2a 00
#pragma libcall ExtDeviceLibBase ExternalDeviceReserved1 30 00
#pragma libcall ExtDeviceLibBase ExternalDeviceAlloc 36 801
#pragma libcall ExtDeviceLibBase ExternalDeviceFree 3c 00
#pragma libcall ExtDeviceLibBase ExternalDevicePlay 42 9802
#pragma libcall ExtDeviceLibBase ExternalDeviceStop 48 00
#pragma libcall ExtDeviceLibBase ExternalDeviceCheckRate 4e 001
#pragma libcall ExtDeviceLibBase ExternalDeviceCheckRateFraction 54 001
#pragma libcall ExtDeviceLibBase ExternalDeviceUpdateRate 5a 001
#endif

#ifdef __cplusplus
}
#endif

#endif
