#ifndef _INCLUDE_PRAGMA_EXT_RECORDER_LIB_H
#define _INCLUDE_PRAGMA_EXT_RECORDER_LIB_H

/*
**  $VER: ext_recorder_pragmas.h (01-Aug-99)
**
**  TuComposer pragma file for various compilers
*/

#ifndef CLIB_EXT_RECORDER_PROTOS_H
#include <clib/ext_recorder_protos.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined(AZTEC_C) || defined(__MAXON__) || defined(__STORM__)
#pragma amicall(ExtRecorderLibBase, 0x1E, ExternalRecorderInitialize(a0))
#pragma amicall(ExtRecorderLibBase, 0x24, ExternalRecorderUpdateFlags(a0, d0, d1))
#pragma amicall(ExtRecorderLibBase, 0x2A, ExternalRecorderReserved0())
#pragma amicall(ExtRecorderLibBase, 0x30, ExternalRecorderReserved1())
#pragma amicall(ExtRecorderLibBase, 0x36, ExternalRecorderIdentify(a0))
#pragma amicall(ExtRecorderLibBase, 0x3C, ExternalRecorderLoad(a0, a1, a2, d0))
#pragma amicall(ExtRecorderLibBase, 0x42, ExternalRecorderSave(a0, a1, a2))
#pragma amicall(ExtRecorderLibBase, 0x48, ExternalRecorderGetInfo(a0, a1, d0))
#pragma amicall(ExtRecorderLibBase, 0x4E, ExternalRecorderGetNums(a0))
#endif
#if defined(_DCC) || defined(__SASC)
#pragma libcall ExtRecorderLibBase ExternalRecorderInitialize 1e 801
#pragma libcall ExtRecorderLibBase ExternalRecorderUpdateFlags 24 10803
#pragma libcall ExtRecorderLibBase ExternalRecorderReserved0 2a 00
#pragma libcall ExtRecorderLibBase ExternalRecorderReserved1 30 00
#pragma libcall ExtRecorderLibBase ExternalRecorderIdentify 36 801
#pragma libcall ExtRecorderLibBase ExternalRecorderLoad 3c 0a9804
#pragma libcall ExtRecorderLibBase ExternalRecorderSave 42 a9803
#pragma libcall ExtRecorderLibBase ExternalRecorderGetInfo 48 09803
#pragma libcall ExtRecorderLibBase ExternalRecorderGetNums 4e 801
#endif

#ifdef __cplusplus
}
#endif

#endif
