#ifndef _INCLUDE_PRAGMA_TUCOMPOSER_LIB_H
#define _INCLUDE_PRAGMA_TUCOMPOSER_LIB_H

/*
**  $VER: tucomposer_pragmas.h (29-Jul-99)
**
**  TuComposer pragma file for various compilers
*/

#ifndef CLIB_TUCOMPOSER_PROTOS_H
#include <clib/tucomposer_protos.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined(AZTEC_C) || defined(__MAXON__) || defined(__STORM__)
#pragma amicall(TuCBase,0x01E,AllocPMem(d0))
#pragma amicall(TuCBase,0x024,FreePMem(a1,d0))
#pragma amicall(TuCBase,0x02A,InitNodeList(a0))
#pragma amicall(TuCBase,0x030,InsertNode(a0,a1,a2))
#pragma amicall(TuCBase,0x036,AddNodeHead(a0,a1))
#pragma amicall(TuCBase,0x03C,AddNodeTail(a0,a1))
#pragma amicall(TuCBase,0x042,RemoveNode(a1))
#pragma amicall(TuCBase,0x048,RemNodeHead(a0))
#pragma amicall(TuCBase,0x04E,RemNodeTail(a0))
#pragma amicall(TuCBase,0x054,EnqueueNode(a0,a1))
#pragma amicall(TuCBase,0x05A,DupNodeList(a0,a1,d0))
#pragma amicall(TuCBase,0x060,ReMapNodeList(a0,a1))
#pragma amicall(TuCBase,0x066,AllocNameStr(a0))
#pragma amicall(TuCBase,0x06C,FreeNameStr(a0))
#pragma amicall(TuCBase,0x072,SetString(a0,a1))
#pragma amicall(TuCBase,0x078,SetNameStr(a0,a1))
#pragma amicall(TuCBase,0x07E,Sin(d0,d1))
#pragma amicall(TuCBase,0x084,Cos(d0,d1))
#pragma amicall(TuCBase,0x08A,Tan(d0,d1))
#pragma amicall(TuCBase,0x090,DoPlayerIRQ(a0))
#pragma amicall(TuCBase,0x096,AddPlayExecHandler(a0))
#pragma amicall(TuCBase,0x09C,RemPlayExecHandler(a0))
#pragma amicall(TuCBase,0x0A2,SetPlayExecHandlerPri(a0,d0))
#pragma amicall(TuCBase,0x0A8,Stamp2Date(a0,a1))
#pragma amicall(TuCBase,0x0AE,AllocSimulateMix(a0))
#pragma amicall(TuCBase,0x0B4,FreeSimulateMix(a0))
#pragma amicall(TuCBase,0x0BA,AllocUnknownChunk(a0,d0,d1))
#pragma amicall(TuCBase,0x0C0,FreeUnknownChunk(a0))
#pragma amicall(TuCBase,0x0C6,DeleteUnknownChunk(a0))
#pragma amicall(TuCBase,0x0CC,Randomize(d0))
#pragma amicall(TuCBase,0x0D2,Rnd(d0))
#pragma amicall(TuCBase,0x0D8,AllocSoundDevice(a0,a1))
#pragma amicall(TuCBase,0x0DE,FreeSoundDevice(a0))
#pragma amicall(TuCBase,0x0E4,PlaySoundDevice(a0,a1,a2))
#pragma amicall(TuCBase,0x0EA,StopSoundDevice(a0))
#pragma amicall(TuCBase,0x0F0,CheckSoundDeviceRate(a0,d0))
#pragma amicall(TuCBase,0x0F6,CheckSoundDeviceRateFraction(a0,d0))
#pragma amicall(TuCBase,0x0FC,UpdateSoundDeviceRate(a0,d0))
#pragma amicall(TuCBase,0x102,AllocMixer(a0))
#pragma amicall(TuCBase,0x108,FreeMixer(a0))
#pragma amicall(TuCBase,0x10E,InitMixer(a0,a1,a2))
#pragma amicall(TuCBase,0x114,ChangeMixerRate(a0,d0))
#pragma amicall(TuCBase,0x11A,ChangeMixerTempo(a0,d0))
#pragma amicall(TuCBase,0x120,ChangeMixerVolTable(a0,d0,d1,d2,d3))
#pragma amicall(TuCBase,0x126,GetMixChannel(a1,a0,d0))
#pragma amicall(TuCBase,0x12C,SetMixChannel(a1,a0,d0))
#pragma amicall(TuCBase,0x132,SetMixChannelVolPanPitch(a1,a0,d0))
#pragma amicall(TuCBase,0x138,SetMixChannelPosRepFlags(a1,a0,d0))
#pragma amicall(TuCBase,0x13E,DoMix(a0,a1))
#pragma amicall(TuCBase,0x144,AllocPostProcessor(a0,a1))
#pragma amicall(TuCBase,0x14A,FreePostProcessor(a0))
#pragma amicall(TuCBase,0x150,InitPostProcessor(a0,a1,a2))
#pragma amicall(TuCBase,0x156,ChangePostProcessor(a0,a1))
#pragma amicall(TuCBase,0x15C,DoPostProcessorMix(a0,a2))
#pragma amicall(TuCBase,0x162,AddPostProcessor(a0,a1))
#pragma amicall(TuCBase,0x168,RemPostProcessor(a0))
#pragma amicall(TuCBase,0x16E,SetPostProcessorPri(a0,d0))
#pragma amicall(TuCBase,0x174,AllocTCModule(d0))
#pragma amicall(TuCBase,0x17A,FreeTCModule(a0))
#pragma amicall(TuCBase,0x180,AddTCModule(a0))
#pragma amicall(TuCBase,0x186,RemTCModule(a0))
#pragma amicall(TuCBase,0x18C,DupTCModule(a0))
#pragma amicall(TuCBase,0x192,ReMapTCModule(a0,a1))
#pragma amicall(TuCBase,0x198,LoadTCModule(a0,a1,a2,a3,d0))
#pragma amicall(TuCBase,0x19E,SaveTCModule(a0,a1,a2,a3))
#pragma amicall(TuCBase,0x1A4,IdentifyTCModule(a0))
#pragma amicall(TuCBase,0x1AA,GetTCModuleInfo(a0,a1,d0))
#pragma amicall(TuCBase,0x1B0,FreeTCModuleInfo(a0))
#pragma amicall(TuCBase,0x1B6,GetTCModules(a0,a1))
#pragma amicall(TuCBase,0x1BC,PushTCModule(a0))
#pragma amicall(TuCBase,0x1C2,PopTCModule(a0))
#pragma amicall(TuCBase,0x1C8,CutTCModule(a0,a1))
#pragma amicall(TuCBase,0x1CE,CopyTCModule(a0,a1))
#pragma amicall(TuCBase,0x1D4,PasteTCModule(a0,a1))
#pragma amicall(TuCBase,0x1DA,SwapTCModule(a0,a1))
#pragma amicall(TuCBase,0x1E0,ClearTCModule(a0))
#pragma amicall(TuCBase,0x1E6,AddTCModuleUnknownChunk(a0,a1))
#pragma amicall(TuCBase,0x1EC,RemTCModuleUnknownChunk(a0))
#pragma amicall(TuCBase,0x1F2,InsertTCModuleUnknownChunk(a0,a1,a2))
#pragma amicall(TuCBase,0x1F8,AllocPlayTCModule())
#pragma amicall(TuCBase,0x1FE,FreePlayTCModule())
#pragma amicall(TuCBase,0x204,PlayTCModule(a0))
#pragma amicall(TuCBase,0x20A,StopTCModule())
#pragma amicall(TuCBase,0x210,SetTCMChannels(a0,d0))
#pragma amicall(TuCBase,0x216,CalcTCMPlayTime(a0,a1))
#pragma amicall(TuCBase,0x21C,GetOptimalVChannels(a0))
#pragma amicall(TuCBase,0x222,AllocSong(d0,d1,d2))
#pragma amicall(TuCBase,0x228,FreeSong(a0))
#pragma amicall(TuCBase,0x22E,AddSong(a0,a1))
#pragma amicall(TuCBase,0x234,RemSong(a0))
#pragma amicall(TuCBase,0x23A,InsertSong(a0,a1,a2))
#pragma amicall(TuCBase,0x240,DeleteSong(a0))
#pragma amicall(TuCBase,0x246,DupSong(a0))
#pragma amicall(TuCBase,0x24C,ReMapSong(a0,a1))
#pragma amicall(TuCBase,0x252,GetNumSongs(a0))
#pragma amicall(TuCBase,0x258,GetSongNum(a0,a1))
#pragma amicall(TuCBase,0x25E,GetSongAddr(a0,d0))
#pragma amicall(TuCBase,0x264,LoadSong(a0,a1,a2,a3,d0))
#pragma amicall(TuCBase,0x26A,SaveSong(a0,a1,a2,a3))
#pragma amicall(TuCBase,0x270,IdentifySong(a0))
#pragma amicall(TuCBase,0x276,GetSongInfo(a0,a1,d0))
#pragma amicall(TuCBase,0x27C,FreeSongInfo(a0))
#pragma amicall(TuCBase,0x282,GetSongs(a0,a1))
#pragma amicall(TuCBase,0x288,PushSong(a0))
#pragma amicall(TuCBase,0x28E,PopSong(a0))
#pragma amicall(TuCBase,0x294,CutSong(a0,a1))
#pragma amicall(TuCBase,0x29A,CopySong(a0,a1))
#pragma amicall(TuCBase,0x2A0,PasteSong(a0,a1))
#pragma amicall(TuCBase,0x2A6,SwapSong(a0,a1))
#pragma amicall(TuCBase,0x2AC,ClearSong(a0))
#pragma amicall(TuCBase,0x2B2,AddSongUnknownChunk(a0,a1))
#pragma amicall(TuCBase,0x2B8,RemSongUnknownChunk(a0))
#pragma amicall(TuCBase,0x2BE,InsertSongUnknownChunk(a0,a1,a2))
#pragma amicall(TuCBase,0x2C4,GetSongInstrs(a0))
#pragma amicall(TuCBase,0x2CA,FreeSongInstrs(a0))
#pragma amicall(TuCBase,0x2D0,GetSongEnvelopes(a0))
#pragma amicall(TuCBase,0x2D6,FreeSongEnvelopes(a0))
#pragma amicall(TuCBase,0x2DC,GetSongKeyboards(a0))
#pragma amicall(TuCBase,0x2E2,FreeSongKeyboards(a0))
#pragma amicall(TuCBase,0x2E8,GetSongArpeggios(a0))
#pragma amicall(TuCBase,0x2EE,FreeSongArpeggios(a0))
#pragma amicall(TuCBase,0x2F4,ReMapSongInstrs(a0,a1,a2))
#pragma amicall(TuCBase,0x2FA,SetBaseSongInstrs(a0,a1,d0))
#pragma amicall(TuCBase,0x300,SetSongChannels(a0,d0))
#pragma amicall(TuCBase,0x306,SetStack(a0,d0,d1))
#pragma amicall(TuCBase,0x30C,CalcSongPlayTime(a0,a1))
#pragma amicall(TuCBase,0x312,GetOptimalChannels(a0))
#pragma amicall(TuCBase,0x318,ResetSong(a0))
#pragma amicall(TuCBase,0x31E,CalcPlayerSpeed(a0))
#pragma amicall(TuCBase,0x324,AllocPosition(d0))
#pragma amicall(TuCBase,0x32A,FreePosition(a0,d0))
#pragma amicall(TuCBase,0x330,SwapPosition(a0,d0,d1))
#pragma amicall(TuCBase,0x336,SetPosition(a0,a1))
#pragma amicall(TuCBase,0x33C,DupPosition(a0,d0))
#pragma amicall(TuCBase,0x342,GetPositionNum(a0,a1,d0))
#pragma amicall(TuCBase,0x348,GetPositionAddr(a0,d0,d1))
#pragma amicall(TuCBase,0x34E,ClearPosition(a0,d0))
#pragma amicall(TuCBase,0x354,PlayPosition(a0,a1,d0,d1))
#pragma amicall(TuCBase,0x35A,DupPositionChannel(a0,a1,d0,d1))
#pragma amicall(TuCBase,0x360,ClearPositionChannel(a0,d0))
#pragma amicall(TuCBase,0x366,AllocPositionList())
#pragma amicall(TuCBase,0x36C,FreePositionList(a0))
#pragma amicall(TuCBase,0x372,AddPositionList(a0,a1,d0))
#pragma amicall(TuCBase,0x378,RemPositionList(a0,d0))
#pragma amicall(TuCBase,0x37E,InsertPositionList(a0,a1,a2,d0))
#pragma amicall(TuCBase,0x384,DeletePositionList(a0))
#pragma amicall(TuCBase,0x38A,DupPositionList(a0))
#pragma amicall(TuCBase,0x390,SwapPositionList(a0,a1))
#pragma amicall(TuCBase,0x396,ClearPositionList(a0))
#pragma amicall(TuCBase,0x39C,AllocTrack(d0))
#pragma amicall(TuCBase,0x3A2,FreeTrack(a0))
#pragma amicall(TuCBase,0x3A8,AddTrack(a0,a1))
#pragma amicall(TuCBase,0x3AE,RemTrack(a0))
#pragma amicall(TuCBase,0x3B4,InsertTrack(a0,a1,a2))
#pragma amicall(TuCBase,0x3BA,DeleteTrack(a0))
#pragma amicall(TuCBase,0x3C0,ClearTrack(a0))
#pragma amicall(TuCBase,0x3C6,DupTrack(a0))
#pragma amicall(TuCBase,0x3CC,ReMapTrack(a0,a1,a2))
#pragma amicall(TuCBase,0x3D2,ReSizeTrack(a0,d0))
#pragma amicall(TuCBase,0x3D8,AddTrackUnknownChunk(a0,a1))
#pragma amicall(TuCBase,0x3DE,RemTrackUnknownChunk(a0))
#pragma amicall(TuCBase,0x3E4,InsertTrackUnknownChunk(a0,a1,a2))
#pragma amicall(TuCBase,0x3EA,GetNumTracks(a0))
#pragma amicall(TuCBase,0x3F0,GetTrackNum(a0,a1))
#pragma amicall(TuCBase,0x3F6,GetTrackAddr(a0,d0))
#pragma amicall(TuCBase,0x3FC,GetNoteStr(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x402,GetIndexNoteStr(a0,d0,d1))
#pragma amicall(TuCBase,0x408,NoteToIndex(d0,d1))
#pragma amicall(TuCBase,0x40E,IndexToNote(d0))
#pragma amicall(TuCBase,0x414,GetTrackRowStr(a0,a1,a2,d0,d1,d2))
#pragma amicall(TuCBase,0x41A,AllocEffect(d0,d1))
#pragma amicall(TuCBase,0x420,FreeEffect(a0))
#pragma amicall(TuCBase,0x426,AddEffect(a0,a1,d0))
#pragma amicall(TuCBase,0x42C,RemEffect(a0,d0))
#pragma amicall(TuCBase,0x432,InsertEffect(a0,a1,a2,d0))
#pragma amicall(TuCBase,0x438,DeleteEffect(a0))
#pragma amicall(TuCBase,0x43E,ClearEffects(a0,d0,d1))
#pragma amicall(TuCBase,0x444,ReMapEffects(a0,a1,d0,d1,d2))
#pragma amicall(TuCBase,0x44A,AllocTrackData(d0))
#pragma amicall(TuCBase,0x450,FreeTrackData(a0,d0))
#pragma amicall(TuCBase,0x456,AddRows(a0,d0))
#pragma amicall(TuCBase,0x45C,RemRows(a0,d0))
#pragma amicall(TuCBase,0x462,InsertRows(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x468,DeleteRows(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x46E,ClearRows(a0,d0,d1))
#pragma amicall(TuCBase,0x474,ReMapRows(a0,a1,d0,d1,d2))
#pragma amicall(TuCBase,0x47A,CopyRows(a0,a1,d0,d1,d2))
#pragma amicall(TuCBase,0x480,SwapRows(a0,a1,d0,d1,d2))
#pragma amicall(TuCBase,0x486,PlayRow(a0,a1,d0,d1))
#pragma amicall(TuCBase,0x48C,CmpTracks(a0,a1))
#pragma amicall(TuCBase,0x492,PackTrack(a0))
#pragma amicall(TuCBase,0x498,UnPackTrack(a0,a1))
#pragma amicall(TuCBase,0x49E,FreePackedTrack(a0))
#pragma amicall(TuCBase,0x4A4,LoadTrack(a0,a1,a2,a3,d0))
#pragma amicall(TuCBase,0x4AA,SaveTrack(a0,a1,a2,a3))
#pragma amicall(TuCBase,0x4B0,IdentifyTrack(a0))
#pragma amicall(TuCBase,0x4B6,GetTrackInfo(a0,a1,d0))
#pragma amicall(TuCBase,0x4BC,FreeTrackInfo(a0))
#pragma amicall(TuCBase,0x4C2,GetTracks(a0,a1))
#pragma amicall(TuCBase,0x4C8,PushTrack(a0))
#pragma amicall(TuCBase,0x4CE,PopTrack(a0))
#pragma amicall(TuCBase,0x4D4,CutTrack(a0,a1))
#pragma amicall(TuCBase,0x4DA,CopyTrack(a0,a1))
#pragma amicall(TuCBase,0x4E0,PasteTrack(a0,a1))
#pragma amicall(TuCBase,0x4E6,SwapTrack(a0,a1))
#pragma amicall(TuCBase,0x4EC,SwapTrackInSong(a0,a1,d0))
#pragma amicall(TuCBase,0x4F2,ShrinkTrack(a0,d0))
#pragma amicall(TuCBase,0x4F8,ExpandTrack(a0,d0))
#pragma amicall(TuCBase,0x4FE,HalveTrack(a0,d0))
#pragma amicall(TuCBase,0x504,DoubleTrack(a0,d0))
#pragma amicall(TuCBase,0x50A,SplitTrack(a0,a1,d0))
#pragma amicall(TuCBase,0x510,JoinTrack(a0,a1))
#pragma amicall(TuCBase,0x516,PlayTrack(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x51C,TrackNoteShift(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x522,ScrollTrack(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x528,RotateTrack(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x52E,FlipTrack(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x534,AllocInstr(d0))
#pragma amicall(TuCBase,0x53A,FreeInstr(a0))
#pragma amicall(TuCBase,0x540,AddInstr(a0,a1))
#pragma amicall(TuCBase,0x546,RemInstr(a0))
#pragma amicall(TuCBase,0x54C,InsertInstr(a0,a1,a2))
#pragma amicall(TuCBase,0x552,DeleteInstr(a0))
#pragma amicall(TuCBase,0x558,ClearInstr(a0))
#pragma amicall(TuCBase,0x55E,DupInstr(a0))
#pragma amicall(TuCBase,0x564,ReMapInstr(a0,a1))
#pragma amicall(TuCBase,0x56A,AddInstrUnknownChunk(a0,a1))
#pragma amicall(TuCBase,0x570,RemInstrUnknownChunk(a0))
#pragma amicall(TuCBase,0x576,InsertInstrUnknownChunk(a0,a1,a2))
#pragma amicall(TuCBase,0x57C,GetNumInstrs(a0))
#pragma amicall(TuCBase,0x582,GetInstrNum(a0,a1))
#pragma amicall(TuCBase,0x588,GetInstrAddr(a0,d0))
#pragma amicall(TuCBase,0x58E,LoadInstr(a0,a1,a2,a3,d0))
#pragma amicall(TuCBase,0x594,SaveInstr(a0,a1,a2,a3))
#pragma amicall(TuCBase,0x59A,IdentifyInstr(a0))
#pragma amicall(TuCBase,0x5A0,GetInstrInfo(a0,a1,d0))
#pragma amicall(TuCBase,0x5A6,FreeInstrInfo(a0))
#pragma amicall(TuCBase,0x5AC,GetInstrs(a0,a1))
#pragma amicall(TuCBase,0x5B2,PushInstr(a0))
#pragma amicall(TuCBase,0x5B8,PopInstr(a0))
#pragma amicall(TuCBase,0x5BE,CutInstr(a0,a1))
#pragma amicall(TuCBase,0x5C4,CopyInstr(a0,a1))
#pragma amicall(TuCBase,0x5CA,PasteInstr(a0,a1))
#pragma amicall(TuCBase,0x5D0,SwapInstr(a0,a1))
#pragma amicall(TuCBase,0x5D6,SwapInstrInModule(a0,a1,d0))
#pragma amicall(TuCBase,0x5DC,PlayInstr(a0,a1,d0,d1,d2))
#pragma amicall(TuCBase,0x5E2,CmpInstrs(a0,a1))
#pragma amicall(TuCBase,0x5E8,GetInstrEnvelopes(a0))
#pragma amicall(TuCBase,0x5EE,FreeInstrEnvelopes(a0))
#pragma amicall(TuCBase,0x5F4,AddInstrEnvelopes(a0,d0))
#pragma amicall(TuCBase,0x5FA,GetInstrKeyboard(a0))
#pragma amicall(TuCBase,0x600,GetInstrSamples(a0))
#pragma amicall(TuCBase,0x606,FreeInstrSamples(a0))
#pragma amicall(TuCBase,0x60C,CreateEnvelope(d0,d1,d2,d3,d4))
#pragma amicall(TuCBase,0x612,FreeEnvelope(a0))
#pragma amicall(TuCBase,0x618,AddEnvelope(a0,a1))
#pragma amicall(TuCBase,0x61E,RemEnvelope(a0))
#pragma amicall(TuCBase,0x624,InsertEnvelope(a0,a1,a2))
#pragma amicall(TuCBase,0x62A,DeleteEnvelope(a0))
#pragma amicall(TuCBase,0x630,ClearEnvelope(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x636,DupEnvelope(a0))
#pragma amicall(TuCBase,0x63C,ReMapEnvelope(a0,a1))
#pragma amicall(TuCBase,0x642,ReSizeEnvelope(a0,d0))
#pragma amicall(TuCBase,0x648,ValidateEnvNodes(a0))
#pragma amicall(TuCBase,0x64E,AddEnvelopeUnknownChunk(a0,a1))
#pragma amicall(TuCBase,0x654,RemEnvelopeUnknownChunk(a0))
#pragma amicall(TuCBase,0x65A,InsertEnvelopeUnknownChunk(a0,a1,a2))
#pragma amicall(TuCBase,0x660,GetNumEnvelopes(a0))
#pragma amicall(TuCBase,0x666,GetEnvelopeNum(a0,a1))
#pragma amicall(TuCBase,0x66C,GetEnvelopeAddr(a0,d0))
#pragma amicall(TuCBase,0x672,SwapEnvelopeInModule(a0,a1,d0))
#pragma amicall(TuCBase,0x678,LoadEnvelope(a0,a1,d0))
#pragma amicall(TuCBase,0x67E,SaveEnvelope(a0,a1))
#pragma amicall(TuCBase,0x684,ShrinkEnvelope(a0,d0))
#pragma amicall(TuCBase,0x68A,ExpandEnvelope(a0,d0))
#pragma amicall(TuCBase,0x690,HalveEnvelope(a0,d0))
#pragma amicall(TuCBase,0x696,DoubleEnvelope(a0,d0))
#pragma amicall(TuCBase,0x69C,SplitEnvelope(a0,a1,d0))
#pragma amicall(TuCBase,0x6A2,JoinEnvelope(a0,a1))
#pragma amicall(TuCBase,0x6A8,ScrollEnvelope(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x6AE,RotateEnvelope(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x6B4,FlipEnvelope(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x6BA,AddEnvPoint(a0,d0))
#pragma amicall(TuCBase,0x6C0,RemEnvPoint(a0,d0))
#pragma amicall(TuCBase,0x6C6,InsertEnvPoint(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x6CC,DeleteEnvPoint(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x6D2,CmpEnvelopes(a0,a1))
#pragma amicall(TuCBase,0x6D8,AllocKeyboard())
#pragma amicall(TuCBase,0x6DE,FreeKeyboard(a0))
#pragma amicall(TuCBase,0x6E4,AddKeyboard(a0,a1))
#pragma amicall(TuCBase,0x6EA,RemKeyboard(a0))
#pragma amicall(TuCBase,0x6F0,InsertKeyboard(a0,a1,a2))
#pragma amicall(TuCBase,0x6F6,DeleteKeyboard(a0))
#pragma amicall(TuCBase,0x6FC,ClearKeyboard(a0))
#pragma amicall(TuCBase,0x702,DupKeyboard(a0))
#pragma amicall(TuCBase,0x708,ReMapKeyboard(a0,a1))
#pragma amicall(TuCBase,0x70E,GetNumKeyboards(a0))
#pragma amicall(TuCBase,0x714,GetKeyboardNum(a0,a1))
#pragma amicall(TuCBase,0x71A,GetKeyboardAddr(a0,d0))
#pragma amicall(TuCBase,0x720,SwapKeyboardInModule(a0,a1,d0))
#pragma amicall(TuCBase,0x726,SetKeyboard(a0,d0,d1,d2,d3,d4))
#pragma amicall(TuCBase,0x72C,CheckKeyboard(a0))
#pragma amicall(TuCBase,0x732,CmpKeyboards(a0,a1))
#pragma amicall(TuCBase,0x738,AllocArpeggio(d0))
#pragma amicall(TuCBase,0x73E,FreeArpeggio(a0))
#pragma amicall(TuCBase,0x744,AddArpeggio(a0,a1))
#pragma amicall(TuCBase,0x74A,RemArpeggio(a0))
#pragma amicall(TuCBase,0x750,InsertArpeggio(a0,a1,a2))
#pragma amicall(TuCBase,0x756,DeleteArpeggio(a0))
#pragma amicall(TuCBase,0x75C,ClearArpeggio(a0))
#pragma amicall(TuCBase,0x762,DupArpeggio(a0))
#pragma amicall(TuCBase,0x768,ReMapArpeggio(a0,a1))
#pragma amicall(TuCBase,0x76E,ReSizeArpeggio(a0,d0))
#pragma amicall(TuCBase,0x774,GetNumArpeggios(a0))
#pragma amicall(TuCBase,0x77A,GetArpeggioNum(a0,a1))
#pragma amicall(TuCBase,0x780,GetArpeggioAddr(a0,d0))
#pragma amicall(TuCBase,0x786,SwapArpeggioInModule(a0,a1,d0))
#pragma amicall(TuCBase,0x78C,ShrinkArpeggio(a0,d0))
#pragma amicall(TuCBase,0x792,ExpandArpeggio(a0,d0))
#pragma amicall(TuCBase,0x798,HalveArpeggio(a0,d0))
#pragma amicall(TuCBase,0x79E,DoubleArpeggio(a0,d0))
#pragma amicall(TuCBase,0x7A4,SplitArpeggio(a0,a1,d0))
#pragma amicall(TuCBase,0x7AA,JoinArpeggio(a0,a1))
#pragma amicall(TuCBase,0x7B0,ScrollArpeggio(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x7B6,RotateArpeggio(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x7BC,FlipArpeggio(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x7C2,AddArpeggioTick(a0,d0))
#pragma amicall(TuCBase,0x7C8,RemArpeggioTick(a0,d0))
#pragma amicall(TuCBase,0x7CE,InsertArpeggioTick(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x7D4,DeleteArpeggioTick(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x7DA,CmpArpeggios(a0,a1))
#pragma amicall(TuCBase,0x7E0,AllocSample(a0,d0))
#pragma amicall(TuCBase,0x7E6,FreeSample(a0))
#pragma amicall(TuCBase,0x7EC,AddSample(a0,a1))
#pragma amicall(TuCBase,0x7F2,RemSample(a0))
#pragma amicall(TuCBase,0x7F8,InsertSample(a0,a1,a2))
#pragma amicall(TuCBase,0x7FE,DeleteSample(a0))
#pragma amicall(TuCBase,0x804,ClearSample(a0))
#pragma amicall(TuCBase,0x80A,DupSample(a0))
#pragma amicall(TuCBase,0x810,ReSizeSample(a0,d0))
#pragma amicall(TuCBase,0x816,AddSampleUnknownChunk(a0,a1))
#pragma amicall(TuCBase,0x81C,RemSampleUnknownChunk(a0))
#pragma amicall(TuCBase,0x822,InsertSampleUnknownChunk(a0,a1,a2))
#pragma amicall(TuCBase,0x828,GetNumSamples(a0))
#pragma amicall(TuCBase,0x82E,GetSampleNum(a0,a1))
#pragma amicall(TuCBase,0x834,GetSampleAddr(a0,d0))
#pragma amicall(TuCBase,0x83A,PushSample(a0))
#pragma amicall(TuCBase,0x840,PopSample(a0))
#pragma amicall(TuCBase,0x846,CutSample(a0,a1))
#pragma amicall(TuCBase,0x84C,CopySample(a0,a1))
#pragma amicall(TuCBase,0x852,PasteSample(a0,a1))
#pragma amicall(TuCBase,0x858,SwapSample(a0,a1))
#pragma amicall(TuCBase,0x85E,SwapSampleInInstr(a0,a1,d0))
#pragma amicall(TuCBase,0x864,PlaySample(a0,a1,d0,d1,d2))
#pragma amicall(TuCBase,0x86A,LoadSample(a0,a1,a2,a3,d0))
#pragma amicall(TuCBase,0x870,SaveSample(a0,a1,a2,a3))
#pragma amicall(TuCBase,0x876,IdentifySample(a0))
#pragma amicall(TuCBase,0x87C,GetSampleInfo(a0,a1,d0))
#pragma amicall(TuCBase,0x882,FreeSampleInfo(a0))
#pragma amicall(TuCBase,0x888,GetSamples(a0,a1))
#pragma amicall(TuCBase,0x88E,CalcSamplePlayFreq(a0,d0,d1))
#pragma amicall(TuCBase,0x894,CalcFineTune(d0,d1))
#pragma amicall(TuCBase,0x89A,ConvertSampleFrequency(d0))
#pragma amicall(TuCBase,0x8A0,CalcLinearFrequency(d0,d1))
#pragma amicall(TuCBase,0x8A6,AllocSampleData(d0))
#pragma amicall(TuCBase,0x8AC,FreeSampleData(a0,d0))
#pragma amicall(TuCBase,0x8B2,SetSampleData(a0,a1,d0))
#pragma amicall(TuCBase,0x8B8,AddSampleData(a0,d0))
#pragma amicall(TuCBase,0x8BE,RemSampleData(a0,d0))
#pragma amicall(TuCBase,0x8C4,InsertSampleData(a0,d0,d1))
#pragma amicall(TuCBase,0x8CA,DeleteSampleData(a0,d0,d1))
#pragma amicall(TuCBase,0x8D0,ClearSampleData(a0,d0,d1))
#pragma amicall(TuCBase,0x8D6,DupSampleData(a0))
#pragma amicall(TuCBase,0x8DC,CutSampleData(a0,a1,d0,d1))
#pragma amicall(TuCBase,0x8E2,CopySampleData(a0,a1,d0,d1))
#pragma amicall(TuCBase,0x8E8,PasteSampleData(a0,a1,d0,d1))
#pragma amicall(TuCBase,0x8EE,CropSampleData(a0,a1,d0,d1))
#pragma amicall(TuCBase,0x8F4,LoadSampleData(a0,a1,d0))
#pragma amicall(TuCBase,0x8FA,SaveSampleData(a0,a1,d0,d1))
#pragma amicall(TuCBase,0x900,ConvertBits(a0,d0,d1))
#pragma amicall(TuCBase,0x906,GetOptimalBits(a0,d0))
#pragma amicall(TuCBase,0x90C,ConvertSigned(a0))
#pragma amicall(TuCBase,0x912,ConvertWord(a0))
#pragma amicall(TuCBase,0x918,DecrunchSample(a0,d0))
#pragma amicall(TuCBase,0x91E,Backwards(a0,d0,d1))
#pragma amicall(TuCBase,0x924,MixSamples(a0,a1,d0,d1,d2))
#pragma amicall(TuCBase,0x92A,Sample(a0,a1,a2,d0,d1,d2,d3))
#pragma amicall(TuCBase,0x930,OctaveUp(a0))
#pragma amicall(TuCBase,0x936,OctaveDown(a0))
#pragma amicall(TuCBase,0x93C,ReSample(a0,d0,d1,d2))
#pragma amicall(TuCBase,0x942,InvertSample(a0))
#pragma amicall(TuCBase,0x948,XFadeSample(a0))
#pragma amicall(TuCBase,0x94E,AmplifySample(a0,d0,d1,d2,d3))
#pragma amicall(TuCBase,0x954,GetBiggestAmplify(a0,d0,d1))
#pragma amicall(TuCBase,0x95A,GetLowestAmplify(a0,d0,d1))
#pragma amicall(TuCBase,0x960,CreateEcho(a0))
#pragma amicall(TuCBase,0x966,BoostSample(a0))
#pragma amicall(TuCBase,0x96C,FilterSample(a0))
#pragma amicall(TuCBase,0x972,MorphSamples(a0))
#pragma amicall(TuCBase,0x978,MinimizeSample(a0))
#pragma amicall(TuCBase,0x97E,FindOriginSample(a0))
#pragma amicall(TuCBase,0x984,GetSampleValue(a0,d0))
#pragma amicall(TuCBase,0x98A,GetSampleValueArray(a0,a1,d0,d1))
#pragma amicall(TuCBase,0x990,CmpSamples(a0,a1))
#pragma amicall(TuCBase,0x996,AllocSynth(d0,d1,d2))
#pragma amicall(TuCBase,0x99C,FreeSynth(a0))
#pragma amicall(TuCBase,0x9A2,AssignSynth(a0,a1))
#pragma amicall(TuCBase,0x9A8,ClearSynth(a0))
#pragma amicall(TuCBase,0x9AE,DupSynth(a0))
#pragma amicall(TuCBase,0x9B4,ReMapSynth(a0,a1))
#pragma amicall(TuCBase,0x9BA,AddSynthUnknownChunk(a0,a1))
#pragma amicall(TuCBase,0x9C0,RemSynthUnknownChunk(a0))
#pragma amicall(TuCBase,0x9C6,InsertSynthUnknownChunk(a0,a1,a2))
#pragma amicall(TuCBase,0x9CC,GetNumSynths(a0))
#pragma amicall(TuCBase,0x9D2,GetSynthNum(a0,a1))
#pragma amicall(TuCBase,0x9D8,GetSynthAddr(a0,d0))
#pragma amicall(TuCBase,0x9DE,PushSynth(a0))
#pragma amicall(TuCBase,0x9E4,PopSynth(a0))
#pragma amicall(TuCBase,0x9EA,CutSynth(a0,a1))
#pragma amicall(TuCBase,0x9F0,CopySynth(a0,a1))
#pragma amicall(TuCBase,0x9F6,PasteSynth(a0,a1))
#pragma amicall(TuCBase,0x9FC,SwapSynth(a0,a1))
#pragma amicall(TuCBase,0xA02,LoadSynth(a0,a1,a2,a3,d0))
#pragma amicall(TuCBase,0xA08,SaveSynth(a0,a1,a2,a3))
#pragma amicall(TuCBase,0xA0E,IdentifySynth(a0))
#pragma amicall(TuCBase,0xA14,GetSynthInfo(a0,a1,d0))
#pragma amicall(TuCBase,0xA1A,FreeSynthInfo(a0))
#pragma amicall(TuCBase,0xA20,GetSynths(a0,a1))
#pragma amicall(TuCBase,0xA26,CmpSynths(a0,a1))
#pragma amicall(TuCBase,0xA2C,AllocWaveform(d0))
#pragma amicall(TuCBase,0xA32,FreeWaveform(a0))
#pragma amicall(TuCBase,0xA38,AddWaveform(a0,a1))
#pragma amicall(TuCBase,0xA3E,RemWaveform(a0))
#pragma amicall(TuCBase,0xA44,InsertWaveform(a0,a1,a2))
#pragma amicall(TuCBase,0xA4A,DeleteWaveform(a0))
#pragma amicall(TuCBase,0xA50,ClearWaveform(a0))
#pragma amicall(TuCBase,0xA56,DupWaveform(a0))
#pragma amicall(TuCBase,0xA5C,ReSizeWaveform(a0,d0))
#pragma amicall(TuCBase,0xA62,GetNumWaveforms(a0))
#pragma amicall(TuCBase,0xA68,GetWaveformNum(a0,a1))
#pragma amicall(TuCBase,0xA6E,GetWaveformAddr(a0,d0))
#pragma amicall(TuCBase,0xA74,PushWaveform(a0))
#pragma amicall(TuCBase,0xA7A,PopWaveform(a0))
#pragma amicall(TuCBase,0xA80,CutWaveform(a0,a1))
#pragma amicall(TuCBase,0xA86,CopyWaveform(a0,a1))
#pragma amicall(TuCBase,0xA8C,PasteWaveform(a0,a1))
#pragma amicall(TuCBase,0xA92,SwapWaveform(a0,a1))
#pragma amicall(TuCBase,0xA98,SwapWaveformInSynth(a0,a1))
#pragma amicall(TuCBase,0xA9E,LoadWaveform(a0,a1,d0))
#pragma amicall(TuCBase,0xAA4,SaveWaveform(a0,a1,d0,d1))
#pragma amicall(TuCBase,0xAAA,PlayWaveform(a0,a1,d0))
#pragma amicall(TuCBase,0xAB0,AddWaveformPoint(a0,d0))
#pragma amicall(TuCBase,0xAB6,RemWaveformPoint(a0,d0))
#pragma amicall(TuCBase,0xABC,InsertWaveformPoint(a0,d0,d1,d2))
#pragma amicall(TuCBase,0xAC2,DeleteWaveformPoint(a0,d0,d1,d2))
#pragma amicall(TuCBase,0xAC8,FillWaveform(a0,d0,d1,d2,d3))
#pragma amicall(TuCBase,0xACE,ConvertWaveform(a0,d0,d1))
#pragma amicall(TuCBase,0xAD4,ConvertWaveformSigned(a0))
#pragma amicall(TuCBase,0xADA,ConvertWaveformWord(a0))
#pragma amicall(TuCBase,0xAE0,BackwardsWaveform(a0))
#pragma amicall(TuCBase,0xAE6,MixWaveforms(a0,a1))
#pragma amicall(TuCBase,0xAEC,HalveWaveform(a0))
#pragma amicall(TuCBase,0xAF2,DoubleWaveform(a0))
#pragma amicall(TuCBase,0xAF8,ScaleWaveformSize(a0,d0,d1,d2))
#pragma amicall(TuCBase,0xAFE,InvertWaveform(a0))
#pragma amicall(TuCBase,0xB04,AmplifyWaveform(a0,d0))
#pragma amicall(TuCBase,0xB0A,GetMaxWaveformAmplify(a0))
#pragma amicall(TuCBase,0xB10,GetMinWaveformAmplify(a0))
#pragma amicall(TuCBase,0xB16,CopySample2Waveform(a0,a1))
#pragma amicall(TuCBase,0xB1C,CopyWaveform2Sample(a0,a1))
#pragma amicall(TuCBase,0xB22,CopyEnvelope2Waveform(a0,a1))
#pragma amicall(TuCBase,0xB28,CopyWaveform2Envelope(a0,a1))
#pragma amicall(TuCBase,0xB2E,TransformWaveform(a0,a1))
#pragma amicall(TuCBase,0xB34,CmpWaveforms(a0,a1))
#pragma amicall(TuCBase,0xB3A,AllocSynthCode(d0))
#pragma amicall(TuCBase,0xB40,FreeSynthCode(a0,d0))
#pragma amicall(TuCBase,0xB46,AssignSynthCode(a0,a1,d0))
#pragma amicall(TuCBase,0xB4C,ClearSynthCode(a0))
#pragma amicall(TuCBase,0xB52,DupSynthCode(a0))
#pragma amicall(TuCBase,0xB58,ReSizeSynthCode(a0,d0))
#pragma amicall(TuCBase,0xB5E,PushSynthCode(a0))
#pragma amicall(TuCBase,0xB64,PopSynthCode(a0))
#pragma amicall(TuCBase,0xB6A,CutSynthCode(a0,a1))
#pragma amicall(TuCBase,0xB70,CopySynthCode(a0,a1))
#pragma amicall(TuCBase,0xB76,PasteSynthCode(a0,a1))
#pragma amicall(TuCBase,0xB7C,SwapSynthCode(a0,a1))
#pragma amicall(TuCBase,0xB82,AddSynthCodeLine(a0,d0))
#pragma amicall(TuCBase,0xB88,RemSynthCodeLine(a0,d0))
#pragma amicall(TuCBase,0xB8E,InsertSynthCodeLine(a0,d0,d1,d2))
#pragma amicall(TuCBase,0xB94,DeleteSynthCodeLine(a0,d0,d1,d2))
#pragma amicall(TuCBase,0xB9A,GetSynthCodeParams(d0))
#pragma amicall(TuCBase,0xBA0,AssembleCodeLine(a0,a1,d0,d1))
#pragma amicall(TuCBase,0xBA6,DisassembleCodeLine(a0,a1,d0,d1))
#pragma amicall(TuCBase,0xBAC,AllocSymbol(a0))
#pragma amicall(TuCBase,0xBB2,FreeSymbol(a0))
#pragma amicall(TuCBase,0xBB8,AssignSymbol(a0,a1))
#pragma amicall(TuCBase,0xBBE,DupSymbol(a0))
#pragma amicall(TuCBase,0xBC4,AddSymbol(a0,a1))
#pragma amicall(TuCBase,0xBCA,RemSymbol(a0))
#pragma amicall(TuCBase,0xBD0,InsertSymbol(a0,a1,a2))
#pragma amicall(TuCBase,0xBD6,DeleteSymbol(a0))
#pragma amicall(TuCBase,0xBDC,GetNumSymbols(a0))
#pragma amicall(TuCBase,0xBE2,GetSymbolNum(a0,a1))
#pragma amicall(TuCBase,0xBE8,GetSymbolAddr(a0,d0))
#pragma amicall(TuCBase,0xBEE,MatchSymbol(a0,a1,d0,d1))
#pragma amicall(TuCBase,0xBF4,AddExternalLib(a0,d0))
#pragma amicall(TuCBase,0xBFA,RemExternalLib(a0))
#pragma amicall(TuCBase,0xC00,OpenExternalLib(a0))
#pragma amicall(TuCBase,0xC06,CloseExternalLib(a0))
#pragma amicall(TuCBase,0xC0C,GetExternalLibs(a0))
#pragma amicall(TuCBase,0xC12,AllocFlagStr(a0))
#pragma amicall(TuCBase,0xC18,CIdentify(d1))
#pragma amicall(TuCBase,0xC1E,COpen(d1,d2,d3))
#pragma amicall(TuCBase,0xC24,CClose(d1))
#pragma amicall(TuCBase,0xC2A,CRead(d1,d2,d3))
#pragma amicall(TuCBase,0xC30,CWrite(d1,d2,d3))
#pragma amicall(TuCBase,0xC36,CSeek(d1,d2,d3))
#pragma amicall(TuCBase,0xC3C,CGetInfo(d1,d2))
#endif
#if defined(_DCC) || defined(__SASC)
#pragma  libcall TuCBase AllocPMem            01E 001
#pragma  libcall TuCBase FreePMem             024 0902
#pragma  libcall TuCBase InitNodeList         02A 801
#pragma  libcall TuCBase InsertNode           030 A9803
#pragma  libcall TuCBase AddNodeHead          036 9802
#pragma  libcall TuCBase AddNodeTail          03C 9802
#pragma  libcall TuCBase RemoveNode           042 901
#pragma  libcall TuCBase RemNodeHead          048 801
#pragma  libcall TuCBase RemNodeTail          04E 801
#pragma  libcall TuCBase EnqueueNode          054 9802
#pragma  libcall TuCBase DupNodeList          05A 09803
#pragma  libcall TuCBase ReMapNodeList        060 9802
#pragma  libcall TuCBase AllocNameStr         066 801
#pragma  libcall TuCBase FreeNameStr          06C 801
#pragma  libcall TuCBase SetString            072 9802
#pragma  libcall TuCBase SetNameStr           078 9802
#pragma  libcall TuCBase Sin                  07E 1002
#pragma  libcall TuCBase Cos                  084 1002
#pragma  libcall TuCBase Tan                  08A 1002
#pragma  libcall TuCBase DoPlayerIRQ          090 801
#pragma  libcall TuCBase AddPlayExecHandler   096 801
#pragma  libcall TuCBase RemPlayExecHandler   09C 801
#pragma  libcall TuCBase SetPlayExecHandlerPri 0A2 0802
#pragma  libcall TuCBase Stamp2Date           0A8 9802
#pragma  libcall TuCBase AllocSimulateMix     0AE 801
#pragma  libcall TuCBase FreeSimulateMix      0B4 801
#pragma  libcall TuCBase AllocUnknownChunk    0BA 10803
#pragma  libcall TuCBase FreeUnknownChunk     0C0 801
#pragma  libcall TuCBase DeleteUnknownChunk   0C6 801
#pragma  libcall TuCBase Randomize            0CC 001
#pragma  libcall TuCBase Rnd                  0D2 001
#pragma  libcall TuCBase AllocSoundDevice     0D8 9802
#pragma  libcall TuCBase FreeSoundDevice      0DE 801
#pragma  libcall TuCBase PlaySoundDevice      0E4 A9803
#pragma  libcall TuCBase StopSoundDevice      0EA 801
#pragma  libcall TuCBase CheckSoundDeviceRate 0F0 0802
#pragma  libcall TuCBase CheckSoundDeviceRateFraction 0F6 0802
#pragma  libcall TuCBase UpdateSoundDeviceRate 0FC 0802
#pragma  libcall TuCBase AllocMixer           102 801
#pragma  libcall TuCBase FreeMixer            108 801
#pragma  libcall TuCBase InitMixer            10E A9803
#pragma  libcall TuCBase ChangeMixerRate      114 0802
#pragma  libcall TuCBase ChangeMixerTempo     11A 0802
#pragma  libcall TuCBase ChangeMixerVolTable  120 3210805
#pragma  libcall TuCBase GetMixChannel        126 08903
#pragma  libcall TuCBase SetMixChannel        12C 08903
#pragma  libcall TuCBase SetMixChannelVolPanPitch 132 08903
#pragma  libcall TuCBase SetMixChannelPosRepFlags 138 08903
#pragma  libcall TuCBase DoMix                13E 9802
#pragma  libcall TuCBase AllocPostProcessor   144 9802
#pragma  libcall TuCBase FreePostProcessor    14A 801
#pragma  libcall TuCBase InitPostProcessor    150 A9803
#pragma  libcall TuCBase ChangePostProcessor  156 9802
#pragma  libcall TuCBase DoPostProcessorMix   15C A802
#pragma  libcall TuCBase AddPostProcessor     162 9802
#pragma  libcall TuCBase RemPostProcessor     168 801
#pragma  libcall TuCBase SetPostProcessorPri  16E 0802
#pragma  libcall TuCBase AllocTCModule        174 001
#pragma  libcall TuCBase FreeTCModule         17A 801
#pragma  libcall TuCBase AddTCModule          180 801
#pragma  libcall TuCBase RemTCModule          186 801
#pragma  libcall TuCBase DupTCModule          18C 801
#pragma  libcall TuCBase ReMapTCModule        192 9802
#pragma  libcall TuCBase LoadTCModule         198 0BA9805
#pragma  libcall TuCBase SaveTCModule         19E BA9804
#pragma  libcall TuCBase IdentifyTCModule     1A4 801
#pragma  libcall TuCBase GetTCModuleInfo      1AA 09803
#pragma  libcall TuCBase FreeTCModuleInfo     1B0 801
#pragma  libcall TuCBase GetTCModules         1B6 9802
#pragma  libcall TuCBase PushTCModule         1BC 801
#pragma  libcall TuCBase PopTCModule          1C2 801
#pragma  libcall TuCBase CutTCModule          1C8 9802
#pragma  libcall TuCBase CopyTCModule         1CE 9802
#pragma  libcall TuCBase PasteTCModule        1D4 9802
#pragma  libcall TuCBase SwapTCModule         1DA 9802
#pragma  libcall TuCBase ClearTCModule        1E0 801
#pragma  libcall TuCBase AddTCModuleUnknownChunk 1E6 9802
#pragma  libcall TuCBase RemTCModuleUnknownChunk 1EC 801
#pragma  libcall TuCBase InsertTCModuleUnknownChunk 1F2 A9803
#pragma  libcall TuCBase AllocPlayTCModule    1F8 00
#pragma  libcall TuCBase FreePlayTCModule     1FE 00
#pragma  libcall TuCBase PlayTCModule         204 801
#pragma  libcall TuCBase StopTCModule         20A 00
#pragma  libcall TuCBase SetTCMChannels       210 0802
#pragma  libcall TuCBase CalcTCMPlayTime      216 9802
#pragma  libcall TuCBase GetOptimalVChannels  21C 801
#pragma  libcall TuCBase AllocSong            222 21003
#pragma  libcall TuCBase FreeSong             228 801
#pragma  libcall TuCBase AddSong              22E 9802
#pragma  libcall TuCBase RemSong              234 801
#pragma  libcall TuCBase InsertSong           23A A9803
#pragma  libcall TuCBase DeleteSong           240 801
#pragma  libcall TuCBase DupSong              246 801
#pragma  libcall TuCBase ReMapSong            24C 9802
#pragma  libcall TuCBase GetNumSongs          252 801
#pragma  libcall TuCBase GetSongNum           258 9802
#pragma  libcall TuCBase GetSongAddr          25E 0802
#pragma  libcall TuCBase LoadSong             264 0BA9805
#pragma  libcall TuCBase SaveSong             26A BA9804
#pragma  libcall TuCBase IdentifySong         270 801
#pragma  libcall TuCBase GetSongInfo          276 09803
#pragma  libcall TuCBase FreeSongInfo         27C 801
#pragma  libcall TuCBase GetSongs             282 9802
#pragma  libcall TuCBase PushSong             288 801
#pragma  libcall TuCBase PopSong              28E 801
#pragma  libcall TuCBase CutSong              294 9802
#pragma  libcall TuCBase CopySong             29A 9802
#pragma  libcall TuCBase PasteSong            2A0 9802
#pragma  libcall TuCBase SwapSong             2A6 9802
#pragma  libcall TuCBase ClearSong            2AC 801
#pragma  libcall TuCBase AddSongUnknownChunk  2B2 9802
#pragma  libcall TuCBase RemSongUnknownChunk  2B8 801
#pragma  libcall TuCBase InsertSongUnknownChunk 2BE A9803
#pragma  libcall TuCBase GetSongInstrs        2C4 801
#pragma  libcall TuCBase FreeSongInstrs       2CA 801
#pragma  libcall TuCBase GetSongEnvelopes     2D0 801
#pragma  libcall TuCBase FreeSongEnvelopes    2D6 801
#pragma  libcall TuCBase GetSongKeyboards     2DC 801
#pragma  libcall TuCBase FreeSongKeyboards    2E2 801
#pragma  libcall TuCBase GetSongArpeggios     2E8 801
#pragma  libcall TuCBase FreeSongArpeggios    2EE 801
#pragma  libcall TuCBase ReMapSongInstrs      2F4 A9803
#pragma  libcall TuCBase SetBaseSongInstrs    2FA 09803
#pragma  libcall TuCBase SetSongChannels      300 0802
#pragma  libcall TuCBase SetStack             306 10803
#pragma  libcall TuCBase CalcSongPlayTime     30C 9802
#pragma  libcall TuCBase GetOptimalChannels   312 801
#pragma  libcall TuCBase ResetSong            318 801
#pragma  libcall TuCBase CalcPlayerSpeed      31E 801
#pragma  libcall TuCBase AllocPosition        324 001
#pragma  libcall TuCBase FreePosition         32A 0802
#pragma  libcall TuCBase SwapPosition         330 10803
#pragma  libcall TuCBase SetPosition          336 9802
#pragma  libcall TuCBase DupPosition          33C 0802
#pragma  libcall TuCBase GetPositionNum       342 09803
#pragma  libcall TuCBase GetPositionAddr      348 10803
#pragma  libcall TuCBase ClearPosition        34E 0802
#pragma  libcall TuCBase PlayPosition         354 109804
#pragma  libcall TuCBase DupPositionChannel   35A 109804
#pragma  libcall TuCBase ClearPositionChannel 360 0802
#pragma  libcall TuCBase AllocPositionList    366 00
#pragma  libcall TuCBase FreePositionList     36C 801
#pragma  libcall TuCBase AddPositionList      372 09803
#pragma  libcall TuCBase RemPositionList      378 0802
#pragma  libcall TuCBase InsertPositionList   37E 0A9804
#pragma  libcall TuCBase DeletePositionList   384 801
#pragma  libcall TuCBase DupPositionList      38A 801
#pragma  libcall TuCBase SwapPositionList     390 9802
#pragma  libcall TuCBase ClearPositionList    396 801
#pragma  libcall TuCBase AllocTrack           39C 001
#pragma  libcall TuCBase FreeTrack            3A2 801
#pragma  libcall TuCBase AddTrack             3A8 9802
#pragma  libcall TuCBase RemTrack             3AE 801
#pragma  libcall TuCBase InsertTrack          3B4 A9803
#pragma  libcall TuCBase DeleteTrack          3BA 801
#pragma  libcall TuCBase ClearTrack           3C0 801
#pragma  libcall TuCBase DupTrack             3C6 801
#pragma  libcall TuCBase ReMapTrack           3CC A9803
#pragma  libcall TuCBase ReSizeTrack          3D2 0802
#pragma  libcall TuCBase AddTrackUnknownChunk 3D8 9802
#pragma  libcall TuCBase RemTrackUnknownChunk 3DE 801
#pragma  libcall TuCBase InsertTrackUnknownChunk 3E4 A9803
#pragma  libcall TuCBase GetNumTracks         3EA 801
#pragma  libcall TuCBase GetTrackNum          3F0 9802
#pragma  libcall TuCBase GetTrackAddr         3F6 0802
#pragma  libcall TuCBase GetNoteStr           3FC 210804
#pragma  libcall TuCBase GetIndexNoteStr      402 10803
#pragma  libcall TuCBase NoteToIndex          408 1002
#pragma  libcall TuCBase IndexToNote          40E 001
#pragma  libcall TuCBase GetTrackRowStr       414 210A9806
#pragma  libcall TuCBase AllocEffect          41A 1002
#pragma  libcall TuCBase FreeEffect           420 801
#pragma  libcall TuCBase AddEffect            426 09803
#pragma  libcall TuCBase RemEffect            42C 0802
#pragma  libcall TuCBase InsertEffect         432 0A9804
#pragma  libcall TuCBase DeleteEffect         438 801
#pragma  libcall TuCBase ClearEffects         43E 10803
#pragma  libcall TuCBase ReMapEffects         444 2109805
#pragma  libcall TuCBase AllocTrackData       44A 001
#pragma  libcall TuCBase FreeTrackData        450 0802
#pragma  libcall TuCBase AddRows              456 0802
#pragma  libcall TuCBase RemRows              45C 0802
#pragma  libcall TuCBase InsertRows           462 210804
#pragma  libcall TuCBase DeleteRows           468 210804
#pragma  libcall TuCBase ClearRows            46E 10803
#pragma  libcall TuCBase ReMapRows            474 2109805
#pragma  libcall TuCBase CopyRows             47A 2109805
#pragma  libcall TuCBase SwapRows             480 2109805
#pragma  libcall TuCBase PlayRow              486 109804
#pragma  libcall TuCBase CmpTracks            48C 9802
#pragma  libcall TuCBase PackTrack            492 801
#pragma  libcall TuCBase UnPackTrack          498 9802
#pragma  libcall TuCBase FreePackedTrack      49E 801
#pragma  libcall TuCBase LoadTrack            4A4 0BA9805
#pragma  libcall TuCBase SaveTrack            4AA BA9804
#pragma  libcall TuCBase IdentifyTrack        4B0 801
#pragma  libcall TuCBase GetTrackInfo         4B6 09803
#pragma  libcall TuCBase FreeTrackInfo        4BC 801
#pragma  libcall TuCBase GetTracks            4C2 9802
#pragma  libcall TuCBase PushTrack            4C8 801
#pragma  libcall TuCBase PopTrack             4CE 801
#pragma  libcall TuCBase CutTrack             4D4 9802
#pragma  libcall TuCBase CopyTrack            4DA 9802
#pragma  libcall TuCBase PasteTrack           4E0 9802
#pragma  libcall TuCBase SwapTrack            4E6 9802
#pragma  libcall TuCBase SwapTrackInSong      4EC 09803
#pragma  libcall TuCBase ShrinkTrack          4F2 0802
#pragma  libcall TuCBase ExpandTrack          4F8 0802
#pragma  libcall TuCBase HalveTrack           4FE 0802
#pragma  libcall TuCBase DoubleTrack          504 0802
#pragma  libcall TuCBase SplitTrack           50A 09803
#pragma  libcall TuCBase JoinTrack            510 9802
#pragma  libcall TuCBase PlayTrack            516 210804
#pragma  libcall TuCBase TrackNoteShift       51C 210804
#pragma  libcall TuCBase ScrollTrack          522 210804
#pragma  libcall TuCBase RotateTrack          528 210804
#pragma  libcall TuCBase FlipTrack            52E 210804
#pragma  libcall TuCBase AllocInstr           534 001
#pragma  libcall TuCBase FreeInstr            53A 801
#pragma  libcall TuCBase AddInstr             540 9802
#pragma  libcall TuCBase RemInstr             546 801
#pragma  libcall TuCBase InsertInstr          54C A9803
#pragma  libcall TuCBase DeleteInstr          552 801
#pragma  libcall TuCBase ClearInstr           558 801
#pragma  libcall TuCBase DupInstr             55E 801
#pragma  libcall TuCBase ReMapInstr           564 9802
#pragma  libcall TuCBase AddInstrUnknownChunk 56A 9802
#pragma  libcall TuCBase RemInstrUnknownChunk 570 801
#pragma  libcall TuCBase InsertInstrUnknownChunk 576 A9803
#pragma  libcall TuCBase GetNumInstrs         57C 801
#pragma  libcall TuCBase GetInstrNum          582 9802
#pragma  libcall TuCBase GetInstrAddr         588 0802
#pragma  libcall TuCBase LoadInstr            58E 0BA9805
#pragma  libcall TuCBase SaveInstr            594 BA9804
#pragma  libcall TuCBase IdentifyInstr        59A 801
#pragma  libcall TuCBase GetInstrInfo         5A0 09803
#pragma  libcall TuCBase FreeInstrInfo        5A6 801
#pragma  libcall TuCBase GetInstrs            5AC 9802
#pragma  libcall TuCBase PushInstr            5B2 801
#pragma  libcall TuCBase PopInstr             5B8 801
#pragma  libcall TuCBase CutInstr             5BE 9802
#pragma  libcall TuCBase CopyInstr            5C4 9802
#pragma  libcall TuCBase PasteInstr           5CA 9802
#pragma  libcall TuCBase SwapInstr            5D0 9802
#pragma  libcall TuCBase SwapInstrInModule    5D6 09803
#pragma  libcall TuCBase PlayInstr            5DC 2109805
#pragma  libcall TuCBase CmpInstrs            5E2 9802
#pragma  libcall TuCBase GetInstrEnvelopes    5E8 801
#pragma  libcall TuCBase FreeInstrEnvelopes   5EE 801
#pragma  libcall TuCBase AddInstrEnvelopes    5F4 0802
#pragma  libcall TuCBase GetInstrKeyboard     5FA 801
#pragma  libcall TuCBase GetInstrSamples      600 801
#pragma  libcall TuCBase FreeInstrSamples     606 801
#pragma  libcall TuCBase CreateEnvelope       60C 4321005
#pragma  libcall TuCBase FreeEnvelope         612 801
#pragma  libcall TuCBase AddEnvelope          618 9802
#pragma  libcall TuCBase RemEnvelope          61E 801
#pragma  libcall TuCBase InsertEnvelope       624 A9803
#pragma  libcall TuCBase DeleteEnvelope       62A 801
#pragma  libcall TuCBase ClearEnvelope        630 210804
#pragma  libcall TuCBase DupEnvelope          636 801
#pragma  libcall TuCBase ReMapEnvelope        63C 9802
#pragma  libcall TuCBase ReSizeEnvelope       642 0802
#pragma  libcall TuCBase ValidateEnvNodes     648 801
#pragma  libcall TuCBase AddEnvelopeUnknownChunk 64E 9802
#pragma  libcall TuCBase RemEnvelopeUnknownChunk 654 801
#pragma  libcall TuCBase InsertEnvelopeUnknownChunk 65A A9803
#pragma  libcall TuCBase GetNumEnvelopes      660 801
#pragma  libcall TuCBase GetEnvelopeNum       666 9802
#pragma  libcall TuCBase GetEnvelopeAddr      66C 0802
#pragma  libcall TuCBase SwapEnvelopeInModule 672 09803
#pragma  libcall TuCBase LoadEnvelope         678 09803
#pragma  libcall TuCBase SaveEnvelope         67E 9802
#pragma  libcall TuCBase ShrinkEnvelope       684 0802
#pragma  libcall TuCBase ExpandEnvelope       68A 0802
#pragma  libcall TuCBase HalveEnvelope        690 0802
#pragma  libcall TuCBase DoubleEnvelope       696 0802
#pragma  libcall TuCBase SplitEnvelope        69C 09803
#pragma  libcall TuCBase JoinEnvelope         6A2 9802
#pragma  libcall TuCBase ScrollEnvelope       6A8 210804
#pragma  libcall TuCBase RotateEnvelope       6AE 210804
#pragma  libcall TuCBase FlipEnvelope         6B4 210804
#pragma  libcall TuCBase AddEnvPoint          6BA 0802
#pragma  libcall TuCBase RemEnvPoint          6C0 0802
#pragma  libcall TuCBase InsertEnvPoint       6C6 210804
#pragma  libcall TuCBase DeleteEnvPoint       6CC 210804
#pragma  libcall TuCBase CmpEnvelopes         6D2 9802
#pragma  libcall TuCBase AllocKeyboard        6D8 00
#pragma  libcall TuCBase FreeKeyboard         6DE 801
#pragma  libcall TuCBase AddKeyboard          6E4 9802
#pragma  libcall TuCBase RemKeyboard          6EA 801
#pragma  libcall TuCBase InsertKeyboard       6F0 A9803
#pragma  libcall TuCBase DeleteKeyboard       6F6 801
#pragma  libcall TuCBase ClearKeyboard        6FC 801
#pragma  libcall TuCBase DupKeyboard          702 801
#pragma  libcall TuCBase ReMapKeyboard        708 9802
#pragma  libcall TuCBase GetNumKeyboards      70E 801
#pragma  libcall TuCBase GetKeyboardNum       714 9802
#pragma  libcall TuCBase GetKeyboardAddr      71A 0802
#pragma  libcall TuCBase SwapKeyboardInModule 720 09803
#pragma  libcall TuCBase SetKeyboard          726 43210806
#pragma  libcall TuCBase CheckKeyboard        72C 801
#pragma  libcall TuCBase CmpKeyboards         732 9802
#pragma  libcall TuCBase AllocArpeggio        738 001
#pragma  libcall TuCBase FreeArpeggio         73E 801
#pragma  libcall TuCBase AddArpeggio          744 9802
#pragma  libcall TuCBase RemArpeggio          74A 801
#pragma  libcall TuCBase InsertArpeggio       750 A9803
#pragma  libcall TuCBase DeleteArpeggio       756 801
#pragma  libcall TuCBase ClearArpeggio        75C 801
#pragma  libcall TuCBase DupArpeggio          762 801
#pragma  libcall TuCBase ReMapArpeggio        768 9802
#pragma  libcall TuCBase ReSizeArpeggio       76E 0802
#pragma  libcall TuCBase GetNumArpeggios      774 801
#pragma  libcall TuCBase GetArpeggioNum       77A 9802
#pragma  libcall TuCBase GetArpeggioAddr      780 0802
#pragma  libcall TuCBase SwapArpeggioInModule 786 09803
#pragma  libcall TuCBase ShrinkArpeggio       78C 0802
#pragma  libcall TuCBase ExpandArpeggio       792 0802
#pragma  libcall TuCBase HalveArpeggio        798 0802
#pragma  libcall TuCBase DoubleArpeggio       79E 0802
#pragma  libcall TuCBase SplitArpeggio        7A4 09803
#pragma  libcall TuCBase JoinArpeggio         7AA 9802
#pragma  libcall TuCBase ScrollArpeggio       7B0 210804
#pragma  libcall TuCBase RotateArpeggio       7B6 210804
#pragma  libcall TuCBase FlipArpeggio         7BC 210804
#pragma  libcall TuCBase AddArpeggioTick      7C2 0802
#pragma  libcall TuCBase RemArpeggioTick      7C8 0802
#pragma  libcall TuCBase InsertArpeggioTick   7CE 210804
#pragma  libcall TuCBase DeleteArpeggioTick   7D4 210804
#pragma  libcall TuCBase CmpArpeggios         7DA 9802
#pragma  libcall TuCBase AllocSample          7E0 0802
#pragma  libcall TuCBase FreeSample           7E6 801
#pragma  libcall TuCBase AddSample            7EC 9802
#pragma  libcall TuCBase RemSample            7F2 801
#pragma  libcall TuCBase InsertSample         7F8 A9803
#pragma  libcall TuCBase DeleteSample         7FE 801
#pragma  libcall TuCBase ClearSample          804 801
#pragma  libcall TuCBase DupSample            80A 801
#pragma  libcall TuCBase ReSizeSample         810 0802
#pragma  libcall TuCBase AddSampleUnknownChunk 816 9802
#pragma  libcall TuCBase RemSampleUnknownChunk 81C 801
#pragma  libcall TuCBase InsertSampleUnknownChunk 822 A9803
#pragma  libcall TuCBase GetNumSamples        828 801
#pragma  libcall TuCBase GetSampleNum         82E 9802
#pragma  libcall TuCBase GetSampleAddr        834 0802
#pragma  libcall TuCBase PushSample           83A 801
#pragma  libcall TuCBase PopSample            840 801
#pragma  libcall TuCBase CutSample            846 9802
#pragma  libcall TuCBase CopySample           84C 9802
#pragma  libcall TuCBase PasteSample          852 9802
#pragma  libcall TuCBase SwapSample           858 9802
#pragma  libcall TuCBase SwapSampleInInstr    85E 09803
#pragma  libcall TuCBase PlaySample           864 2109805
#pragma  libcall TuCBase LoadSample           86A 0BA9805
#pragma  libcall TuCBase SaveSample           870 BA9804
#pragma  libcall TuCBase IdentifySample       876 801
#pragma  libcall TuCBase GetSampleInfo        87C 09803
#pragma  libcall TuCBase FreeSampleInfo       882 801
#pragma  libcall TuCBase GetSamples           888 9802
#pragma  libcall TuCBase CalcSamplePlayFreq   88E 10803
#pragma  libcall TuCBase CalcFineTune         894 1002
#pragma  libcall TuCBase ConvertSampleFrequency 89A 001
#pragma  libcall TuCBase CalcLinearFrequency  8A0 1002
#pragma  libcall TuCBase AllocSampleData      8A6 001
#pragma  libcall TuCBase FreeSampleData       8AC 0802
#pragma  libcall TuCBase SetSampleData        8B2 09803
#pragma  libcall TuCBase AddSampleData        8B8 0802
#pragma  libcall TuCBase RemSampleData        8BE 0802
#pragma  libcall TuCBase InsertSampleData     8C4 10803
#pragma  libcall TuCBase DeleteSampleData     8CA 10803
#pragma  libcall TuCBase ClearSampleData      8D0 10803
#pragma  libcall TuCBase DupSampleData        8D6 801
#pragma  libcall TuCBase CutSampleData        8DC 109804
#pragma  libcall TuCBase CopySampleData       8E2 109804
#pragma  libcall TuCBase PasteSampleData      8E8 109804
#pragma  libcall TuCBase CropSampleData       8EE 109804
#pragma  libcall TuCBase LoadSampleData       8F4 09803
#pragma  libcall TuCBase SaveSampleData       8FA 109804
#pragma  libcall TuCBase ConvertBits          900 10803
#pragma  libcall TuCBase GetOptimalBits       906 0802
#pragma  libcall TuCBase ConvertSigned        90C 801
#pragma  libcall TuCBase ConvertWord          912 801
#pragma  libcall TuCBase DecrunchSample       918 0802
#pragma  libcall TuCBase Backwards            91E 10803
#pragma  libcall TuCBase MixSamples           924 2109805
#pragma  libcall TuCBase Sample               92A 3210A9807
#pragma  libcall TuCBase OctaveUp             930 801
#pragma  libcall TuCBase OctaveDown           936 801
#pragma  libcall TuCBase ReSample             93C 210804
#pragma  libcall TuCBase InvertSample         942 801
#pragma  libcall TuCBase XFadeSample          948 801
#pragma  libcall TuCBase AmplifySample        94E 3210805
#pragma  libcall TuCBase GetBiggestAmplify    954 10803
#pragma  libcall TuCBase GetLowestAmplify     95A 10803
#pragma  libcall TuCBase CreateEcho           960 801
#pragma  libcall TuCBase BoostSample          966 801
#pragma  libcall TuCBase FilterSample         96C 801
#pragma  libcall TuCBase MorphSamples         972 801
#pragma  libcall TuCBase MinimizeSample       978 801
#pragma  libcall TuCBase FindOriginSample     97E 801
#pragma  libcall TuCBase GetSampleValue       984 0802
#pragma  libcall TuCBase GetSampleValueArray  98A 109804
#pragma  libcall TuCBase CmpSamples           990 9802
#pragma  libcall TuCBase AllocSynth           996 21003
#pragma  libcall TuCBase FreeSynth            99C 801
#pragma  libcall TuCBase AssignSynth          9A2 9802
#pragma  libcall TuCBase ClearSynth           9A8 801
#pragma  libcall TuCBase DupSynth             9AE 801
#pragma  libcall TuCBase ReMapSynth           9B4 9802
#pragma  libcall TuCBase AddSynthUnknownChunk 9BA 9802
#pragma  libcall TuCBase RemSynthUnknownChunk 9C0 801
#pragma  libcall TuCBase InsertSynthUnknownChunk 9C6 A9803
#pragma  libcall TuCBase GetNumSynths         9CC 801
#pragma  libcall TuCBase GetSynthNum          9D2 9802
#pragma  libcall TuCBase GetSynthAddr         9D8 0802
#pragma  libcall TuCBase PushSynth            9DE 801
#pragma  libcall TuCBase PopSynth             9E4 801
#pragma  libcall TuCBase CutSynth             9EA 9802
#pragma  libcall TuCBase CopySynth            9F0 9802
#pragma  libcall TuCBase PasteSynth           9F6 9802
#pragma  libcall TuCBase SwapSynth            9FC 9802
#pragma  libcall TuCBase LoadSynth            A02 0BA9805
#pragma  libcall TuCBase SaveSynth            A08 BA9804
#pragma  libcall TuCBase IdentifySynth        A0E 801
#pragma  libcall TuCBase GetSynthInfo         A14 09803
#pragma  libcall TuCBase FreeSynthInfo        A1A 801
#pragma  libcall TuCBase GetSynths            A20 9802
#pragma  libcall TuCBase CmpSynths            A26 9802
#pragma  libcall TuCBase AllocWaveform        A2C 001
#pragma  libcall TuCBase FreeWaveform         A32 801
#pragma  libcall TuCBase AddWaveform          A38 9802
#pragma  libcall TuCBase RemWaveform          A3E 801
#pragma  libcall TuCBase InsertWaveform       A44 A9803
#pragma  libcall TuCBase DeleteWaveform       A4A 801
#pragma  libcall TuCBase ClearWaveform        A50 801
#pragma  libcall TuCBase DupWaveform          A56 801
#pragma  libcall TuCBase ReSizeWaveform       A5C 0802
#pragma  libcall TuCBase GetNumWaveforms      A62 801
#pragma  libcall TuCBase GetWaveformNum       A68 9802
#pragma  libcall TuCBase GetWaveformAddr      A6E 0802
#pragma  libcall TuCBase PushWaveform         A74 801
#pragma  libcall TuCBase PopWaveform          A7A 801
#pragma  libcall TuCBase CutWaveform          A80 9802
#pragma  libcall TuCBase CopyWaveform         A86 9802
#pragma  libcall TuCBase PasteWaveform        A8C 9802
#pragma  libcall TuCBase SwapWaveform         A92 9802
#pragma  libcall TuCBase SwapWaveformInSynth  A98 9802
#pragma  libcall TuCBase LoadWaveform         A9E 09803
#pragma  libcall TuCBase SaveWaveform         AA4 109804
#pragma  libcall TuCBase PlayWaveform         AAA 09803
#pragma  libcall TuCBase AddWaveformPoint     AB0 0802
#pragma  libcall TuCBase RemWaveformPoint     AB6 0802
#pragma  libcall TuCBase InsertWaveformPoint  ABC 210804
#pragma  libcall TuCBase DeleteWaveformPoint  AC2 210804
#pragma  libcall TuCBase FillWaveform         AC8 3210805
#pragma  libcall TuCBase ConvertWaveform      ACE 10803
#pragma  libcall TuCBase ConvertWaveformSigned AD4 801
#pragma  libcall TuCBase ConvertWaveformWord  ADA 801
#pragma  libcall TuCBase BackwardsWaveform    AE0 801
#pragma  libcall TuCBase MixWaveforms         AE6 9802
#pragma  libcall TuCBase HalveWaveform        AEC 801
#pragma  libcall TuCBase DoubleWaveform       AF2 801
#pragma  libcall TuCBase ScaleWaveformSize    AF8 210804
#pragma  libcall TuCBase InvertWaveform       AFE 801
#pragma  libcall TuCBase AmplifyWaveform      B04 0802
#pragma  libcall TuCBase GetMaxWaveformAmplify B0A 801
#pragma  libcall TuCBase GetMinWaveformAmplify B10 801
#pragma  libcall TuCBase CopySample2Waveform  B16 9802
#pragma  libcall TuCBase CopyWaveform2Sample  B1C 9802
#pragma  libcall TuCBase CopyEnvelope2Waveform B22 9802
#pragma  libcall TuCBase CopyWaveform2Envelope B28 9802
#pragma  libcall TuCBase TransformWaveform    B2E 9802
#pragma  libcall TuCBase CmpWaveforms         B34 9802
#pragma  libcall TuCBase AllocSynthCode       B3A 001
#pragma  libcall TuCBase FreeSynthCode        B40 0802
#pragma  libcall TuCBase AssignSynthCode      B46 09803
#pragma  libcall TuCBase ClearSynthCode       B4C 801
#pragma  libcall TuCBase DupSynthCode         B52 801
#pragma  libcall TuCBase ReSizeSynthCode      B58 0802
#pragma  libcall TuCBase PushSynthCode        B5E 801
#pragma  libcall TuCBase PopSynthCode         B64 801
#pragma  libcall TuCBase CutSynthCode         B6A 9802
#pragma  libcall TuCBase CopySynthCode        B70 9802
#pragma  libcall TuCBase PasteSynthCode       B76 9802
#pragma  libcall TuCBase SwapSynthCode        B7C 9802
#pragma  libcall TuCBase AddSynthCodeLine     B82 0802
#pragma  libcall TuCBase RemSynthCodeLine     B88 0802
#pragma  libcall TuCBase InsertSynthCodeLine  B8E 210804
#pragma  libcall TuCBase DeleteSynthCodeLine  B94 210804
#pragma  libcall TuCBase GetSynthCodeParams   B9A 001
#pragma  libcall TuCBase AssembleCodeLine     BA0 109804
#pragma  libcall TuCBase DisassembleCodeLine  BA6 109804
#pragma  libcall TuCBase AllocSymbol          BAC 801
#pragma  libcall TuCBase FreeSymbol           BB2 801
#pragma  libcall TuCBase AssignSymbol         BB8 9802
#pragma  libcall TuCBase DupSymbol            BBE 801
#pragma  libcall TuCBase AddSymbol            BC4 9802
#pragma  libcall TuCBase RemSymbol            BCA 801
#pragma  libcall TuCBase InsertSymbol         BD0 A9803
#pragma  libcall TuCBase DeleteSymbol         BD6 801
#pragma  libcall TuCBase GetNumSymbols        BDC 801
#pragma  libcall TuCBase GetSymbolNum         BE2 9802
#pragma  libcall TuCBase GetSymbolAddr        BE8 0802
#pragma  libcall TuCBase MatchSymbol          BEE 109804
#pragma  libcall TuCBase AddExternalLib       BF4 0802
#pragma  libcall TuCBase RemExternalLib       BFA 801
#pragma  libcall TuCBase OpenExternalLib      C00 801
#pragma  libcall TuCBase CloseExternalLib     C06 801
#pragma  libcall TuCBase GetExternalLibs      C0C 801
#pragma  libcall TuCBase AllocFlagStr         C12 801
#pragma  libcall TuCBase CIdentify            C18 101
#pragma  libcall TuCBase COpen                C1E 32103
#pragma  libcall TuCBase CClose               C24 101
#pragma  libcall TuCBase CRead                C2A 32103
#pragma  libcall TuCBase CWrite               C30 32103
#pragma  libcall TuCBase CSeek                C36 32103
#pragma  libcall TuCBase CGetInfo             C3C 2102
#endif

#ifdef __cplusplus
}
#endif

#endif
